package CodeGenerator;

import java.util.*;
import com.ifx.davex.appjetinteract.App2JetInterface;

public class dbg002_uartc_template
{
  protected static String nl;
  public static synchronized dbg002_uartc_template create(String lineSeparator)
  {
    nl = lineSeparator;
    dbg002_uartc_template result = new dbg002_uartc_template();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = NL + "/*CODE_BLOCK_BEGIN[DBG002_UART.c]*/" + NL + "/*******************************************************************************" + NL + " Copyright (c) 2011, Infineon Technologies AG                                 **" + NL + " All rights reserved.                                                         **" + NL + "                                                                              **" + NL + " Redistribution and use in source and binary forms, with or without           **" + NL + " modification,are permitted provided that the following conditions are met:   **" + NL + "                                                                              **" + NL + " *Redistributions of source code must retain the above copyright notice,      **" + NL + " this list of conditions and the following disclaimer.                        **" + NL + " *Redistributions in binary form must reproduce the above copyright notice,   **" + NL + " this list of conditions and the following disclaimer in the documentation    **" + NL + " and/or other materials provided with the distribution.                       **" + NL + " *Neither the name of the copyright holders nor the names of its contributors **" + NL + " may be used to endorse or promote products derived from this software without** " + NL + " specific prior written permission.                                           **" + NL + "                                                                              **" + NL + " THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\"  **" + NL + " AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE    **" + NL + " IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   **" + NL + " ARE  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE   **" + NL + " LIABLE  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR         **" + NL + " CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF         **" + NL + " SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS    **" + NL + " INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN      **" + NL + " CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)       **" + NL + " ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE   **" + NL + " POSSIBILITY OF SUCH DAMAGE.                                                  **" + NL + "                                                                              **" + NL + " To improve the quality of the software, users are encouraged to share        **" + NL + " modifications, enhancements or bug fixes with Infineon Technologies AG       **" + NL + " dave@infineon.com).                                                          **" + NL + "                                                                              **" + NL + "********************************************************************************" + NL + "**                                                                            **" + NL + "**                                                                            **" + NL + "** PLATFORM : Infineon XMC4000 Series   \t\t\t                          **" + NL + "**                                                                            **" + NL + "** COMPILER : Compiler Independent                                            **" + NL + "**                                                                            **" + NL + "** AUTHOR   : App Developer                                                   **" + NL + "**                                                                            **" + NL + "** MAY BE CHANGED BY USER [yes/no]: Yes                                       **" + NL + "**                                                                            **" + NL + "** MODIFICATION DATE : Dec 12, 2012                                           **" + NL + "**                                                                            **" + NL + "*******************************************************************************/" + NL + "/*******************************************************************************" + NL + "**                      Author(s) Identity                                    **" + NL + "********************************************************************************" + NL + "**                                                                            **" + NL + "** Initials     Name                                                          **" + NL + "** ---------------------------------------------------------------------------**" + NL + "** NPJ          App Developer                                                 **" + NL + "*******************************************************************************/";
  protected final String TEXT_2 = NL + "/**" + NL + " * @file DBG002_UART.c" + NL + " * " + NL + " * @App Version DBG002 <";
  protected final String TEXT_3 = ">" + NL + " *" + NL + " * @brief   This file provides implementation of UART read write functions.  " + NL + " *          Limitations " + NL + " *           a) Read/Write functions are non reentrant." + NL + " *           b) No support for DMA mode" + NL + " */" + NL + " " + NL + "/*******************************************************************************" + NL + " ** INCLUDE FILES                                                             **" + NL + " ******************************************************************************/" + NL + "" + NL + "#include <DAVE3.h>" + NL + "#include \"../../inc/DBG002/DBG002_UART.h\"" + NL;
  protected final String TEXT_4 = NL;
  protected final String TEXT_5 = NL + "/*******************************************************************************" + NL + "**                      Private Macro Definitions                             **" + NL + "*******************************************************************************/" + NL + "  /* System Core clock frequency in MHz */" + NL;
  protected final String TEXT_6 = "   " + NL + "#define DBG002_UARTCLOCK  ";
  protected final String TEXT_7 = NL + "#define DBG002_UARTCLOCK  ";
  protected final String TEXT_8 = NL + NL + "/*******************************************************************************" + NL + "**                 Private Function Declarations:" + NL + "*******************************************************************************/" + NL + "" + NL + "/* Initializes the App based on User provide configuration. */" + NL + "void DBG002_UARTlInit (const DBG002_UARTHandleType* Handle);" + NL + "" + NL + "/*******************************************************************************" + NL + "**                      Global Constant Definitions                           **" + NL + "*******************************************************************************/" + NL + "" + NL + "/*******************************************************************************" + NL + "**                      Private Function Definitions                          **" + NL + "*******************************************************************************/" + NL + "/* Initializes the App based on User provide configuration. */" + NL;
  protected final String TEXT_9 = NL + " " + NL + "void DBG002_UARTlInit (const DBG002_UARTHandleType* Handle)" + NL + "{" + NL + "  USIC_CH_TypeDef* UartRegs = Handle->UartRegs;" + NL + "" + NL + "  " + NL + " /* <<<DD_DBG002_UARTAPI_1>>>*/" + NL + " " + NL + "  /** UART initialization  */" + NL + "  ";
  protected final String TEXT_10 = NL + "  SET_BIT(SCU_CLK->CGATCLR0, SCU_CLK_CGATCLR0_USIC0_Pos);" + NL + "" + NL + "  RESET001_DeassertReset(PER0_USIC0);";
  protected final String TEXT_11 = NL + "  ";
  protected final String TEXT_12 = NL + "\t// Disable clock gating to USIC0" + NL + "\tSCU_GENERAL->PASSWD = 0x000000C0UL; // disable bit protection" + NL + "\tSCU_CLK->CGATCLR0 |= SCU_CLK_CGATCLR0_USIC0_Msk;" + NL + "\tSCU_GENERAL->PASSWD = 0x000000C3UL; // enable bit protection";
  protected final String TEXT_13 = NL + "  " + NL + "  " + NL + "  /* Enable the USIC Channel */" + NL + "  UartRegs->KSCFG |= (((uint32_t)( 0x01UL  & USIC_CH_KSCFG_MODEN_Msk)) | \\" + NL + "  ((uint32_t)(0x01UL   << USIC_CH_KSCFG_BPMODEN_Pos) &  (uint32_t)USIC_CH_KSCFG_BPMODEN_Msk));" + NL + "  " + NL + "  /* Configuration of USIC Channel Fractional Divider */" + NL + "" + NL + "  /* Fractional divider mode selected */" + NL + "  UartRegs->FDR |= ((uint32_t)( 2UL << USIC_CH_FDR_DM_Pos) \\" + NL + "                    & (uint32_t)USIC_CH_FDR_DM_Msk);" + NL + "  " + NL + "  /* Step value */" + NL + "  UartRegs->FDR |= ((Handle->BGR_STEP) & (uint32_t)USIC_CH_FDR_STEP_Msk);" + NL + "          " + NL + "  /* The PreDivider for CTQ, PCTQ = 0  */" + NL + "  /* The Denominator for CTQ, DCTQ = 16 */" + NL + "    " + NL + "  UartRegs->BRG |= \\" + NL + "\t  ((((uint32_t)(Handle->BGR_PCTQ) << USIC_CH_BRG_PCTQ_Pos) & \\" + NL + "\t\t  \t     USIC_CH_BRG_PCTQ_Msk) | \\" + NL + "      (((uint32_t)(Handle->BGR_DCTQ) << USIC_CH_BRG_DCTQ_Pos) & \\" + NL + "\t     USIC_CH_BRG_DCTQ_Msk) | \\" + NL + "      (((uint32_t)(Handle->BGR_PDIV) << USIC_CH_BRG_PDIV_Pos) &  \\" + NL + "\t     USIC_CH_BRG_PDIV_Msk));" + NL + " " + NL + "  /* Configuration of USIC Shift Control */" + NL + "  " + NL + "  /* Transmit/Receive LSB first is selected  */" + NL + "  /* Transmission Mode (TRM) = 1  */" + NL + "  /* Passive Data Level (PDL) = 1 */" + NL + "  UartRegs->SCTR |= (((uint32_t)(0x01UL  << USIC_CH_SCTR_PDL_Pos) & \\" + NL + "\t\t  (uint32_t)USIC_CH_SCTR_PDL_Msk ) | \\" + NL + "    ((uint32_t)(0x01UL  <<  USIC_CH_SCTR_TRM_Pos ) &   (uint32_t)USIC_CH_SCTR_TRM_Msk ));" + NL + "  /* Set Word Length (WLE) & Frame Length (FLE) */" + NL + "  UartRegs->SCTR |= (((uint32_t)((uint32_t)Handle->DataBits  << USIC_CH_SCTR_FLE_Pos) & \\" + NL + "\t\t  (uint32_t)USIC_CH_SCTR_FLE_Msk ) | \\" + NL + "  ((uint32_t)((uint32_t)Handle->DataBits  << USIC_CH_SCTR_WLE_Pos) &  (uint32_t)USIC_CH_SCTR_WLE_Msk));" + NL + "" + NL + "       " + NL + "  /* Configuration of USIC Transmit Control/Status Register */ " + NL + "  /* TBUF Data Enable (TDEN) = 1 */" + NL + "  /* TBUF Data Single Shot Mode (TDSSM) = 1 */" + NL + "\t" + NL + "  UartRegs->TCSR |= (((uint32_t)(0x01UL  << USIC_CH_TCSR_TDEN_Pos) & \\" + NL + "\t\t  (uint32_t)USIC_CH_TCSR_TDEN_Msk ) | \\" + NL + "    ((uint32_t)(0x01UL  << USIC_CH_TCSR_TDSSM_Pos) & (uint32_t)USIC_CH_TCSR_TDSSM_Msk));" + NL + "" + NL + "  /* Configuration of Protocol Control Register */ " + NL + "  /* Sample Mode (SMD) = 1 */" + NL + "  /* 1 Stop bit is selected */   " + NL + "  /* Sample Point (SP) = 2 */" + NL + "  /* Pulse Length (PL) = 0 */" + NL + "  " + NL + "  UartRegs->PCR_ASCMode |= (((uint32_t)(0x01UL  & USIC_CH_PCR_ASCMode_SMD_Msk)) | \\" + NL + "    ((uint32_t)((uint32_t)Handle->StopBit  << USIC_CH_PCR_ASCMode_STPB_Pos) & \\" + NL + "    \t\t(uint32_t)USIC_CH_PCR_ASCMode_STPB_Msk) | \\" + NL + "    ((uint32_t)((uint32_t)(Handle->BGR_SP)  << USIC_CH_PCR_ASCMode_SP_Pos) & \\" + NL + "    \t\t(uint32_t)USIC_CH_PCR_ASCMode_SP_Msk) | \\" + NL + "    ((uint32_t)(0x01UL  << USIC_CH_PCR_ASCMode_RSTEN_Pos) & \\" + NL + "    \t\t(uint32_t)USIC_CH_PCR_ASCMode_RSTEN_Msk) | \\" + NL + "    \t\t((uint32_t)(0x00UL  << USIC_CH_PCR_ASCMode_IDM_Pos) & \\" + NL + "    \t\t\t\t(uint32_t)USIC_CH_PCR_ASCMode_IDM_Msk));" + NL + "  " + NL + "  /* Configuration of Protocol Status Register */ " + NL + "  /* TBIF is set to simplify polling*/" + NL + "  UartRegs->PSR_ASCMode |= ((uint32_t)(0x01UL  << USIC_CH_PSR_TBIF_Pos) & \\" + NL + "\t\t  (uint32_t)USIC_CH_PSR_TBIF_Msk);" + NL + "\t\t                    " + NL + "  /* Configuration of Transmitter Buffer Control Register */ " + NL + "    UartRegs->TBCTR &= ~(USIC_CH_TBCTR_LOF_Msk | USIC_CH_TBCTR_LIMIT_Msk);" + NL + "    UartRegs->TBCTR |= ((uint32_t)Handle->TxLimit << USIC_CH_TBCTR_LIMIT_Pos);" + NL + "" + NL + "  /* Configuration of Receiver Buffer Control Register */ " + NL + "    UartRegs->RBCTR &= ~(USIC_CH_RBCTR_LOF_Msk | USIC_CH_RBCTR_LIMIT_Msk);" + NL + "    UartRegs->RBCTR |= ((uint32_t)Handle->RxLimit << USIC_CH_RBCTR_LIMIT_Pos) " + NL + "                    |  (USIC_CH_RBCTR_LOF_Msk);                     " + NL + "   " + NL + "  /* Configuration of Channel Control Register */ " + NL + "  /* parity generation is disabled*/" + NL + "    UartRegs->CCR |= ( ((uint32_t)(UART_MODE  & USIC_CH_CCR_MODE_Msk)) | \\" + NL + "    (((uint32_t)Handle->Parity  << USIC_CH_CCR_PM_Pos) & \\" + NL + "    (uint32_t)USIC_CH_CCR_PM_Msk));" + NL + "}" + NL + "" + NL + "/*******************************************************************************" + NL + "**                      Public Function Definitions                           **" + NL + "*******************************************************************************/" + NL + "void DBG002_UARTInit(void)" + NL + "{" + NL + "/* Reset the Peripheral*/";
  protected final String TEXT_14 = NL + "  RESET001_DeassertReset(PER0_USIC";
  protected final String TEXT_15 = ");";
  protected final String TEXT_16 = NL + "  /* Reset the Peripheral*/";
  protected final String TEXT_17 = NL + "  RESET001_DeassertReset(PER1_USIC";
  protected final String TEXT_18 = "); ";
  protected final String TEXT_19 = " ";
  protected final String TEXT_20 = NL + "  DBG002_UARTlInit(&DBG002_UARTHandle0);";
  protected final String TEXT_21 = NL + "// CHANNEL IS NOT MAPPED";
  protected final String TEXT_22 = NL + "}" + NL + "" + NL + "" + NL + "" + NL + "/*CODE_BLOCK_END*/" + NL + NL;
  protected final String TEXT_23 = NL;

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
     App2JetInterface app = (App2JetInterface) argument; 
    stringBuffer.append(TEXT_1);
    
	String Baseuri = "app/dbg002/"; 
	int appInst = 0;
	String MappedUri = null;

    stringBuffer.append(TEXT_2);
    stringBuffer.append(app.getAppVersion(Baseuri) );
    stringBuffer.append(TEXT_3);
     int Is44Device = -1; 
     int Is42Device = -1; 
     int Is45Device = -1; 
     Is44Device = ((app.getSoftwareId().substring(0,2).compareTo("44")==0)?1:0); 
     Is42Device = ((app.getSoftwareId().substring(0,2).compareTo("42")==0)?1:0); 
     Is45Device = ((app.getSoftwareId().substring(0,2).compareTo("45")==0)?1:0); 
    stringBuffer.append(TEXT_4);
     String UnitInst = null; 
    stringBuffer.append(TEXT_5);
    if ((Is44Device==1) || (Is42Device==1) || (Is45Device == 1)) {
    stringBuffer.append(TEXT_6);
    stringBuffer.append( app.getIntegerValue (Baseuri + appInst + "/clkapp/clk001_iroActualFreqPB" ));
     } else { 
    stringBuffer.append(TEXT_7);
    stringBuffer.append( app.getIntegerValue (Baseuri + appInst + "/clkapp/clk002_irMCLK" ));
     } 
    stringBuffer.append(TEXT_8);
     int is44dev = -1; 
     int is42dev = -1; 
     is44dev = ((app.getSoftwareId().substring(0,2).compareTo("44")==0)?1:0); 
     is42dev = ((app.getSoftwareId().substring(0,2).compareTo("42")==0)?1:0); 
    stringBuffer.append(TEXT_9);
    if ((is44dev==1) || (is42dev==1)) {
    stringBuffer.append(TEXT_10);
    }
    stringBuffer.append(TEXT_11);
    if ((Is44Device!=1) && (Is42Device!=1) && (Is45Device != 1)) {
    stringBuffer.append(TEXT_12);
    }
    stringBuffer.append(TEXT_13);
     MappedUri = app.getMappedUri(Baseuri + appInst + "/channel"); 
     if((MappedUri != null) && (MappedUri != "")) { 
 UnitInst = MappedUri.substring(MappedUri .length()-11,MappedUri.indexOf("/channel/")); 
 int Unit = Integer.parseInt(UnitInst); 
     if(Unit == 0)  { 
    if ((Is44Device==1) || (Is42Device==1) || (Is45Device == 1)) {
    stringBuffer.append(TEXT_14);
    stringBuffer.append(UnitInst);
    stringBuffer.append(TEXT_15);
     } 
     } else { 
    stringBuffer.append(TEXT_16);
    if ((Is44Device==1) || (Is42Device==1) || (Is45Device == 1)) {
    stringBuffer.append(TEXT_17);
    stringBuffer.append(UnitInst);
    stringBuffer.append(TEXT_18);
     } 
    stringBuffer.append(TEXT_19);
     } 
    stringBuffer.append(TEXT_20);
     } 
     else { 
    stringBuffer.append(TEXT_21);
     } 
    stringBuffer.append(TEXT_22);
    stringBuffer.append(TEXT_23);
    return stringBuffer.toString();
  }
}
