/*******************************************************************************
**  DAVE App Name : ADC002       App Version: 1.0.28               
**  This file is generated by DAVE, User modification to this file will be    **
**  overwritten at the next code generation.                                  **
*******************************************************************************/

/*CODE_BLOCK_BEGIN[ADC002_Conf.h]*/

/******************************************************************************
 *
 * Copyright (C) 2013 Infineon Technologies AG. All rights reserved.
 *
 * Infineon Technologies AG (Infineon) is supplying this software for use with
 * Infineon's microcontrollers.
 * This file can be freely distributed within development tools that are
 * supporting such microcontrollers.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * INFINEON SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,
 * OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
********************************************************************************
**                                                                            **
**                                                                            **
** PLATFORM : Infineon XMC4000/XMC1000 Series                                 **
**                                                                            **
** COMPILER : Compiler Independent                                            **
**                                                                            **
** AUTHOR   : DAVE App Developer                                              **
**                                                                            **
** MAY BE CHANGED BY USER [yes/no]: Yes                                       **
**                                                                            **
** MODIFICATION DATE : Oct 31, 2013                                           **
**                                                                            **
*******************************************************************************/

/*******************************************************************************
**                       Author(s) Identity                                   **
********************************************************************************
**                                                                            **
** Initials     Name                                                          **
** ---------------------------------------------------------------------------**
** KM           DAVE App Developer                                            **
*******************************************************************************/

/**
 * @file  ADC002_Conf.h
 *
 * @brief This file contains App parameter data as per GUI configurations
 *
 * Change History:
 *
 * Date       version       Details
 * 12-Dec-2012   1.0.6    Initial code added for XMC1000
 * 30-Jan-2013   1.0.8    App version changed
 * 24-Apr-2013   1.0.12   Ported to XMC4500 step AB
 *                        Source Result selection Feature added
 * 10-Jun-2013   1.0.14   1. Integer Parameter updated in manifest to support
 *                           PMSMFOCSL01 app. 
 *                        2. In the Header comment section device name changed
 *                           to XMC1000
 *                        3. Source Result register selection feature disabled
 *                           due to header file update not available.
 * 27-Jun-2013   1.0.16   Source Result register selection feature removed to
 *                        simplify the app.       
 * 10-Sep-2013   1.0.18   1. Arbitration slot enable(ASEN) code is moved to the
 *                         end of ADC002_lInit function. 
 *                        2. Added support for the following devices under 
 *                         XMC1200 and XMC1300 Series XMC1201, XMC1202, XMC1301.
 * 27-Sep-2013   1.0.20   ADC002_InitializeQueue api issue - the queue is not 
 *                        created if interrupt is enabled is fixed.
 * 31-Oct-2013   1.0.22   '10 bit Fast compare mode' is made invisible in GUI for
 *                        standard conversion mode.         
 */
#ifndef ADC002_H_
#define ADC002_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <DAVE3.h>




extern const ADC002_HandleType ADC002_Handle0;

#ifdef __cplusplus
}
#endif
  
#endif /* ADC002_H_ */

/**
 * @}
 */
 
/*CODE_BLOCK_END*/

