/*******************************************************************************
**  DAVE App Name : DBG002       App Version: 1.0.22               
**  This file is generated by DAVE, User modification to this file will be    **
**  overwritten at the next code generation.                                  **
*******************************************************************************/


/*******************************************************************************
 *
 * Copyright (C) 2011 Infineon Technologies AG. All rights reserved.
 *
 * Infineon Technologies AG (Infineon) is supplying this software for use with
 * Infineon's microcontrollers.
 * This file can be freely distributed within development tools that are
 * supporting such microcontrollers.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * INFINEON SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,
 * OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
********************************************************************************
**                                                                            **
**                                                                            **
** PLATFORM : Infineon XMC4000 Series                                         **
**                                                                            **
** COMPILER : Compiler Independent                                            **
**                                                                            **
** AUTHOR : App Developer                                                     **
**                                                                            **
** MAY BE CHANGED BY USER [yes/no]: Yes                                       **
**                                                                            **
** MODIFICATION DATE : Jan 22, 2014                                           **
**                                                                            **
*******************************************************************************/

/*******************************************************************************
**                       Author(s) Identity                                   **
********************************************************************************
**                                                                            **
** Initials    Name                                                           **
** ---------------------------------------------------------------------------**
** NPJ          App Developer                                                  **
*******************************************************************************/
/**
 * @file DBG002.h
 *
 * @App Version DBG002 <1.0.22>
 * @brief  This file contains all public data structures,enums and function
 *         prototypes for Debug Log App.
 *
 */
 #ifndef _DBG002_H_
 #define _DBG002_H_
 
#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
**                                  File Include                              **
*******************************************************************************/


#include <DAVE3.h>
#include "../../inc/DBG002/DBG002_Conf.h"
#include "../DBG002/DBG002_Xspy.h"
/* Inclusion of definitions about Invariant Checking */
#include "../../inc/DBG002/Nana/nana.h"

/*******************************************************************************
**                      Global Definitions                                    **
*******************************************************************************/

#define DBG002_VERSION "1.0.22"

/*******************************************************************************
**                      Global Macro Definitions                              **
*******************************************************************************/

#define SIZE_FLOAT         sizeof (float)
#define SIZE_UINT8         sizeof (uint8_t)
#define SIZE_UINT16        sizeof (uint16_t)
#define SIZE_UINT32        sizeof (uint32_t)
#define SIZE_UINT64        sizeof (uint64_t)
#define SIZE_INT8          sizeof (int8_t)
#define SIZE_INT16         sizeof (int16_t)
#define SIZE_INT32         sizeof (int32_t)
#define SIZE_INT64         sizeof (int64_t)
#define SIZE_DOUBLE        sizeof (double)

/**
 * @ingroup DBG002_apidoc
 * @{
 */

/** Add a floating point value to the variable table.
    You must specify a scale parameter. */
#define XSPY_ADD_SCALED_FLOAT(str, var, scale)\
	{str":"#scale":Float:", SIZE_FLOAT, (uint32_t)&var}

/** Add a uint8_t value to the variable table.
    You must specify a scale parameter. */
#define XSPY_ADD_SCALED_UINT8(str, var, scale)\
	{str":"#scale":Uint8:", SIZE_UINT8, (uint32_t)&var}

/** Add a uint16_t value to the variable table.
    You must specify a scale parameter. */
#define XSPY_ADD_SCALED_UINT16(str, var, scale)\
	{str":"#scale":Uint16:", SIZE_UINT16, (uint32_t)&var}

/** Add a uint32_t value to the variable table.
    You must specify a scale parameter. */
#define XSPY_ADD_SCALED_UINT32(str, var, scale)\
	{str":"#scale":Uint32:", SIZE_UINT32, (uint32_t)&var}

/** Add a uint64_t value to the variable table.
    You must specify a scale parameter. */
#define XSPY_ADD_SCALED_UINT64(str, var, scale)\
	{str":"#scale":Uint64:", SIZE_UINT64, (uint32_t)&var}

/** Add a int8_t value to the variable table.
    You must specify a scale parameter. */
#define XSPY_ADD_SCALED_INT8(str, var, scale)\
	{str":"#scale":Int8:", SIZE_INT8, (uint32_t)&var}

/** Add a int16_t value to the variable table.
    You must specify a scale parameter. */
#define XSPY_ADD_SCALED_INT16(str, var, scale)\
	{str":"#scale":Int16:", SIZE_INT16, (uint32_t)&var}

/** Add a int32_t value to the variable table.
    You must specify a scale parameter. */
#define XSPY_ADD_SCALED_INT32(str, var, scale)\
	{str":"#scale":Int32:", SIZE_INT32, (uint32_t)&var}

/** Add a int64_t value to the variable table.
    You must specify a scale parameter. */
#define XSPY_ADD_SCALED_INT64(str, var, scale)\
	{str":"#scale":Int64:", SIZE_INT64, (uint32_t)&var}

/** Add a double type value to the variable table.
    You must specify a scale parameter. */
#define XSPY_ADD_SCALED_DOUBLE(str, var, scale)\
	{str":"#scale":Double:", SIZE_DOUBLE, (uint32_t)&var}

/** Add a floating point value to the variable table. */
#define XSPY_ADD_FLOAT(str, var)\
	{str":1.0:Float:", SIZE_FLOAT, (uint32_t)&var}

/** Add a uint8_t value to the variable table. */
#define XSPY_ADD_UINT8(str, var)\
	{str":1.0:Uint8:", SIZE_UINT8, (uint32_t)&var}

/** Add a uint16_t value to the variable table. */
#define XSPY_ADD_UINT16(str, var)\
	{str":1.0:Uint16:", SIZE_UINT16, (uint32_t)&var}

/** Add a uint32_t value to the variable table. */
#define XSPY_ADD_UINT32(str, var)\
	{str":1.0:Uint32:", SIZE_UINT32, (uint32_t)&var}

/** Add a uint64_t value to the variable table. */
#define XSPY_ADD_UINT64(str, var)\
	{str":1.0:Uint64:", SIZE_UINT64, (uint32_t)&var}

/** Add a int8_t value to the variable table. */
#define XSPY_ADD_INT8(str, var)\
	{str":1.0:Int8:", SIZE_INT8, (uint32_t)&var}

/** Add a int16_t value to the variable table. */
#define XSPY_ADD_INT16(str, var)\
	{str":1.0:Int16:", SIZE_INT16, (uint32_t)&var}

/** Add a int32_t value to the variable table. */
#define XSPY_ADD_INT32(str, var)\
	{str":1.0:Int32:", SIZE_INT32, (uint32_t)&var}

/** Add a int64_t value to the variable table. */
#define XSPY_ADD_INT64(str, var)\
	{str":1.0:Int64:", SIZE_INT64, (uint32_t)&var}

/** Add a double type value to the variable table. */
#define XSPY_ADD_DOUBLE(str, var)\
	{str":1.0:Double:", SIZE_DOUBLE, (uint32_t)&var}	

/**
 * @}
 */

/**
 * @ingroup DBG002_publicparam
 * @{
 */
/** Macro for Logging function start */
#define DBG002_FUNCTION_ENTRY(GID, Status) \
        DBG002_TRACE(GID, Status, sizeof(__FUNCTION__), __FUNCTION__)

/** Macro for logging function stop */
#define DBG002_FUNCTION_EXIT(GID, Status) \
       DBG002_TRACE(GID, Status, sizeof(__FUNCTION__), __FUNCTION__)      

#define DBG002_GID                  0U               

/** Enumeration for Severity Type - LEVEL NOT SET */
#define DBG002_LEVEL_NOTSET           0xFF
/** Enumeration for Severity Type - SET TO TRACE */
#define DBG002_LEVEL_TRACE            0
/** Enumeration for Severity Type - SET TO INFO */
#define DBG002_LEVEL_INFO             1
/** Enumeration for Severity Type - SET TO WARNING */
#define DBG002_LEVEL_WARNING          2
/** Enumeration for Severity Type - SET TO ERROR */
#define DBG002_LEVEL_ERROR            3
/** Enumeration for Severity Type - SET TO CRITICAL */
#define DBG002_LEVEL_CRITICAL         4
/** Enumeration for Severity Type - SET TO SAFETY CRITICAL */
#define DBG002_LEVEL_SAFETY_CRITICAL  5

/*******************************************************************************
**                      Global Type Definitions                               **
*******************************************************************************/     
/** Group ID of Apps present in the project*/
typedef enum DBG002_GroupIDType
{
  /*
   * GID's reserved for application specific
   * code and variables.
   */
 DBG002_GID_XSPY1 = 1,
 DBG002_GID_XSPY2 = 2,
 DBG002_GID_XSPY3 = 3,
 DBG002_GID_XSPY4 = 4,
  
  /*
   * GID's reserved for messages from user
   * code.
   */
 DBG002_GID_USER1 = 5,
 DBG002_GID_USER2 = 6,
     
 /* GID for MOTORLIBS App */
 DBG002_GID_MOTORLIBS = 32,
 /* GID for MATHLIBS App */
 DBG002_GID_MATHLIBS = 249,
 /* GID for CLK002 App */
 DBG002_GID_CLK002 = 173,
 /* GID for IO002 App */
 DBG002_GID_IO002 = 86,
 /* GID for CCU8GLOBAL App */
 DBG002_GID_CCU8GLOBAL = 132,
 /* GID for IO004 App */
 DBG002_GID_IO004 = 222,
 /* GID for PWMSVM01 App */
 DBG002_GID_PWMSVM01 = 207,
 /* GID for ADCGLOB001 App */
 DBG002_GID_ADCGLOB001 = 79,
 /* GID for ADCGROUP001 App */
 DBG002_GID_ADCGROUP001 = 112,
 /* GID for IO001 App */
 DBG002_GID_IO001 = 26,
 /* GID for ADCCH001 App */
 DBG002_GID_ADCCH001 = 60,
 /* GID for ADC002 App */
 DBG002_GID_ADC002 = 254,
 /* GID for PMSMFOCSL01 App */
 DBG002_GID_PMSMFOCSL01 = 33,
}DBG002_GroupIDType;

/**
 * @brief Typedef for the Callback
 */ 
typedef status_t (*DBG002_CmdCallback)(void*, uint32_t,DBG002_XSpyDataType*);


/**
 * @brief Enumeration for Error Codes
 */
typedef enum DBG002_ErrorType
{
  /** Failure */
  DBG002_ERR = 1,
  /** DebugLog MessageID for PBC */
  DBG002_PBC,
  /** DebugLog MessageID for invalid parameter */
  DBG002_INVALID_PARAMETER,
  /** DebugLog invalid set command */
  DBG002_SETLOCATION_FAILED,
  /** DebugLog invalid set command */
   DBG002_GETLOCATION_FAILED,
  /** DebugLog XSPY MessageID for invalid XSPY set stream command */
  DBG002_SETSTREAMCOMMAND_FAILED,
  /** DebugLog XSPY MessageID for invalid XSPY set sync command */
  DBG002_SETSYNCCOMMAND_FAILED,
  /** Get variable command failed */
  DBG002_GETVARCOMMAND_FAILED,
  /** Get groupid command failed */
  DBG002_GETGROUPID_FAILED,
 /*DEBUGLOG Transport busy*/
  DBG002_TRANSPORT_BUSY,
  /* XSPY command buffer empty*/
  DBG002_NO_COMMAND_RECEIVED
} DBG002_ErrorType;

/**
 * @brief Enumeration for MessageID
 */
typedef enum DBG002_MessageIdType
{
	DBG002_MESSAGEID_XSPY = 0xFF,
	DBG002_MESSAGEID_PBC = 0xFC,
	DBG002_MESSAGEID_LITERAL = 0xFB
} DBG002_MessageIdType;

/**
 * @brief Enumeration for type of Physical Interface
 */
typedef enum DBG002_PhyicalInterfaceType
{
  /** UART */
  DBG002_UART,
  /** Simple Controller Area Network */
  DBG002_SIMPLE_CAN,
  /** Ethernet */
  DBG002_ETHERNET,
  /** File System */
  DBG002_FILESYSTEM
} DBG002_PhyicalInterfaceType;



/**
 * @brief Enumeration for Assert Options
 */
typedef enum DBG002_AssertOptionType
{
  DBG002_ABORT_INSTRUCTION,
  /** Stop the working */
  DBG002_BREAK_INSTRUCTION,
  /** sends the debug message to host */
  DBG002_SENDTO_DEBUGLOG
} DBG002_AssertOptionType;


/***
 * @brief Data structure which defines App parameters 
 */
typedef struct DBG002_AppInfoType
{
	/** App group ID*/
	uint8_t GroupID;
	/** App name */
	uint8_t AppName[20];
}DBG002_AppInfoType;

/**
 * @brief Function pointer for the Physical Interface Init Function
 */
typedef void (*DBG002_PhyInterfaceInitFuncPtr)(void*);

/**
 * @brief Function pointer for the Physical Interface Write Function
 */
typedef status_t (*DBG002_PhyInterfaceWriteFuncPtr)(void*,uint32_t,uint8_t*);


/**
 * @brief GUI configurable elements for every channel
 */
typedef struct DBG002_GUIConfigurableType
{
  /** gid for dynamic filtering */
  uint32_t                          DynamicFilterMacroGroupID[8];
  /** severity level for dynamic filter */
  uint8_t                          RunTimeDynamicFilterSeverity;
  /** circular buffer size */
  uint8_t                           CircularBufferSize;
  /** physical channel */
  DBG002_PhyicalInterfaceType     PhysicalChannel;
  /** Physical Interface Handle */
  handle_t                          PeripheralHandle;
  /** Pointer to the physical Interface Init function */
  DBG002_PhyInterfaceInitFuncPtr           PhysicalInterfaceInit;
  /** Pointer to the Physical Interface Write function */
  DBG002_PhyInterfaceWriteFuncPtr          PhysicalInterfaceWrite;
} DBG002_GUIConfigurableType;

/**
 * @}
 */

/*******************************************************************************
**                          FUNCTION PROTOTYPES                               **
*******************************************************************************/


/** @ingroup DBG002_apidoc
 * @{
 */

/**
 * @brief Initializes the debug log app's global data structures and registers
 * debug log app callback function.
 *
 *
 * @return None
 * 
 * <b>Reentrant: yes</b><BR>
 * <b>Sync/Async:  Synchronous</b>
 * <BR><P ALIGN="LEFT"><B>Example:</B>
 * @code 
 * #include<DAVE3.h>
 * int main()
 * {
 * 	DAVE_Init();//DBG002_Init() will be called inside DAVE_Init()
 * 	while(1)
 * 	{
 * 	}
 * }
 * @endcode<BR> </p> 
 */
void DBG002_Init(void);
/**
 * @}
 */



status_t DBG002_RegisterCallBack
(
  uint8_t groupid,
  DBG002_CmdCallback Callback,
  DBG002_XSpyDataType* XspyDataPtr
);



void DBG002_Flush(void);


/**
 * @brief       This API is mapped to the MACROS. The first parameter is
 *              appended by the macro.
 *
 * @param[in]   Severity_Level  Severity level of the MEssage
 * @param[in]   GroupID        Application ID
 * @param[in]   MessageID      Message / Error ID
 * @param[in]   Length         Length of the Message
 * @param[in]   Message        Pointer to the Message
 *
 * @return     None
 * <b>Reentrant: yes</b><BR>
 * <b>Sync/Async:  Synchronous</b>
 *
 */
void DBG002_Logging
(
  uint32_t Severity_Level,
  uint8_t GroupID,
  uint8_t MessageID,
  uint8_t Length,
  uint8_t* Message
);


/** @ingroup DBG002_apidoc
 * @{
 */

/* Compile time Filtering MACROS */
#if (DBG002_COMPILE_FILTER_TYPE == DBG002_LEVEL_TRACE)
/**
 * @brief Log message with severity level set to safety critical.
 *
 * @param[in]   GroupID        Application ID
 * @param[in]   MessageID      Message / Error ID
 * @param[in]   Length         Length of the Message
 * @param[in]   Message        Pointer to the Message
 *
 */
  #define DBG002_SAFETY_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_SAFETY_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/**
 * @brief Log message with severity level set to critical.
 *
 * @param[in]   GroupID        Application ID
 * @param[in]   MessageID      Message / Error ID
 * @param[in]   Length         Length of the Message
 * @param[in]   Message        Pointer to the Message
 *
 */
  #define DBG002_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/**
 * @brief Log message with severity level set to error.
 *
 * @param[in]   GroupID        Application ID
 * @param[in]   MessageID      Message / Error ID
 * @param[in]   Length         Length of the Message
 * @param[in]   Message        Pointer to the Message
 *
 */
  #define DBG002_ERROR(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_ERROR,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/**
 * @brief Log message with severity level set to warning.
 *
 * @param[in]   GroupID        Application ID
 * @param[in]   MessageID      Message / Error ID
 * @param[in]   Length         Length of the Message
 * @param[in]   Message        Pointer to the Message
 *
 */
  #define DBG002_WARNING(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_WARNING,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/**
 * @brief Log message with severity level set to info.
 *
 * @param[in]   GroupID        Application ID
 * @param[in]   MessageID      Message / Error ID
 * @param[in]   Length         Length of the Message
 * @param[in]   Message        Pointer to the Message
 *
 */
  #define DBG002_INFO(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_INFO,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/**
 * @brief Log message with severity level set to trace.
 *
 * @param[in]   GroupID        Application ID
 * @param[in]   MessageID      Message / Error ID
 * @param[in]   Length         Length of the Message
 * @param[in]   Message        Pointer to the Message
 *
 */
  #define DBG002_TRACE(groupid,messageid,length,value)\
        DBG002_Logging(DBG002_LEVEL_TRACE,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/**
 * @brief Flush the Debug log buffer contents.
 *
 */
#define DBG002_FLUSH()   DBG002_Flush();
#elif (DBG002_COMPILE_FILTER_TYPE == DBG002_LEVEL_INFO)
/** */
  #define DBG002_SAFETY_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_SAFETY_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_ERROR(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_ERROR,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_WARNING(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_WARNING,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_INFO(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_INFO,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_TRACE(groupid,messageid,length,value)\
        /** NULL */
  #define DBG002_FLUSH()   DBG002_Flush();

#elif (DBG002_COMPILE_FILTER_TYPE == DBG002_LEVEL_WARNING)
/** */
  #define DBG002_SAFETY_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_SAFETY_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */ 
  #define DBG002_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_ERROR(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_ERROR,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_WARNING(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_WARNING,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_INFO(groupid,messageid,length,value) \
        /** NULL */
/** */
  #define DBG002_TRACE(groupid,messageid,length,value)\
        /** NULL */
  #define DBG002_FLUSH()   DBG002_Flush();

#elif (DBG002_COMPILE_FILTER_TYPE == DBG002_LEVEL_ERROR)
/** */
  #define DBG002_SAFETY_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_SAFETY_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_ERROR(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_ERROR,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_WARNING(groupid,messageid,length,value) \
        /** NULL */
/** */
  #define DBG002_INFO(groupid,messageid,length,value) \
        /** NULL */
/** */
  #define DBG002_TRACE(groupid,messageid,length,value)\
        /** NULL */
  #define DBG002_FLUSH()   DBG002_Flush();

#elif (DBG002_COMPILE_FILTER_TYPE == DBG002_LEVEL_CRITICAL)
/** */
  #define DBG002_SAFETY_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_SAFETY_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_ERROR(groupid,messageid,length,value) \
        /** NULL */
/** */
  #define DBG002_WARNING(groupid,messageid,length,value) \
        /** NULL */
/** */
  #define DBG002_INFO(groupid,messageid,length,value) \
        /** NULL */
/** */
  #define DBG002_TRACE(groupid,messageid,length,value)\
        /** NULL */
#define DBG002_FLUSH()   DBG002_Flush();

#elif (DBG002_COMPILE_FILTER_TYPE == DBG002_LEVEL_SAFETY_CRITICAL)
/** */
  #define DBG002_SAFETY_CRITICAL(groupid,messageid,length,value) \
        DBG002_Logging(DBG002_LEVEL_SAFETY_CRITICAL,(uint8_t)groupid,\
                         (uint8_t)messageid, (uint8_t)length,(uint8_t*)value);
/** */
  #define DBG002_CRITICAL(groupid,messageid,length,value) \
        /** NULL */
/** */
  #define DBG002_ERROR(groupid,messageid,length,value) \
        /** NULL */
/** */
  #define DBG002_WARNING(groupid,messageid,length,value) \
        /** NULL */
/** */
  #define DBG002_INFO(groupid,messageid,length,value) \
        /** NULL */
/** */
  #define DBG002_TRACE(groupid,messageid,length,value)\
        /** NULL */
#define DBG002_FLUSH()   DBG002_Flush();

  #elif (DBG002_COMPILE_FILTER_TYPE == DBG002_LEVEL_NOTSET)
/** */
  #define DBG002_SAFETY_CRITICAL(groupid,messageid,length,value)
        /** NULL */
/** */
  #define DBG002_CRITICAL(groupid,messageid,length,value)
        /** NULL */
/** */
  #define DBG002_ERROR(groupid,messageid,length,value)
        /** NULL */
/** */
  #define DBG002_WARNING(groupid,messageid,length,value)
        /** NULL */
/** */
  #define DBG002_INFO(groupid,messageid,length,value)
        /** NULL */
/** */
  #define DBG002_TRACE(groupid,messageid,length,value)
        /** NULL */
#define DBG002_FLUSH()
        /** NULL */
#endif

/**
 * @}
 */

#include "../../inc/DBG002/DBG002_Private.h"


#define get_unaligned16(p) \
	p[0] | p[1] << 8;

#define get_unaligned32(p) \
	p[0] | p[1] << 8 | p[2] << 16 | p[3] << 24;

#define put_unaligned16(val, p) \
	*p++ = (uint8_t)(val); \
 	*p++ = (uint8_t)(val >> 8);

#define put_unaligned32(val, p) \
	*p++ = (uint8_t)(val); \
 	*p++ = (uint8_t)(val >> 8); \
 	*p++ = (uint8_t)(val >> 16); \
 	*p++ = (uint8_t)(val >> 24); \
 	

#ifdef __cplusplus
}
#endif

#endif /* _DBG002_H_ */

