
/**
 * @file PMSMFOCSL01_Conf.h
 *
 * @brief This file declares the handle as extern so that it can be used by any App. 
 */

#ifndef PMSMFOCSL01CONF_H_
#define PMSMFOCSL01CONF_H_

/* Support for C++ codebase */
#ifdef __cplusplus
extern "C" {
#endif


/*******************************************************************************
** INCLUDE FILES:
*******************************************************************************/
#include <DAVE3.h>		



/*******************************************************************************
** GLOBAL MACRO DEFINITIONS: 		
*******************************************************************************/
/**
  * @ingroup PMSMFOCSL01_constants
  * @{
  */ 
/* Total number of Column A Instances */	    
#define  PMSMFOCSL01_NUM_INSTANCES       1U

	
/* For instance 0 */

/* User defined function mapped to  corresponding handler */
#define  PMSMFOCSL01_PWMPeriodMatchISRA       IRQ_Hdlr_25 

/* User defined function mapped to  corresponding handler */
#define  PMSMFOCSL01_TrapPhaseVOneMatchISRA       IRQ_Hdlr_26 

/* User defined function mapped to  corresponding handler */

#define  PMSMFOCSL01_HandleA               PMSMFOCSL01_Handle0  
/* For instance 0 */ 

/**
 * @}
 */
 
/*******************************************************************************
** GLOBAL TYPE DEFINITIONS:            
*******************************************************************************/

/*******************************************************************************
** GLOBAL VARIABLE DEFINITIONS: 
*******************************************************************************/

/*******************************************************************************
** FUNCTION PROTOTYPES:
*******************************************************************************/

/*******************************************************************************
** STRUCTURES:
*******************************************************************************/
  

/* Support for C++ codebase */
#ifdef __cplusplus
}
#endif

#endif /* End of PMSMFOCSL01CONF_H_*/

/**
 * @}
 */
 
/*CODE_BLOCK_END*/
 



