/*******************************************************************************
**  DAVE App Name : DBG002       App Version: 1.0.22               
**  This file is generated by DAVE, User modification to this file will be    **
**  overwritten at the next code generation.                                  **
*******************************************************************************/


/*******************************************************************************
 Copyright (c) 2011, Infineon Technologies AG                                 **
 All rights reserved.                                                         **
                                                                              **
 Redistribution and use in source and binary forms, with or without           **
 modification,are permitted provided that the following conditions are met:   **
                                                                              **
 *Redistributions of source code must retain the above copyright notice,      **
 this list of conditions and the following disclaimer.                        **
 *Redistributions in binary form must reproduce the above copyright notice,   **
 this list of conditions and the following disclaimer in the documentation    **
 and/or other materials provided with the distribution.                       **
 *Neither the name of the copyright holders nor the names of its contributors **
 may be used to endorse or promote products derived from this software without** 
 specific prior written permission.                                           **
                                                                              **
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"  **
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE    **
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   **
 ARE  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE   **
 LIABLE  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR         **
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF         **
 SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS    **
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN      **
 CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)       **
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE   **
 POSSIBILITY OF SUCH DAMAGE.                                                  **
                                                                              **
 To improve the quality of the software, users are encouraged to share        **
 modifications, enhancements or bug fixes with Infineon Technologies AG       **
 dave@infineon.com).                                                          **
                                                                              **
********************************************************************************
**                                                                            **
**                                                                            **
** PLATFORM : Infineon XMC4000 Series                                         **
**                                                                            **
** COMPILER : Compiler Independent                                            **
**                                                                            **
** AUTHOR : App Developer                                                     **
**                                                                            **
** MAY BE CHANGED BY USER [yes/no]: Yes                                       **
**                                                                            **
** MODIFICATION DATE : Dec 12, 2012                                           **
**                                                                            **
*******************************************************************************/

/*******************************************************************************
**                       Author(s) Identity                                   **
********************************************************************************
**                                                                            **
** Initials    Name                                                           **
** ---------------------------------------------------------------------------**
** NPJ          App Developer                                                  **
*******************************************************************************/

/**
 * @file DBG002.c
 *
 * @App Version DBG002 <1.0.22>
 * @brief  This file contains all public & Private function definations of
 * DebugLog App.
 *
 */



/*******************************************************************************
 **                         INCLUDE FILES                                     **
 ******************************************************************************/
/**
 * @cond INTERNAL_DOCS
 */
#include <string.h>
#include <DAVE3.h>
#include "../../inc/DBG002/DBG002_UART.h"


/*******************************************************************************
**                     Private Constant Declarations                          **
*******************************************************************************/
/**
 * @ingroup DBG002_privateparam
 * @{
 */
 
 const char DBG002_version[] = DBG002_VERSION;

/*******************************************************************************
**                      Global Variable Definitions                           **
*******************************************************************************/
extern DBG002_GUIConfigurableType DBG002_ChannelConfig;
extern uint8_t isComingUartTxTrigger;


DBG002_CmdCallback DBG002_CallbackForGroupID[NO_OF_APPS + 4];
/* '4', being the maximum number of xSPY instances */
DBG002_XSpyDataType* CallBackArg[4];
DBG002_LoggingMessageFormatType CircularBufElementCh1[DBG002_CIRCULAR_BUFF_SIZE_CH1];
/*******************************************************************************
**                      Global Private Definitions                            **
*******************************************************************************/

/* Group ID of Apps*/
DBG002_AppInfoType CurAppInfo[(NO_OF_APPS + 6)] = {
 {DBG002_GID_XSPY1, "DBG002_GID_XSPY1"},
 {DBG002_GID_XSPY2, "DBG002_GID_XSPY2"},
 {DBG002_GID_XSPY3, "DBG002_GID_XSPY3"},
 {DBG002_GID_XSPY4, "DBG002_GID_XSPY4"},
 {DBG002_GID_USER1, "DBG002_GID_USER1"},
 {DBG002_GID_USER2, "DBG002_GID_USER2"},		     
 {32U,"MOTORLIBS"},		     
 {249U,"MATHLIBS"},		     
 {173U,"CLK002"},		     
 {86U,"IO002"},		     
 {132U,"CCU8GLOBAL"},		     
 {222U,"IO004"},		     
 {207U,"PWMSVM01"},		     
 {79U,"ADCGLOB001"},		     
 {112U,"ADCGROUP001"},		     
 {26U,"IO001"},		     
 {60U,"ADCCH001"},		     
 {254U,"ADC002"},		     
 {33U,"PMSMFOCSL01"},
};


/**
 * @}
 */
/**
 * @endcond
 */

/**
 * Initialize the local data structures from the GUI configurable elements
 */
void DBG002_Init(void)
{
  /* Register the callback with self */
  DBG002_RegisterCallBack(DBG002_GID, DBG002_lCallback, NULL);
  /* Initialize the peripheral interface */

    /*
     * initialize interface for Channel
     * use the handle stored in the channel configuration structure
     * --> use the same handle to call the API to send and receive data
     */
    if((DBG002_ChannelConfig.PeripheralHandle != (handle_t)NULL))
    {
      if(DBG002_ChannelConfig.PhysicalInterfaceInit)
      {
        DBG002_ChannelConfig.PhysicalInterfaceInit ( \
                  (void*)DBG002_ChannelConfig.PeripheralHandle);
      }
    }
  
}

/**
 * Registers the callback of APPs 
 */
status_t DBG002_RegisterCallBack
(
  uint8_t groupid,
  DBG002_CmdCallback Callback,
  DBG002_XSpyDataType* XspyDataPtr
)
{
  status_t Status = (status_t)DBG002_ERR;
  if((groupid > 255U) ||(Callback == NULL))
  {
	  Status = (status_t)DBG002_INVALID_PARAMETER;
  }
  else
  {
	/* Register the function pointer */
    DBG002_CallbackForGroupID[groupid] = Callback;
    /* Register xspy data pointer */
    CallBackArg[groupid] = XspyDataPtr;
    Status = (status_t)DAVEApp_SUCCESS;
  }
  return Status;
}

/**
 * This API is used to log the messages in circular buffer or sends them to the
 * host depending upon certain conditions.
 */
void DBG002_Logging
(
  uint32_t SeverityLevel,
  uint8_t GroupID,
  uint8_t MessageID,
  uint8_t Length,
  uint8_t *Message
)
{
    /* apply runtime filter */
    DBG002_lDynamicFilter(SeverityLevel, GroupID,MessageID, \
                              Length, Message);
}

/**
 * @}
 */

/**
 * @ingroup DBG002_privatefunc
 * @{
 */

/*
 * This function parses the command received from host.
 * This checks whether the callback is registered with debuglog. If registered
 * then evokes it and passes the command to appropriate application. If
 * callback is not registered then the command will be ignored.
 */
status_t DBG002_lProcessCommand(DBG002_CommandFromHostType* PtrCmdBuffer)
{
  status_t Status = (status_t)DBG002_ERR;
  /* check if call back is registered if registered then evoke */
  if(DBG002_CallbackForGroupID[PtrCmdBuffer->GroupID] != NULL)
  {
     Status = (DBG002_CallbackForGroupID[PtrCmdBuffer->GroupID])       \
             (PtrCmdBuffer,PtrCmdBuffer->GroupID,CallBackArg[PtrCmdBuffer->GroupID]);
  }
  return Status;
}

/**
 * this API registered with DebugLog. It handles the commands sent by host
 * intended for DebugLog
 */
status_t DBG002_lCallback(void* CommandPtr,uint32_t GroupID,DBG002_XSpyDataType* XspyAppPtr)
{
  static uint8_t XSpyMessage[256] = {0};
  status_t Status = (status_t)DBG002_ERR;
  DBG002_CommandFromHostType* CmdFromHost =(DBG002_CommandFromHostType*)CommandPtr;
  switch(CmdFromHost->Message[0])
  {
    case DBG002_GET_INFO:
  	{
  		uint8_t i;
        uint8_t* ResBufPtr = &XSpyMessage[1];

        Status = (status_t)DAVEApp_SUCCESS;
  		XSpyMessage[0] = DBG002_GET_INFO;
  		for (i = 0; i < sizeof(DBG002_version); i++) {
  			*(ResBufPtr++) = DBG002_version[i];
  		}

  		if (DBG002_CallbackForGroupID[DBG002_GID_XSPY1] != 0 ||
  			DBG002_CallbackForGroupID[DBG002_GID_XSPY2] != 0 ||
  			DBG002_CallbackForGroupID[DBG002_GID_XSPY3] != 0 ||
  			DBG002_CallbackForGroupID[DBG002_GID_XSPY4] != 0) {
  			*(ResBufPtr++) = 0xFF;
  		}
  		else {
  			*(ResBufPtr++) = 0x00;
  		}

  		/*Send a debuglog message*/
  		DBG002_lAddMsgToBuffer((uint32_t)DBG002_LEVEL_INFO, (uint8_t)DBG002_GID, (uint8_t)MESSAGE_ID_XSPY, ResBufPtr - XSpyMessage, (uint8_t *)&XSpyMessage);
  		break;
  	}
    case DBG002_SET_DYNAMIC_FILTER:
    {
      Status = DBG002_lSetDynamicFilter(CmdFromHost);
      break;
    }
    case DBG002_SET_LOCATION:
    {
      Status = (status_t)DAVEApp_SUCCESS;
      uint8_t Msglen = (CmdFromHost->MessageLen - 1U);
      uint32_t address_value;
      uint8_t size_value;
      uint8_t* BufPtr = &CmdFromHost->Message[1];
      while(Msglen > 0U)
      {

    	  /* Read the address received */
    	  address_value = get_unaligned32(BufPtr);
    	  BufPtr += 4U;

    	  size_value = *(BufPtr++);

    	  /* read the size of the variable */
    	  if(size_value == 1U)
    	  {
    		  /* set the value to the buffer 8bit*/
    		  *((uint8_t*)address_value) = *(BufPtr++);
    		  Msglen -=6U;
    	  }
    	  else if(size_value == 2U)
    	  {
    		  /* set the value to the buffer 16bit*/
    		  *((uint16_t*)address_value) = get_unaligned16(BufPtr);
    		  BufPtr += 2U;
    		  Msglen -=7U;
    	  }
    	  else if(size_value == 4U)
    	  {
    		  /* set the value to the buffer 32bit*/
    		  *((uint32_t*)address_value) = get_unaligned32(BufPtr);
    		  BufPtr += 4U;
    		  Msglen -= 9U;
    	  }
    	  else if(size_value == 8U)
    	  {
    		  /* set the value to the buffer 64bit*/
    		  *((uint32_t*)address_value) = get_unaligned32(BufPtr);
    		  address_value += 4U;
    		  BufPtr += 4U;
    		  *((uint32_t*)address_value) = get_unaligned32(BufPtr);
    		  BufPtr += 4U;
    		  Msglen -= 13U;
    	  }
    	  else
    	  {
    	        Status = (status_t)DBG002_SETLOCATION_FAILED;
    	        break;
    	  }
      }

      break;
    }
    case DBG002_GET_LOCATION:
    {
        uint32_t address_value;
        uint8_t size_value;
        uint8_t MsgLen = (CmdFromHost->MessageLen - 1U);
        uint8_t* GetBufPtr = &CmdFromHost->Message[1];
        uint8_t* ResBufPtr = &XSpyMessage[1];
        Status = (status_t)DAVEApp_SUCCESS;
        XSpyMessage[0] = DBG002_GET_LOCATION;

        while(MsgLen > 0U)
        {
        	/*Read the address of the variable */
        	address_value = get_unaligned32(GetBufPtr);
        	GetBufPtr += 4U;
        	/* Copy the address received the message buffer*/
        	put_unaligned32(address_value, ResBufPtr);

        	/* Get the size of variable */
        	size_value = *(GetBufPtr++);
        	/* Copy the size received the message buffer*/
        	*(ResBufPtr++) = size_value;

    		/* read the value of the variable */
        	if(size_value == 1U)
        	{
        		*(ResBufPtr++) = *((uint8_t*)address_value);
        	}
        	else if(size_value == 2U)
        	{
        		put_unaligned16(*((uint16_t*)address_value), ResBufPtr);
        	}
        	else if(size_value == 4U)
        	{
        		put_unaligned32(*((uint32_t*)address_value), ResBufPtr);
        	}
        	else if(size_value == 8U)
        	{
        		put_unaligned32(*((uint32_t*)address_value), ResBufPtr);
        		address_value += 4U;
        		put_unaligned32(*((uint32_t*)address_value), ResBufPtr);
        	}
        	else
        	{
      	        Status = DBG002_GETLOCATION_FAILED;
      	        break;
        	}
        	MsgLen -= 5U;
        }
        if(Status != DBG002_GETLOCATION_FAILED)
        {
            /*Send a debuglog message*/
        	DBG002_lAddMsgToBuffer ((uint32_t)DBG002_LEVEL_INFO, (uint8_t)DBG002_GID,   (uint8_t)MESSAGE_ID_XSPY, ResBufPtr - XSpyMessage, (uint8_t *)&XSpyMessage);
        }

      break;
    }
    default:
    {
      break;
    }
  }
  return Status;
}
 

/**
 * This changes/modifies the dynamic filter setting as requested by the host
 */
status_t DBG002_lSetDynamicFilter
(
  const DBG002_CommandFromHostType* CmdFromHost
)
{
  status_t Status = (status_t)DBG002_ERR;

  /* check if message length is correct */
  if((CmdFromHost->MessageLen) == DBG002_MSGLEN_CMD_SETDYNAMICFILTER)
  {
      DBG002_ChannelConfig.DynamicFilterMacroGroupID[0] = \
    		                    *((uint32_t*)(&(CmdFromHost->Message[1])));

      DBG002_ChannelConfig.DynamicFilterMacroGroupID[1] = \
    		                    *((uint32_t*)(&(CmdFromHost->Message[5])));

      DBG002_ChannelConfig.DynamicFilterMacroGroupID[2] = \
    		                    *((uint32_t*)(&(CmdFromHost->Message[9])));
      DBG002_ChannelConfig.DynamicFilterMacroGroupID[3] = \
    		              *((uint32_t*)(&(CmdFromHost->Message[13])));

      DBG002_ChannelConfig.DynamicFilterMacroGroupID[4] = \
    		                *((uint32_t*)(&(CmdFromHost->Message[17])));

      DBG002_ChannelConfig.DynamicFilterMacroGroupID[5] = \
    	                     *((uint32_t*)(&(CmdFromHost->Message[21])));
      DBG002_ChannelConfig.DynamicFilterMacroGroupID[6] = \
    		                 *((uint32_t*)(&(CmdFromHost->Message[25])));
      DBG002_ChannelConfig.DynamicFilterMacroGroupID[7] = \
    		             *((uint32_t*)(&(CmdFromHost->Message[29])));
      DBG002_ChannelConfig.RunTimeDynamicFilterSeverity =
                                 (uint32_t)CmdFromHost->Message[33];
      Status = (status_t)DAVEApp_SUCCESS;
  }
  return (Status);
}


/**
 * This adds the message into circular buffer
 */
void DBG002_lAddMsgToBuffer
(
  uint32_t SeverityLevel,
  uint8_t GroupID,
  uint8_t MessageID,
  uint8_t Length,
  uint8_t* Message
)
{
  /* circular buffer index for writting the next message */
  static uint8_t circularBufferWriteIndex = 0;
  static uint8_t MsgCnt = 0;

  uint32_t CopyCounter = 0U;
  uint32_t OldPRIMASK;
  DBG002_LoggingMessageFormatType* CirBufPtr;

  /*Incrementing the counter shall be atomic. Disable all the interrupts */
  OldPRIMASK = __get_PRIMASK();
  __disable_irq();

  CirBufPtr = &CircularBufElementCh1[circularBufferWriteIndex];
  circularBufferWriteIndex++;
  circularBufferWriteIndex = circularBufferWriteIndex % DBG002_CIRCULAR_BUFF_SIZE_CH1;

  CirBufPtr->Counter = MsgCnt;
  MsgCnt++;

  if (OldPRIMASK == 0U) {
	  __enable_irq();
  }

  CirBufPtr->StartByte[0] = 0xAAU;
  CirBufPtr->StartByte[1] = 0xAAU;
  /* Add elements to circular buffer */
  CirBufPtr->Counter = MsgCnt;
  CirBufPtr->SeverityLevel = SeverityLevel;
  CirBufPtr->GroupID = GroupID;
  CirBufPtr->MessageID = MessageID;
  CirBufPtr->MessageLen = Length;

  if (Length > 0U) {
	/*check if current message is stream data */
	if ((Message[0] == DBG002_XSPYSetStreamData) &&
	    (MessageID == MESSAGE_ID_XSPY)) {
		CirBufPtr->StreamBufPtr = (DBG002_PingPongBufType*)Message;
	} else {
      for (CopyCounter = 0U; CopyCounter < Length; CopyCounter++) {
        CirBufPtr->Message[CopyCounter] = *(Message + CopyCounter);
      }
      CirBufPtr->StreamBufPtr = NULL;
    }
  }
  CirBufPtr->Counter2 = MsgCnt;
  CirBufPtr->isNew = TRUE;
  
  DBG002_SendMessageToHost();
}

/**
 * This API is used to filter the messages by applying run time dynamic filter.
 */
void DBG002_lDynamicFilter
(
  uint32_t SeverityLevel,
  uint8_t GroupID,
  uint8_t MessageID,
  uint8_t Length,
  uint8_t* Message
)
{
  uint8_t ByteNo = GroupID / 32U;
  uint8_t BitNo = GroupID % 32U;

  /* get the values for Group ID and Severity Level */
  if((((DBG002_ChannelConfig.DynamicFilterMacroGroupID[ByteNo]) & (1UL << BitNo)) > 0) && \
		  ((DBG002_ChannelConfig.RunTimeDynamicFilterSeverity) <= SeverityLevel))
  {
    DBG002_lAddMsgToBuffer(SeverityLevel, GroupID,
                                      MessageID, Length, Message);
  }
}


/**
 * @}
 */
/*CODE_BLOCK_END*/ 

