/*******************************************************************************
**  DAVE App Name : DBG002       App Version: 1.0.22               
**  This file is generated by DAVE, User modification to this file will be    **
**  overwritten at the next code generation.                                  **
*******************************************************************************/

/*******************************************************************************
 Copyright (c) 2011, Infineon Technologies AG                                 **
 All rights reserved.                                                         **
                                                                              **
 Redistribution and use in source and binary forms, with or without           **
 modification,are permitted provided that the following conditions are met:   **
                                                                              **
 *Redistributions of source code must retain the above copyright notice,      **
 this list of conditions and the following disclaimer.                        **
 *Redistributions in binary form must reproduce the above copyright notice,   **
 this list of conditions and the following disclaimer in the documentation    **
 and/or other materials provided with the distribution.                       **
 *Neither the name of the copyright holders nor the names of its contributors **
 may be used to endorse or promote products derived from this software without** 
 specific prior written permission.                                           **
                                                                              **
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"  **
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE    **
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   **
 ARE  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE   **
 LIABLE  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR         **
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF         **
 SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS    **
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN      **
 CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)       **
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE   **
 POSSIBILITY OF SUCH DAMAGE.                                                  **
                                                                              **
 To improve the quality of the software, users are encouraged to share        **
 modifications, enhancements or bug fixes with Infineon Technologies AG       **
 dave@infineon.com).                                                          **
                                                                              **
********************************************************************************
**                                                                            **
**                                                                            **
** PLATFORM : Infineon XMC4000 Series                                         **
**                                                                            **
** COMPILER : Compiler Independent                                            **
**                                                                            **
** AUTHOR : App Developer                                                     **
**                                                                            **
** MAY BE CHANGED BY USER [yes/no]: Yes                                       **
**                                                                            **
** MODIFICATION DATE : Dec 13, 2012                                           **
**                                                                            **
*******************************************************************************/

/*******************************************************************************
**                       Author(s) Identity                                   **
********************************************************************************
**                                                                            **
** Initials    Name                                                           **
** ---------------------------------------------------------------------------**
** NPJ          App Developer                                                  **
*******************************************************************************/

/*******************************************************************************
 *                                INCLUDE FILES                               **
 ******************************************************************************/


#include <string.h>
#include <DAVE3.h>

#define CHECK_PP_BUF_STATUS(ptr)	\
	               ((ptr->StreamBuffer[ptr->PPBufferTracker].BufferStatus) == DBG002_BUF_READY)

/*******************************************************************************
**                      Helper Functions                                      **
*******************************************************************************/

#define XSPY_GUARD_CIRC_BUF   1
#define XSPY_UNGUARD_CIRC_BUF 2

extern DBG002_GUIConfigurableType DBG002_ChannelConfig;

/*
 * Set DynamicFilterMacroGroupID mask to make sure no
 * other message pollutes the message queue while the
 * variable table is being transmitted.
 */
static void circ_buffer_helper (int op) {
	int i;

	switch (op) {
		case XSPY_GUARD_CIRC_BUF:
			DBG002_ChannelConfig.DynamicFilterMacroGroupID[0] = 0x0000001f;
			for (i = 1; i <= 7; i++)
				DBG002_ChannelConfig.DynamicFilterMacroGroupID[i] = 0x00000000;
			break;
		case XSPY_UNGUARD_CIRC_BUF:
			for (i = 0; i < 8; i++)
				DBG002_ChannelConfig.DynamicFilterMacroGroupID[i] = 0xffffffff;
			break;
		default:
			break;
	}
}

/*******************************************************************************
**                      Private Function Definitions                          **
*******************************************************************************/


/*
 * This is call back function registered by the Api DBG002_XspyInit() for
 * processing xSPY commands recived from host.
 * */
status_t DBG002_lXspyCmdHandler
(
  void* CommandPtr,
  uint32_t GroupID,
  DBG002_XSpyDataType *XspyDataPtr
)
{

	DBG002_CommandFromHostType *XspyCmdBufPtr = (DBG002_CommandFromHostType*) CommandPtr;
	uint8_t getvar_index = XspyCmdBufPtr->Message[2];
	uint8_t gid_index = XspyCmdBufPtr->Message[1];
	status_t Status = (uint32_t)DAVEApp_SUCCESS;
	uint8_t Command = XspyCmdBufPtr->Message[1];
	uint8_t MsgLen = XspyCmdBufPtr->MessageLen;
	uint8_t *MessagePtr = &XspyCmdBufPtr->Message[0];
	do
	{
		if(XspyDataPtr == NULL)
	    {
			break;
	    }
	    switch(Command)
	    {
	        /* CommandId for XSPY set stream data  */
	        case DBG002_XSPYSetStreamData:
	        {
	    	  uint8_t Index = 0U;
	    	  MsgLen = MsgLen - 2U;
	    	  MessagePtr = &XspyCmdBufPtr->Message[2];
	    	  /* Check if received message length*/
	    	  if(MsgLen == 0U)
	    	  {
	    		XspyDataPtr->StartStream = (bool)FALSE;
	    	  }
	    	  else if ((MsgLen/5U) > DBG002_MAX_STREAM_DATA )
	          {
	            Status = (uint32_t)DBG002_SETSTREAMCOMMAND_FAILED;
	          }
	          else
	          {
	            /* Parse till message length 0 */
	            XspyDataPtr->DataFrameSize = 0;
	            while(MsgLen > 0U)
	            {
	            	/* Read the received address */
	            	XspyDataPtr->StreamAddresses[Index] = get_unaligned32(MessagePtr);
	            	MessagePtr += 4U;

	            	/* Read the variable size */
	            	XspyDataPtr->StreamSize[Index++]= *(MessagePtr);
	            	XspyDataPtr->DataFrameSize += *(MessagePtr++);
	            	MsgLen -= 5U;
	            }

	            /* Set the current no of variables received */
	            XspyDataPtr->CurrentStreamDataIndex = Index;
	            XspyDataPtr->StartStream = (bool)TRUE;
	            Status = (uint32_t)DAVEApp_SUCCESS;
	          }
	          break;
	        }
	        /* CommandId for XSPY Set sync Command  */
	        case DBG002_XSPYSetSyncCmd:
	        {
	      	  uint8_t Index = 0U;
	      	  MsgLen = MsgLen - 2U;
	      	  MessagePtr = &XspyCmdBufPtr->Message[2];
	          while(MsgLen > 0U)
	          {
	            /* Read the received address */
	        	XspyDataPtr->SyncCommands[Index].Address = get_unaligned32(MessagePtr);
	        	MessagePtr += 4U;

	        	/* Read the size of the variable */
	            XspyDataPtr->SyncCommands[Index].Size = *(MessagePtr++);

	            /* set the value received to the buffer */
	            if(XspyDataPtr->SyncCommands[Index].Size == 1U)
	            {
	            	XspyDataPtr->SyncCommands[Index].DBG002_Command.Value8Bit = *(MessagePtr++);
	            	MsgLen -= 6U;
	            }
	            else if(XspyDataPtr->SyncCommands[Index].Size == 2U)
	            {
	            	XspyDataPtr->SyncCommands[Index].DBG002_Command.Value16Bit = get_unaligned16(MessagePtr);

	            	MessagePtr += 2U;
	            	MsgLen -= 7U;
	            }
	            else if(XspyDataPtr->SyncCommands[Index].Size == 4U)
	            {
	            	XspyDataPtr->SyncCommands[Index].DBG002_Command.Value32Bit = get_unaligned32(MessagePtr);

	            	MessagePtr += 4U;
	            	MsgLen -= 9U;
	            }
	            else if(XspyDataPtr->SyncCommands[Index].Size == 8U)
	            {
	            	uint32_t* Temp64bit = (uint32_t*)&XspyDataPtr->SyncCommands[Index].DBG002_Command.Value64Bit;
	            	*(Temp64bit++) = get_unaligned32(MessagePtr);
	            	MessagePtr+=4U;
	            	*(Temp64bit) = get_unaligned32(MessagePtr);
	            	MessagePtr+=4U;
	            	MsgLen -= 13U;
	            }
	            else
	            {
	            	Status = (uint32_t)DBG002_SETSYNCCOMMAND_FAILED;
	            	break;
	            }

	            Index++;
	            if(Index > DBG002_NUM_OF_COMMANDS)
	            {
	            	Status = (uint32_t)DBG002_SETSYNCCOMMAND_FAILED;
	            	break;
	            }
	          }
	          XspyDataPtr->CurrentCommandIndex = Index;
	          break;
	        }
	        /* CommandId for XSPY execute sync Command  */
	        case DBG002_XSPYExecuteSyncCmd:
	        {
	    	  /* sync command buffer is ready to execute*/
	    	  XspyDataPtr->SyncCommandsBufferReady = (bool)TRUE;
	          Status = (uint32_t)DAVEApp_SUCCESS;
	          break;
	        }
	        /* CommandId for XSPY get variable table  */
	        case DBG002_XSPYGetVariableTable:
	        {
	          static uint8_t XSpyMessage[256] = {0U};
	          uint8_t* BufPtr = &XSpyMessage[1];
	          uint8_t Index;
	          uint8_t ColonCnt;
	          uint32_t address_value;

	          /* Write Xpy message ID for Send variable table */
	          XSpyMessage[0] = (uint8_t)DBG002_XSPYGetVariableTable;
	          
	          if (getvar_index == XspyDataPtr->NumberofVarDescription) {
	        	  /* End of variable table*/
	        	  DBG002_lAddMsgToBuffer((uint32_t)DBG002_LEVEL_INFO,(uint8_t)gid_index,\
                        (uint8_t)MESSAGE_ID_XSPY,1U,\
                        (uint8_t *)&XSpyMessage);

	        	  /* Unguard the buffer queue. */
	        	  circ_buffer_helper(XSPY_UNGUARD_CIRC_BUF);
	          }
	          else {

	        	  if (getvar_index == 0) {
	        		  /* guard the circular buffer */
	    	          circ_buffer_helper(XSPY_GUARD_CIRC_BUF);
	        	  }

	        	  ColonCnt = 0U;
	        	  Index = 0U;
	        	  /* Copy the name of the variable to message buffer
	        	   * name of variable format is name:scale:unit: eg:- "speed:4.1:rpm:"*/
	        	  while ((ColonCnt < 3U) && (Index < MAX_STRING_LENGTH )) {
	        		  if (XspyDataPtr->VarDescription[getvar_index].Name[Index] == 0x3AU) {
	        			  ColonCnt++;
	        		  }

	        		  *(BufPtr++) = XspyDataPtr->VarDescription[getvar_index].Name[Index++];
	        	  }

	        	  if(Index >= MAX_STRING_LENGTH) {
	        		  Status = (status_t)DBG002_GETVARCOMMAND_FAILED;
	        		  break;
	        	  }

	        	  /* Copy the address to the message buffer */
	        	  address_value = XspyDataPtr->VarDescription[getvar_index].Address;
	        	  put_unaligned32(address_value, BufPtr);

	        	  /* Copy size to message*/
	        	  *(BufPtr++) = XspyDataPtr->VarDescription[getvar_index].Size;

	        	  /*
	        	   * Send the variable table and
	        	   * add message to circular buffer
	        	   */
	        	  DBG002_lAddMsgToBuffer((uint32_t)DBG002_LEVEL_INFO,(uint8_t)gid_index, (uint8_t)MESSAGE_ID_XSPY, BufPtr - XSpyMessage, (uint8_t *)&XSpyMessage);
	          }
	          break;
	        }
	    }
	} while(0);

	return Status;
}


/*******************************************************************************
**                      Public Function Definitions                           **
*******************************************************************************/
/*
 * This API is used for XSpy data structure initilization .
 * */
status_t DBG002_XspyInit
(
  DBG002_XSpyDataType *XspyDataPtr,
  DBG002_VariableDescriptionType *VarDescriptorPtr,
  uint32_t NumberofVarDescriptor,
  uint8_t Gid
)
{
  status_t Status = (uint32_t)DBG002_INVALID_PARAMETER;
  if(( VarDescriptorPtr == NULL)||(XspyDataPtr == NULL))
  {
    Status = (uint32_t)DBG002_INVALID_PARAMETER;
  }
  else
  {
    XspyDataPtr->VarDescription = VarDescriptorPtr;
    XspyDataPtr->NumberofVarDescription = NumberofVarDescriptor;
    XspyDataPtr->Gid = Gid;
    XspyDataPtr->SyncCommandsBufferReady = (bool)FALSE;
    XspyDataPtr->PPBufferTracker=0U;
    XspyDataPtr->CurrentStreamBufferPtr =  &(XspyDataPtr->StreamBuffer[XspyDataPtr->PPBufferTracker].Buffer[1]);
    XspyDataPtr->StreamBuffer[0].BufferStatus = (uint8_t)DBG002_BUF_READY;
    XspyDataPtr->StreamBuffer[1].BufferStatus = (uint8_t)DBG002_BUF_READY;
    DBG002_RegisterCallBack(Gid, DBG002_lXspyCmdHandler, XspyDataPtr);
    Status = (uint32_t)DAVEApp_SUCCESS;
  }
  return Status;
}

/*
 * This API streams the Xspy data to Xspy host
 * this function shall be called by monitored app to synchronize the reading of data.
 * It buffer the data in a ping pong buffer and when it is full it send to X-SPY host using std function.
 * This function use a variables in xspy_struct to store the target address and size of variable.
 *
 */  
status_t DBG002_XspyStreamData(DBG002_XSpyDataType *XspyDataPtr)
{
	status_t Status = (uint32_t)DBG002_INVALID_PARAMETER;
	if (XspyDataPtr != NULL && XspyDataPtr->StartStream == TRUE && CHECK_PP_BUF_STATUS(XspyDataPtr)) {

		uint32_t Index;
		uint32_t address_value;
		uint8_t *buffPtr= XspyDataPtr->CurrentStreamBufferPtr;
		uint8_t current_pp_buf = XspyDataPtr->PPBufferTracker;
		uint8_t *current_start_buf=&(XspyDataPtr->StreamBuffer[current_pp_buf].Buffer[0]);

		/* Set the command for send stream data */
		*current_start_buf = DBG002_XSPYSetStreamData;
		for (Index = 0U; Index < XspyDataPtr->CurrentStreamDataIndex; Index++) {

			address_value = XspyDataPtr->StreamAddresses[Index];
			/* Put the value of variable to message buffer */
			if (XspyDataPtr->StreamSize[Index] == 1U) {
				*(buffPtr++) = *((uint8_t*)address_value);
			}
			else if (XspyDataPtr->StreamSize[Index] == 2U) {
				put_unaligned16((*((uint16_t*)address_value)), buffPtr);
			}
			else if (XspyDataPtr->StreamSize[Index] == 4U) {
				put_unaligned32((*((uint32_t*)address_value)), buffPtr);
			}
			else {
				put_unaligned32((*((uint32_t*)address_value)), buffPtr);
				address_value += 4U;
				put_unaligned32((*((uint32_t*)address_value)), buffPtr);
			}
		}

		XspyDataPtr->CurrentStreamBufferPtr = buffPtr;
		if (((buffPtr - current_start_buf)  + XspyDataPtr->DataFrameSize) > DBG002_STREAM_BUFF_LENGTH) {
			XspyDataPtr->StreamBuffer[current_pp_buf].BufferStatus = (uint8_t)DBG002_BUF_BUSY;
			DBG002_lAddMsgToBuffer((uint32_t)DBG002_LEVEL_INFO,
	    	  	                   ((uint8_t)XspyDataPtr->Gid),
	    	  	                   (uint8_t)MESSAGE_ID_XSPY,
	    	  	                   ((buffPtr - current_start_buf)),
	    	  	                   (uint8_t *)&XspyDataPtr->StreamBuffer[current_pp_buf]);

			/* Change the ping pong for adding next ping pong buffer */
			XspyDataPtr->PPBufferTracker ^= 1U;
			XspyDataPtr->CurrentStreamBufferPtr = &(XspyDataPtr->StreamBuffer[XspyDataPtr->PPBufferTracker].Buffer[1]);
		}
		Status = (uint32_t)DAVEApp_SUCCESS;
	}
	return Status;
}

/*
 * This Api is used to process Execute sync command when the command
 * is received from host. User has to call this Api in application control
 * loop to process the command.
 */
status_t DBG002_XspyProcessCommand
(
  DBG002_XSpyDataType *XspyDataPtr
)
{
  uint8_t Index;
  status_t Status = (uint32_t)DBG002_NO_COMMAND_RECEIVED;
  if(XspyDataPtr->SyncCommandsBufferReady == TRUE)
  {
	  for(Index = 0U; Index < XspyDataPtr->CurrentCommandIndex;Index++)
	  {
		  switch(XspyDataPtr->SyncCommands[Index].Size)
		  {
		  	  case 1:
		  		*((uint8_t*)XspyDataPtr->SyncCommands[Index].Address) = \
		  				XspyDataPtr->SyncCommands[Index].DBG002_Command.Value8Bit;
		  		break;
		  	  case 2:
			    *((uint16_t*)XspyDataPtr->SyncCommands[Index].Address) = \
			  				XspyDataPtr->SyncCommands[Index].DBG002_Command.Value16Bit;
			  	break;
		  	  case 4:
				*((uint32_t*)XspyDataPtr->SyncCommands[Index].Address) = \
				  				XspyDataPtr->SyncCommands[Index].DBG002_Command.Value32Bit;
				break;
		  	  case 8:
				*((double*)XspyDataPtr->SyncCommands[Index].Address) = \
					  				XspyDataPtr->SyncCommands[Index].DBG002_Command.Value64Bit;
			    break;
		  }
	  }
	  XspyDataPtr->SyncCommandsBufferReady = (bool)FALSE;
	  XspyDataPtr->CurrentCommandIndex = 0U;
	  Status = (uint32_t)DAVEApp_SUCCESS;
  }
  return Status;
}


