<?xml version="1.0" encoding="ASCII"?>
<ResourceModel:App xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ResourceModel="http://www.infineon.com/Davex/Resource.ecore" name="PMSMFOCSL01" description="This App implements Sensor Less &#xA; Field Oriented Control for the &#xA; PMSM Motor.It supports DC Link &#xA; Current, Voltage Compensation and &#xA; POT measurement. It consumes &#xA; ADC002 (Queue) App and &#xA; PWMSVM01 App." descriptionURL="/doc/html/group___p_m_s_m_f_o_c_s_l01_app.html" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0">
  <provided xsi:type="ResourceModel:VirtualSignal" name="NVIC node - Current Trigger Interrupt" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_nvic_currentmeas_vs" requiredSignalResource="nvic_current/signal_in" canExpose="false">
    <defaultValue xsi:type="ResourceModel:Blocked" value="Blocked"/>
    <localValue xsi:type="ResourceModel:StringValue" value="Blocked"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="Blocked"/>
  </provided>
  <provided xsi:type="ResourceModel:VirtualSignal" name="NVIC node - Period Match Interrupt" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_nvic_pm_vs" requiredSignalResource="nvic_pwmperiod/signal_in" canExpose="false">
    <defaultValue xsi:type="ResourceModel:Blocked" value="Blocked"/>
    <localValue xsi:type="ResourceModel:StringValue" value="Blocked"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="Blocked"/>
  </provided>
  <provided xsi:type="ResourceModel:VirtualSignal" name="NVIC node - Trap/Phase-V one match Interrupt" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_nvic_trap_vs" requiredSignalResource="nvic_trap/signal_in" canExpose="false">
    <defaultValue xsi:type="ResourceModel:Blocked" value="Blocked"/>
    <localValue xsi:type="ResourceModel:StringValue" value="Blocked"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="Blocked"/>
  </provided>
  <provided xsi:type="ResourceModel:StringParameter" name="Control Strategy" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_srcontrolstrategy">
    <defaultValue xsi:type="ResourceModel:StringValue" value="Speed Control"/>
    <localValue xsi:type="ResourceModel:StringValue" value="Speed Control"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="Speed Control"/>
    <toolTipHelpDescription>This displays the control strategy used for the motor control</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:StringParameter" name="Control Technique" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_srcontroltechnique">
    <defaultValue xsi:type="ResourceModel:StringValue" value="Field Oriented Control"/>
    <localValue xsi:type="ResourceModel:StringValue" value="Field Oriented Control"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="Field Oriented Control"/>
    <toolTipHelpDescription>This displays the control technique used for the motor control</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:StringParameter" name="Feedback Mechanism" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_srsensortype">
    <defaultValue xsi:type="ResourceModel:StringValue" value="Sensorless"/>
    <localValue xsi:type="ResourceModel:StringValue" value="Sensorless"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="Sensorless"/>
    <toolTipHelpDescription>This displays the whether algorithm is sensorbased or sensorless.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="PWM frequency" evalFunction="&#xD;&#xA;         function ForwardMapping(){&#xD;&#xA;              var rise = SCM.getDoubleValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_irwpwmfreq&quot;);&#xD;&#xA;              SCM.setDoubleValue(Res, rise); &#xD;&#xA;&#xD;&#xA;             /*Force value in SVM app*/&#xD;&#xA;              var check_value = SCM.getResource(&quot;svm/pwmsvm01_irwtoplevelapp&quot;);&#xD;&#xA;              SCM.setIntValue(check_value,1); &#xD;&#xA;              var ResETCM = SCM.getResource(&quot;svm/pwmsvm01_erwenablecrntmsr/2&quot;);&#xD;&#xA;              SCM.setIntValue(ResETCM,1);    &#xD;&#xA;              /************************/&#xD;&#xA;              &#xD;&#xA;              var ResTrgrControl = SCM.getResource(&quot;svm/pwmsvm01_erwtriggercontrol&quot;);&#xD;&#xA;              SCM.setIntValue(ResTrgrControl,1); &#xD;&#xA;&#xD;&#xA;          }&#xD;&#xA;          function BackwardMapping(){&#xD;&#xA;              var tempRes = SCM.getResource(&quot;svm/pwmsvm01_irwpwmfreq&quot;);&#xD;&#xA;              var value = SCM.getDoubleValue(tempRes);&#xD;&#xA;              SCM.setDoubleValue(currentResource,value);       &#xD;&#xA;          } " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwpwmfreq" downWardmappedList="//@consumed.59 //@consumed.77 //@consumed.68 //@consumed.83" maxValue="C350" minValue="1388">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="4E20"/>
    <localValue xsi:type="ResourceModel:StringValue" value="4E20"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="4e20"/>
    <toolTipHelpDescription>This allows a user to input PWM frequency. &#xD;
Minimum value is 5 KHz and maximum value is 50 KHz</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="CCR" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;&#xD;&#xA;                var SCRRes = SCM.getResource(&quot;temp_scr&quot;); &#xD;&#xA;                var SCRval = SCM.getIntValue(SCRRes);&#xD;&#xA;&#xD;&#xA;                var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;                var XMC4xxx = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if(value==32768){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  if(XMC1302==0){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Res,3); &#xD;&#xA;&#x9;                SCM.setIntValue(SCRRes,9);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  } else if(XMC4xxx==0) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Res,2);&#xD;&#xA;&#x9;                SCM.setIntValue(SCRRes,8);&#xD;&#xA;&#x9;&#x9;&#x9;      }&#xD;&#xA;&#x9;&#x9;&#x9;    } else {&#xD;&#xA;&#x9;               if(SCRval &lt;= value){&#xD;&#xA;&#x9;                 SCM.setIntValue(SCRRes,value); &#xD;&#xA;&#x9;                }else{&#xD;&#xA;&#x9;                 if(SCRval &lt;= (value*2)){&#xD;&#xA;&#x9;                  var CCRval2 = value*2;&#xD;&#xA;&#x9;                  SCM.setIntValue(SCRRes,CCRval2);&#xD;&#xA;&#x9;                 }else if(SCRval &lt;= (value*3)){&#xD;&#xA;&#x9;                  var CCRval2 = value*3;&#xD;&#xA;&#x9;                  SCM.setIntValue(SCRRes,CCRval2);&#xD;&#xA;&#x9;                 }else if(SCRval &lt;= (value*4)){&#xD;&#xA;&#x9;                  var CCRval2 = value*4;&#xD;&#xA;&#x9;                  SCM.setIntValue(SCRRes,CCRval2);&#xD;&#xA;&#x9;                 }else if(SCRval &lt;= (value*5)){&#xD;&#xA;&#x9;                  var CCRval2 = value*5;&#xD;&#xA;&#x9;                  SCM.setIntValue(SCRRes,CCRval2);&#xD;&#xA;&#x9;                 }else if(SCRval &lt;= (value*6)){&#xD;&#xA;&#x9;                  var CCRval2 = value*6;&#xD;&#xA;&#x9;                  SCM.setIntValue(SCRRes,CCRval2);&#xD;&#xA;&#x9;                 }else if(SCRval &lt;= (value*7)){&#xD;&#xA;&#x9;                  var CCRval2 = value*7;&#xD;&#xA;&#x9;                  SCM.setIntValue(SCRRes,CCRval2);&#xD;&#xA;&#x9;                 }else if(SCRval &lt;= (value*8)){&#xD;&#xA;&#x9;                  var CCRval2 = value*8;&#xD;&#xA;&#x9;                  SCM.setIntValue(SCRRes,CCRval2);&#xD;&#xA;&#x9;                 }else if(SCRval &lt;= (value*9)){&#xD;&#xA;&#x9;                  var CCRval2 = value*9;&#xD;&#xA;&#x9;                  SCM.setIntValue(SCRRes,CCRval2);&#xD;&#xA;&#x9;                 }else if(SCRval &lt;= (value*10)){&#xD;&#xA;&#x9;                  var CCRval2 = value*10;&#xD;&#xA;&#x9;                  SCM.setIntValue(SCRRes,CCRval2);&#xD;&#xA;&#x9;                 }&#xD;&#xA;&#x9;                }&#xD;&#xA;&#x9;                SCM.setIntValue(Res,value);   &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}    &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_ccr&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwccr" downWardmappedList="//@consumed.46 //@consumed.47" maxValue="A" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="3"/>
    <toolTipHelpDescription>This is the Current Control Rate.&#xD;
The FOC algorithm will be executed every CCR times of the PWM period.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="SCR" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_scr&quot;);&#xD;&#xA;&#xD;&#xA;                var CCRRes = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;                var CCRval = SCM.getIntValue(CCRRes);&#xD;&#xA;                var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;                var XMC4xxx = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if(value==32768){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  if(XMC1302==0){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Res,9); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  } else if(XMC4xxx==0) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Res,8); &#xD;&#xA;&#x9;&#x9;&#x9;      }&#xD;&#xA;&#x9;&#x9;&#x9;    } else {&#xD;&#xA;&#x9;              if(value &lt;= CCRval){&#xD;&#xA;&#x9;                 SCM.setIntValue(Res,CCRval); &#xD;&#xA;&#x9;                }else{&#xD;&#xA;&#x9;                 if(value &lt;= (CCRval*2)){&#xD;&#xA;&#x9;                  var CCRval2 = CCRval*2;&#xD;&#xA;&#x9;                  SCM.setIntValue(Res,CCRval2);&#xD;&#xA;&#x9;                 }else if(value &lt;= (CCRval*3)){&#xD;&#xA;&#x9;                  var CCRval2 = CCRval*3;&#xD;&#xA;&#x9;                  SCM.setIntValue(Res,CCRval2);&#xD;&#xA;&#x9;                 }else if(value &lt;= (CCRval*4)){&#xD;&#xA;&#x9;                  var CCRval2 = CCRval*4;&#xD;&#xA;&#x9;                  SCM.setIntValue(Res,CCRval2);&#xD;&#xA;&#x9;                 }else if(value &lt;= (CCRval*5)){&#xD;&#xA;&#x9;                  var CCRval2 = CCRval*5;&#xD;&#xA;&#x9;                  SCM.setIntValue(Res,CCRval2);&#xD;&#xA;&#x9;                 }else if(value &lt;= (CCRval*6)){&#xD;&#xA;&#x9;                  var CCRval2 = CCRval*6;&#xD;&#xA;&#x9;                  SCM.setIntValue(Res,CCRval2);&#xD;&#xA;&#x9;                 }else if(value &lt;= (CCRval*7)){&#xD;&#xA;&#x9;                  var CCRval2 = CCRval*7;&#xD;&#xA;&#x9;                  SCM.setIntValue(Res,CCRval2);&#xD;&#xA;&#x9;                 }else if(value &lt;= (CCRval*8)){&#xD;&#xA;&#x9;                  var CCRval2 = CCRval*8;&#xD;&#xA;&#x9;                  SCM.setIntValue(Res,CCRval2);&#xD;&#xA;&#x9;                 }else if(value &lt;= (CCRval*9)){&#xD;&#xA;&#x9;                  var CCRval2 = CCRval*9;&#xD;&#xA;&#x9;                  SCM.setIntValue(Res,CCRval2);&#xD;&#xA;&#x9;                 }else if(value &lt;= (CCRval*10)){&#xD;&#xA;&#x9;                  var CCRval2 = CCRval*10;&#xD;&#xA;&#x9;                  SCM.setIntValue(Res,CCRval2);&#xD;&#xA;&#x9;                 }&#xD;&#xA;&#x9;                }&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}                    &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_scr&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res);&#xD;&#xA;              &#xD;&#xA;              var CCRRes = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;              var CCRval = SCM.getIntValue(CCRRes);&#xD;&#xA;                &#xD;&#xA;                if(value &lt;= CCRval){&#xD;&#xA;                 SCM.setIntValue(currentResource,CCRval); &#xD;&#xA;                }else{&#xD;&#xA;                 if(value &lt;= (CCRval*2)){&#xD;&#xA;                  var CCRval2 = CCRval*2;&#xD;&#xA;                  SCM.setIntValue(currentResource,CCRval2);&#xD;&#xA;                 }else if(value &lt;= (CCRval*3)){&#xD;&#xA;                  var CCRval2 = CCRval*3;&#xD;&#xA;                  SCM.setIntValue(currentResource,CCRval2);&#xD;&#xA;                 }else if(value &lt;= (CCRval*4)){&#xD;&#xA;                  var CCRval2 = CCRval*4;&#xD;&#xA;                  SCM.setIntValue(currentResource,CCRval2);&#xD;&#xA;                 }else if(value &lt;= (CCRval*5)){&#xD;&#xA;                  var CCRval2 = CCRval*5;&#xD;&#xA;                  SCM.setIntValue(currentResource,CCRval2);&#xD;&#xA;                 }else if(value &lt;= (CCRval*6)){&#xD;&#xA;                  var CCRval2 = CCRval*6;&#xD;&#xA;                  SCM.setIntValue(currentResource,CCRval2);&#xD;&#xA;                 }else if(value &lt;= (CCRval*7)){&#xD;&#xA;                  var CCRval2 = CCRval*7;&#xD;&#xA;                  SCM.setIntValue(currentResource,CCRval2);&#xD;&#xA;                 }else if(value &lt;= (CCRval*8)){&#xD;&#xA;                  var CCRval2 = CCRval*8;&#xD;&#xA;                  SCM.setIntValue(currentResource,CCRval2);&#xD;&#xA;                 }else if(value &lt;= (CCRval*9)){&#xD;&#xA;                  var CCRval2 = CCRval*9;&#xD;&#xA;                  SCM.setIntValue(currentResource,CCRval2);&#xD;&#xA;                 }else if(value &lt;= (CCRval*10)){&#xD;&#xA;                  var CCRval2 = CCRval*10;&#xD;&#xA;                  SCM.setIntValue(currentResource,CCRval2);&#xD;&#xA;                 }&#xD;&#xA;                }   &#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwscr" downWardmappedList="//@consumed.47" maxValue="64" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="9"/>
    <toolTipHelpDescription>This is the Speed Control Rate. &#xD;
The speed calculation will be executed every SCR times of the PWM period.&#xD;
SCR value should be multiple of CCR value.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Enable Auto Run" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_enable_autorun&quot;);&#xD;&#xA;              SCM.setIntValue(Res,value);        &#xD;&#xA;           &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_enable_autorun&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout0enableautorun" downWardmappedList="//@consumed.27" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>Enable Auto Run feature- after initilization, Motor start function will be called.</toolTipHelpDescription>
    <item name="Enable" evalFunction="          &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_enable_autorun&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,1);        &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_enable_autorun&quot;);&#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value == -1 ){&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout0enableautorun/0" downWardmappedList="//@consumed.27" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Enable Auto Run feature- after initilization, Motor start function will be called.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Enable Trap" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout0trap/0&quot;);&#xD;&#xA;              SCM.setIntValue(Res,value);        &#xD;&#xA;           &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout0trap/0&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout0enabletrap" downWardmappedList="//@consumed.64" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <toolTipHelpDescription>Enable trap feature. &#xD;
PWM output signal generation is stopped when trap condition is detected.</toolTipHelpDescription>
    <item name="Enable" evalFunction="          &#xD;&#xA;        function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout0trap/0&quot;);&#xD;&#xA;              var Res1 = SCM.getResource(&quot;svm/pwmsvm01_erwenabletrapint&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,1);  &#xD;&#xA;                SCM.setIntValue(Res1,1);                  &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;                SCM.setIntValue(Res1,0); &#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout0trap/0&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value == -1 ){&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout0enabletrap/0" downWardmappedList="//@consumed.64 //@consumed.82" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>Enable trap feature. &#xD;
PWM output signal generation is stopped when trap condition is detected.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Max Voltage Limit" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_max_volt_lim&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_max_volt_lim&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_max_volt_limt" downWardmappedList="//@consumed.18" maxValue="64" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="64"/>
    <localValue xsi:type="ResourceModel:StringValue" value="64"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="64"/>
    <toolTipHelpDescription>This is the maximum voltage amplitude limit.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Enable Pot" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout0enablepot" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Enable potentiometer.</toolTipHelpDescription>
    <item name="Enable" evalFunction="          &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_pm&quot;);&#xD;&#xA;&#xD;&#xA;              var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical5/ch62&quot;);  &#xD;&#xA;              var RefRes = SCM.getResource(&quot;queueapp/adc002_erwrefill5&quot;);&#xD;&#xA;&#xD;&#xA;              var ChNoRes = SCM.getResource(&quot;queueapp/adc002_irwchannelnum&quot;);&#xD;&#xA;&#xD;&#xA;              var ChNo =0;&#xD;&#xA;&#xD;&#xA;              var VoltRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical4/ch51&quot;);&#xD;&#xA;              var VoltVal = SCM.getIntValue(VoltRes);&#xD;&#xA;&#xD;&#xA;              if (value == 1 ){ &#xD;&#xA;                ChNo =3;&#xD;&#xA;              }&#xD;&#xA;              else if( (VoltVal == 1) &amp;&amp; (value != 1) )&#xD;&#xA;              {&#xD;&#xA;                ChNo =2;&#xD;&#xA;              }   &#xD;&#xA;              else &#xD;&#xA;              {&#xD;&#xA;                ChNo =1;&#xD;&#xA;              } &#xD;&#xA;  &#xD;&#xA;           if (value == 1 ){ &#xD;&#xA;             SCM.setIntValue(Res,1);&#xD;&#xA;             SCM.setIntValue(CurRes,1);&#xD;&#xA;             SCM.setIntValue(RefRes,1);&#xD;&#xA;             SCM.setIntValue(ChNoRes,ChNo);&#xD;&#xA;           } else {&#xD;&#xA;             SCM.setIntValue(Res,0);&#xD;&#xA;             SCM.setIntValue(CurRes,0);&#xD;&#xA;             SCM.setIntValue(RefRes,0);&#xD;&#xA;             SCM.setIntValue(ChNoRes,ChNo);&#xD;&#xA;           }    &#xD;&#xA;             var dep = &quot;DependentApp&quot;; &#xD;&#xA;             var queueapp3 = SCM.getResource(&quot;queueapp3&quot;); &#xD;&#xA;             SCM.setStringValue(queueapp3,dep); &#xD;&#xA;             var queueapp2 = SCM.getResource(&quot;queueapp2&quot;); &#xD;&#xA;             SCM.setStringValue(queueapp2,dep);  &#xD;&#xA;        }&#xD;&#xA;&#xD;&#xA;         function BackwardMapping()&#xD;&#xA;         {&#xD;&#xA;            var Res = SCM.getResource(&quot;temp_pm&quot;); &#xD;&#xA;            var value = SCM.getIntValue(Res); &#xD;&#xA;            if (value == 1 ) { &#xD;&#xA;              SCM.setIntValue(currentResource,1);&#xD;&#xA;            } else {&#xD;&#xA;              SCM.setIntValue(currentResource,0);&#xD;&#xA;            }&#xD;&#xA;         }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout0enablepot/0" downWardmappedList="//@consumed.16 //@consumed.98 //@consumed.104 //@consumed.86 //@consumed.57 //@consumed.56" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Enable potentiometer to read the speed reference value.&#xD;
Channel C in the Queue is assigned for potentiometer measurement. Please assign correct pin to the&#xD;
IO001 App consumed by Channel C.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="BootStrap Enable" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_bs&quot;);&#xD;&#xA;              SCM.setIntValue(Res,value);                &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_bs&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwbootstrap" downWardmappedList="//@consumed.33" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>Enables/Disables Bootstrap configuration</toolTipHelpDescription>
    <item name="Enable" evalFunction="          &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_bs&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,1);        &#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_bs&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwbootstrap/0" downWardmappedList="//@consumed.33" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Enables/Disables Bootstrap configuration</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="BootStrap Count" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_bsvalue&quot;);&#xD;&#xA;                SCM.setDoubleValue(Res,value); &#xD;&#xA;&#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_bsvalue&quot;); &#xD;&#xA;                var value = SCM.getDoubleValue(Res); &#xD;&#xA;                SCM.setDoubleValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwbsvalue" downWardmappedList="//@consumed.34" maxValue="EA60" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="2"/>
    <localValue xsi:type="ResourceModel:StringValue" value="2"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="2"/>
    <toolTipHelpDescription>This allows the user to enter bootstrap&#xD;
count value in msec.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Enable Voltage Compensation" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwevoltagecomp" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Enable voltage compensation feature.</toolTipHelpDescription>
    <item name="Enable" evalFunction="          &#xD;&#xA;          function ForwardMapping()&#xD;&#xA;          {&#xD;&#xA;            var value = SCM.getIntValue(currentResource);&#xD;&#xA;            var Res = SCM.getResource(&quot;temp_vc&quot;);      &#xD;&#xA;&#xD;&#xA;            var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical4/ch51&quot;);  &#xD;&#xA;            var RefRes = SCM.getResource(&quot;queueapp/adc002_erwrefill4&quot;);&#xD;&#xA;&#xD;&#xA;            var Q2VcRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical4/ch51&quot;);&#xD;&#xA;            var Q2RefRes = SCM.getResource(&quot;queueapp2/adc002_erwrefill4&quot;);&#xD;&#xA;&#xD;&#xA;            var ChNoRes = SCM.getResource(&quot;queueapp/adc002_irwchannelnum&quot;);&#xD;&#xA;&#xD;&#xA;            var ChNo =0;&#xD;&#xA;            var PotRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical5/ch62&quot;);&#xD;&#xA;            var PotVal = SCM.getIntValue(PotRes);&#xD;&#xA;&#xD;&#xA;            if (PotVal == 1){ &#xD;&#xA;                    ChNo =3;&#xD;&#xA;            }&#xD;&#xA;            else if( (value == 1) &amp;&amp; (PotVal != 1) )&#xD;&#xA;            {&#xD;&#xA;                  ChNo =2;&#xD;&#xA;            }   &#xD;&#xA;            else &#xD;&#xA;            {&#xD;&#xA;                  ChNo =1;&#xD;&#xA;            }      &#xD;&#xA;            if (value == 1 ){ &#xD;&#xA;               SCM.setIntValue(Res,1);&#xD;&#xA;               SCM.setIntValue(CurRes,1);&#xD;&#xA;               SCM.setIntValue(RefRes,1);&#xD;&#xA;               SCM.setIntValue(ChNoRes,ChNo);&#xD;&#xA;               SCM.setIntValue(Q2VcRes,0);&#xD;&#xA;            } else {&#xD;&#xA;               SCM.setIntValue(Res,0);&#xD;&#xA;               SCM.setIntValue(CurRes,0);&#xD;&#xA;               SCM.setIntValue(RefRes,0);&#xD;&#xA;               SCM.setIntValue(ChNoRes,ChNo);&#xD;&#xA;               SCM.setIntValue(Q2VcRes,0);&#xD;&#xA;               SCM.setIntValue(Q2RefRes,0);&#xD;&#xA;            } &#xD;&#xA;            var dep = &quot;DependentApp&quot;; &#xD;&#xA;            var queueapp3 = SCM.getResource(&quot;queueapp3&quot;); &#xD;&#xA;            SCM.setStringValue(queueapp3,dep); &#xD;&#xA;            var queueapp2 = SCM.getResource(&quot;queueapp2&quot;); &#xD;&#xA;            SCM.setStringValue(queueapp2,dep);      &#xD;&#xA;      }&#xD;&#xA;       function BackwardMapping()&#xD;&#xA;       {&#xD;&#xA;           var Res = SCM.getResource(&quot;temp_vc&quot;); &#xD;&#xA;           var value = SCM.getIntValue(Res); &#xD;&#xA;           if (value == 1 ) { &#xD;&#xA;              SCM.setIntValue(currentResource,1);&#xD;&#xA;           } else {&#xD;&#xA;              SCM.setIntValue(currentResource,0);&#xD;&#xA;           }&#xD;&#xA;       }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwevoltagecomp/0" downWardmappedList="//@consumed.15 //@consumed.96 //@consumed.103 //@consumed.86 //@consumed.124 //@consumed.131 //@consumed.57 //@consumed.56" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Enable voltage compensation feature.&#xD;
Channel B in the Queue is assigned for voltage measurement. Please assign correct pin to the&#xD;
IO001 App consumed by Channel B.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="DC Link Voltage(Vdc)" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_dc_voltage&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_dc_voltage&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwdclinkvoltage" downWardmappedList="//@consumed.30" maxValue="7FFF" minValue="C">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="18"/>
    <localValue xsi:type="ResourceModel:StringValue" value="18"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="18"/>
    <toolTipHelpDescription>This is the Dc link voltage.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Dead Time" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;          {&#xD;&#xA;            var tmintime=0;&#xD;&#xA;            var rise = SCM.getDoubleValue(currentResource);&#xD;&#xA;            var Res = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;            SCM.setDoubleValue(Res, rise);&#xD;&#xA;&#xD;&#xA;            var ResSwitchdelay = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;);&#xD;&#xA;            var valueSwitchdelay = SCM.getDoubleValue(ResSwitchdelay); &#xD;&#xA;            var ResTmin = SCM.getResource(&quot;svm/pwmsvm01_irwtmin&quot;);              &#xD;&#xA;            var tminVal = (valueSwitchdelay+rise+100)/1000;&#xD;&#xA;            SCM.setDoubleValue(ResTmin,tminVal); &#xD;&#xA;&#xD;&#xA;          }&#xD;&#xA;          function BackwardMapping()&#xD;&#xA;          {&#xD;&#xA;            var tempRes = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;            var value = SCM.getDoubleValue(tempRes);&#xD;&#xA;            SCM.setDoubleValue(currentResource, value);&#xD;&#xA;          } &#xD;&#xA;" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwrisedeadtime" downWardmappedList="//@consumed.69 //@consumed.78" maxValue="2710" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="1F4"/>
    <localValue xsi:type="ResourceModel:StringValue" value="1F4"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f4"/>
    <toolTipHelpDescription>Enter dead time value.&#xD;
Dead time is required to avoid short-circuit in switches.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Switch Delay" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var tmintime=0;&#xD;&#xA;                var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;);&#xD;&#xA;                SCM.setDoubleValue(Res,value); &#xD;&#xA;&#xD;&#xA;                var Resdeadtime = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;                var valuedeadtime = SCM.getDoubleValue(Resdeadtime); &#xD;&#xA;                var ResTmin = SCM.getResource(&quot;svm/pwmsvm01_irwtmin&quot;);              &#xD;&#xA;                var tminVal = (valuedeadtime+value+100)/1000;&#xD;&#xA;                SCM.setDoubleValue(ResTmin,tminVal); &#xD;&#xA;&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;); &#xD;&#xA;                var value = SCM.getDoubleValue(Res); &#xD;&#xA;                SCM.setDoubleValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwswitchdelay" downWardmappedList="//@consumed.79 //@consumed.78" maxValue="2710" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="IF4"/>
    <localValue xsi:type="ResourceModel:StringValue" value="IF4"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f4"/>
    <toolTipHelpDescription>Enter switch delay value.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Direct Output" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout0passivelevel&quot;);&#xD;&#xA;              SCM.setIntValue(Res,value);        &#xD;&#xA;           &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout0passivelevel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout0passivelevel" downWardmappedList="//@consumed.62">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>This allows a user to select passive level for high side switch - low or high&#xD;
first, third and fifth IO002 handle (consumed by PWMSVM01 App) are used for high side switch</toolTipHelpDescription>
    <item name="Low('0')" evalFunction="&#xD;&#xA;      function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout0passivelevel&quot;);&#xD;&#xA;&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                if(XMC1302==0) {&#xD;&#xA;                    SCM.setIntValue(Res,0);&#xD;&#xA;                } else if (XMC4500 == 0) {&#xD;&#xA;                    SCM.setIntValue(Res,1);&#xD;&#xA;                }&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout0passivelevel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value === 0 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value == -1 ){&#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }          &#xD;&#xA;          " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout0passivelevel/0" downWardmappedList="//@consumed.62" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>Selects Active Low as Passive Level for output 0</toolTipHelpDescription>
    </item>
    <item name="High('1')" evalFunction="          &#xD;&#xA;         function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout0passivelevel&quot;);&#xD;&#xA;&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,1);        &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                if(XMC1302==0) {&#xD;&#xA;                    SCM.setIntValue(Res,0);&#xD;&#xA;                } else if (XMC4500 == 0) {&#xD;&#xA;                    SCM.setIntValue(Res,1);&#xD;&#xA;                }&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout0passivelevel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value == -1 ){&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout0passivelevel/1" downWardmappedList="//@consumed.62" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Selects Active High as Passive Level for output 0</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Inverted Output" evalFunction="          &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout1passivelevel&quot;);&#xD;&#xA;              SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout1passivelevel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout1passivelevel" downWardmappedList="//@consumed.63">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>This allows a user to select passive level for low side switch - low or high&#xD;
second, fourth and sixth IO002 handle (consumed by PWMSVM01 App) are used for high side switch</toolTipHelpDescription>
    <item name="Low('0')" evalFunction="          &#xD;&#xA;      function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout1passivelevel&quot;);&#xD;&#xA;&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,0);        &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                if(XMC1302==0) {&#xD;&#xA;                    SCM.setIntValue(Res,0);&#xD;&#xA;                } else if (XMC4500 == 0) {&#xD;&#xA;                    SCM.setIntValue(Res,1);&#xD;&#xA;                }&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout1passivelevel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value === 0 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value == -1 ){&#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }&#xD;&#xA;          " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout1passivelevel/0" downWardmappedList="//@consumed.63" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>Selects Active Low as Passive Level for output 1</toolTipHelpDescription>
    </item>
    <item name="High('1')" evalFunction="          &#xD;&#xA;      function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout1passivelevel&quot;);&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,1);        &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                if(XMC1302==0) {&#xD;&#xA;                    SCM.setIntValue(Res,0);&#xD;&#xA;                } else if (XMC4500 == 0) {&#xD;&#xA;                    SCM.setIntValue(Res,1);&#xD;&#xA;                }&#xD;&#xA;              }            &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwout1passivelevel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value === 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value == -1 ){&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }        &#xD;&#xA;          " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwout1passivelevel/1" downWardmappedList="//@consumed.63" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Selects Active High as Passive Level for output 1</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Rshunt" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if(value==0){&#xD;&#xA;                if(XMC1302==0){&#xD;&#xA;                  SCM.setDoubleValue(Res,50); &#xD;&#xA;                } else if(XMC4500==0) {&#xD;&#xA;                  SCM.setDoubleValue(Res,10); &#xD;&#xA;                }&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setDoubleValue(Res,value); &#xD;&#xA;              }                 &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_shunt_res&quot;); &#xD;&#xA;                var value = SCM.getDoubleValue(Res); &#xD;&#xA;                SCM.setDoubleValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwshuntresistance" downWardmappedList="//@consumed.48" maxValue="2710" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="32"/>
    <toolTipHelpDescription>This is the DC link current shunt resistor value.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Ag" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;                var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;                var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if(value==0){&#xD;&#xA;                if(XMC1302==0){&#xD;&#xA;                  SCM.setDoubleValue(Res,16); &#xD;&#xA;                } else if(XMC4500==0) {&#xD;&#xA;                  SCM.setDoubleValue(Res,21); &#xD;&#xA;                }&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setDoubleValue(Res,value); &#xD;&#xA;              }                 &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_curnt_gain&quot;); &#xD;&#xA;                var value = SCM.getDoubleValue(Res); &#xD;&#xA;                SCM.setDoubleValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwcurrentgain" downWardmappedList="//@consumed.49" maxValue="3E8" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="10"/>
    <toolTipHelpDescription>This is the DC link current amplifier gain of the motor.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Amplifier Bias Voltage Calibration" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwampbiasvoltcal" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Enable/Disable Amplifier Bias Voltage Calibration.</toolTipHelpDescription>
    <item name="Enable" evalFunction="          &#xD;&#xA;        function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;          var Res = SCM.getResource(&quot;temp_biasvoltcal&quot;);&#xD;&#xA;          if (value == 1 ) {&#xD;&#xA;            SCM.setIntValue(Res,1);                   &#xD;&#xA;          } else {&#xD;&#xA;            SCM.setIntValue(Res,0);&#xD;&#xA;          }              &#xD;&#xA;        }&#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var Res = SCM.getResource(&quot;temp_biasvoltcal&quot;); &#xD;&#xA;          var value = SCM.getIntValue(Res); &#xD;&#xA;          if (value == 1 ) { &#xD;&#xA;            SCM.setIntValue(currentResource,1);&#xD;&#xA;          } else {&#xD;&#xA;            SCM.setIntValue(currentResource,0);&#xD;&#xA;          }&#xD;&#xA;        }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwampbiasvoltcal/0" downWardmappedList="//@consumed.0" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>Enable/Disable Amplifier Bias Voltage Calibration.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Amplifier Bias Voltage" evalFunction="&#xD;&#xA;    function ForwardMapping()&#xD;&#xA;    {&#xD;&#xA;      var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;      var Res = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;      var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;      var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;&#x9;   if(value==32768){&#xD;&#xA;&#x9;    if(XMC1302==0){&#xD;&#xA;&#x9;      SCM.setDoubleValue(Res,2500); &#xD;&#xA;&#x9;    } else if(XMC4500==0) {&#xD;&#xA;&#x9;      SCM.setDoubleValue(Res,0); &#xD;&#xA;&#x9;    }&#xD;&#xA;&#x9;  } else {&#xD;&#xA;&#x9;    SCM.setDoubleValue(Res,value); &#xD;&#xA;&#x9;  }  &#xD;&#xA;&#xD;&#xA;      var VadcRefRes = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;      var VadcRefVal = SCM.getDoubleValue(VadcRefRes);     &#xD;&#xA;    }&#xD;&#xA;    function BackwardMapping()&#xD;&#xA;    {&#xD;&#xA;      var Res = SCM.getResource(&quot;temp_biasvoltage&quot;); &#xD;&#xA;      var value = SCM.getDoubleValue(Res);&#xD;&#xA;&#xD;&#xA;      var VadcRefRes = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;      var VadcRefVal = SCM.getDoubleValue(VadcRefRes);&#xD;&#xA; &#xD;&#xA;      SCM.setDoubleValue(currentResource,value);&#xD;&#xA;&#xD;&#xA;      SCM.setMinMaxValue(currentResource,0,VadcRefVal,1);&#xD;&#xA;&#xD;&#xA;    }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwampbiasvoltage" downWardmappedList="//@consumed.1" maxValue="1388" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="9c4"/>
    <toolTipHelpDescription>This is the Amplifier Bias Voltage.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Max Current" evalFunction="&#xD;&#xA;      function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;            var Res1 = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;            var value1 = SCM.getDoubleValue(Res1);&#xD;&#xA;&#xD;&#xA;            var Res2 = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;            var value2 = SCM.getDoubleValue(Res2);&#xD;&#xA;&#xD;&#xA;            var Res3 = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;            var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;            var Bias_Res3 = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;            var value4 = SCM.getDoubleValue(Bias_Res3);&#xD;&#xA;        }&#xD;&#xA;&#xD;&#xA;         function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;           var Res1 = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;            var value1 = SCM.getDoubleValue(Res1);&#xD;&#xA;&#xD;&#xA;            var Res2 = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;            var value2 = SCM.getDoubleValue(Res2);&#xD;&#xA;&#xD;&#xA;            var Res3 = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;            var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;            var Bias_Res3 = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;            var value4 = SCM.getDoubleValue(Bias_Res3);&#xD;&#xA;&#xD;&#xA;      var value = ((value3-value4)/(value1*value2));&#xD;&#xA;&#xD;&#xA;      SCM.setDoubleValue(currentResource,value);      &#xD;&#xA;    }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwmaxcurrent" maxValue="2710" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="4009000000000000"/>
    <toolTipHelpDescription>This is the maximum current that can be measured&#xD;
with the given motor and VADC parameters.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Nominal Voltage*" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_nominal_voltage&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_nominal_voltage&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwnominalvoltage" downWardmappedList="//@consumed.32" maxValue="7FFF" minValue="C">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="18"/>
    <localValue xsi:type="ResourceModel:StringValue" value="18"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="18"/>
    <toolTipHelpDescription>This is the nominal voltage of motor.&#xD;
This is the mandatory parameter for the motor control algorithm.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Nominal Current*" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_nominal_current&quot;);&#xD;&#xA;                SCM.setDoubleValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_nominal_current&quot;); &#xD;&#xA;                var value = SCM.getDoubleValue(Res); &#xD;&#xA;                SCM.setDoubleValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwnominalcurrent" downWardmappedList="//@consumed.35" maxValue="186A0" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="26C"/>
    <localValue xsi:type="ResourceModel:StringValue" value="1f3"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f3"/>
    <toolTipHelpDescription>This is the nominal current of motor.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Nominal Speed*" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_nominal_speed&quot;);&#xD;&#xA;             var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4xxx = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if(value==0){&#xD;&#xA;                if(XMC1302==0){&#xD;&#xA;                  SCM.setIntValue(Res,4400); &#xD;&#xA;                } else if(XMC4xxx==0) {&#xD;&#xA;                  SCM.setIntValue(Res,4000); &#xD;&#xA;                }&#xD;&#xA;               }  &#xD;&#xA;              else{&#xD;&#xA;              SCM.setIntValue(Res,value);&#xD;&#xA;              }   &#xD;&#xA;&#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_nominal_speed&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwnominalspeed" downWardmappedList="//@consumed.38" maxValue="FFFF" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="ac8"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="ac8"/>
    <toolTipHelpDescription>This is the nominal speed of motor.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Nominal Frequency*" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_nominal_frequency&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_nominal_frequency&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwnominalfrequency" downWardmappedList="//@consumed.39" maxValue="64" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="32"/>
    <localValue xsi:type="ResourceModel:StringValue" value="32"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="32"/>
    <toolTipHelpDescription>This is the nominal frequency of motor.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Nominal Torque" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_nominal_torque&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_nominal_torque&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwnominaltorque" downWardmappedList="//@consumed.40" maxValue="7FFF" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="100"/>
    <localValue xsi:type="ResourceModel:StringValue" value="4039800000000000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="4039800000000000"/>
    <toolTipHelpDescription>This is the nominal torque of motor.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Phase Resistance*" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_phase_res&quot;);&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4xxx = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if(value==0){&#xD;&#xA;                if(XMC1302==0){&#xD;&#xA;                  SCM.setIntValue(Res,13700); &#xD;&#xA;                } else if(XMC4xxx==0) {&#xD;&#xA;                  SCM.setIntValue(Res,1500); &#xD;&#xA;                }&#xD;&#xA;               }  &#xD;&#xA;              else{&#xD;&#xA;              SCM.setIntValue(Res,value);&#xD;&#xA;              }          &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_phase_res&quot;); &#xD;&#xA;                var value = SCM.getDoubleValue(Res); &#xD;&#xA;                SCM.setDoubleValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwphaseresistance" downWardmappedList="//@consumed.41" maxValue="186A0" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="3584"/>
    <toolTipHelpDescription>This is phase to phase resistance of motor.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Phase Inductance" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_phase_ind&quot;);&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4xxx = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if(value==0){&#xD;&#xA;                if(XMC1302==0){&#xD;&#xA;                  SCM.setIntValue(Res,7730); &#xD;&#xA;                } else if(XMC4xxx==0) {&#xD;&#xA;                  SCM.setIntValue(Res,2100); &#xD;&#xA;                }&#xD;&#xA;               }  &#xD;&#xA;              else{&#xD;&#xA;              SCM.setIntValue(Res,value);&#xD;&#xA;              }        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_phase_ind&quot;); &#xD;&#xA;                var value = SCM.getDoubleValue(Res); &#xD;&#xA;                SCM.setDoubleValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwphaseinductance" downWardmappedList="//@consumed.42" maxValue="5F5E100" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1e32"/>
    <toolTipHelpDescription>This is the phase inductance of motor.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Pole Pairs*" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_pole_pair&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_pole_pair&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwmotorpolepairs" downWardmappedList="//@consumed.28" maxValue="28" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="4"/>
    <localValue xsi:type="ResourceModel:StringValue" value="4"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="4"/>
    <toolTipHelpDescription>This is the number of motor pole pairs.&#xD;
This is the mandatory parameter for the motor control algorithm.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:StringParameter" name="Interrupt" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_period_match">
    <defaultValue xsi:type="ResourceModel:StringValue" value="PMSMFOCSL01_PWMPeriodMatchISR&lt;A/B>"/>
    <localValue xsi:type="ResourceModel:StringValue" value="PMSMFOCSL01_PWMPeriodMatchISR&lt;A/B>"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="PMSMFOCSL01_PWMPeriodMatchISR&lt;A/B>"/>
    <toolTipHelpDescription>This displays the interrupt handler name used for&#xD;
period match interrupt.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Preemption Priority" evalFunction="&#xD;&#xA;         function ForwardMapping(){&#xD;&#xA;              var rise = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_slice_0_Int_prio&quot;);&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if(rise==101){&#xD;&#xA;                if(XMC1302==0){&#xD;&#xA;                  SCM.setIntValue(Res,3); &#xD;&#xA;                } else if(XMC4500==0) {&#xD;&#xA;                  SCM.setIntValue(Res,62); &#xD;&#xA;                }&#xD;&#xA;               }  &#xD;&#xA;              else{&#xD;&#xA;              SCM.setIntValue(Res,rise);&#xD;&#xA;              }&#xD;&#xA;          }&#xD;&#xA;          function BackwardMapping(){&#xD;&#xA;              var tempRes = SCM.getResource(&quot;temp_slice_0_Int_prio&quot;);&#xD;&#xA;              var value = SCM.getIntValue(tempRes);&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              if(XMC1302==0){&#xD;&#xA;               if(value > 3){&#xD;&#xA;                  SCM.setIntValue(currentResource,3); &#xD;&#xA;                }&#xD;&#xA;               else{&#xD;&#xA;               SCM.setIntValue(currentResource,value); &#xD;&#xA;               }&#xD;&#xA;              }&#xD;&#xA;              else{&#xD;&#xA;              SCM.setIntValue(currentResource,value);  &#xD;&#xA;             }     &#xD;&#xA;          } " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_slice_0_int_prio" downWardmappedList="//@consumed.23" maxValue="3F" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <localValue xsi:type="ResourceModel:StringValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="3"/>
    <toolTipHelpDescription>This allows a user to configure the interrupt priority.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Sub Priority" evalFunction="&#xD;&#xA;         function ForwardMapping(){&#xD;&#xA;              var rise = SCM.getIntValue(currentResource);&#xD;&#xA;        var Res = SCM.getResource(&quot;temp_slice_0_Int_sub_prio&quot;);&#xD;&#xA;        SCM.setIntValue(Res, rise);    &#xD;&#xA;&#xD;&#xA;          }&#xD;&#xA;          function BackwardMapping(){&#xD;&#xA;              var tempRes = SCM.getResource(&quot;temp_slice_0_Int_sub_prio&quot;);&#xD;&#xA;              var value = SCM.getIntValue(tempRes);&#xD;&#xA;              SCM.setIntValue(currentResource,value);       &#xD;&#xA;          } " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_slice_0_int_sub_prio" downWardmappedList="//@consumed.26" maxValue="63" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>This allows a user to configure interrupt sub priority.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:StringParameter" name="Trap Interrupt" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_srtrap">
    <defaultValue xsi:type="ResourceModel:StringValue" value="PMSMFOCSL01_TrapPhaseVOneMatchISR&lt;A/B>"/>
    <localValue xsi:type="ResourceModel:StringValue" value="PMSMFOCSL01_TrapPhaseVOneMatchISR&lt;A/B>"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="PMSMFOCSL01_TrapPhaseVOneMatchISR&lt;A/B>"/>
    <toolTipHelpDescription>This displays the interrupt handler name&#xD;
used by trap and Phase V one match interrupt.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Trap Preemption Priority" evalFunction="&#xD;&#xA;         function ForwardMapping(){&#xD;&#xA;              var rise = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_trap_0_Int_prio&quot;);&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if(rise==101){&#xD;&#xA;                if(XMC1302==0){&#xD;&#xA;                  SCM.setIntValue(Res,1); &#xD;&#xA;                } else if(XMC4500==0) {&#xD;&#xA;                  SCM.setIntValue(Res,60); &#xD;&#xA;                }&#xD;&#xA;               } &#xD;&#xA;              else{&#xD;&#xA;              SCM.setIntValue(Res,rise);&#xD;&#xA;              } &#xD;&#xA;          }&#xD;&#xA;          function BackwardMapping(){&#xD;&#xA;              var tempRes = SCM.getResource(&quot;temp_trap_0_Int_prio&quot;);&#xD;&#xA;              var value = SCM.getIntValue(tempRes);&#xD;&#xA;             var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              if(XMC1302==0){&#xD;&#xA;               if(value > 3){&#xD;&#xA;                  SCM.setIntValue(currentResource,3); &#xD;&#xA;                }&#xD;&#xA;               else{&#xD;&#xA;               SCM.setIntValue(currentResource,value); &#xD;&#xA;               }&#xD;&#xA;              }&#xD;&#xA;              else{&#xD;&#xA;              SCM.setIntValue(currentResource,value);  &#xD;&#xA;             }     &#xD;&#xA;          }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_trapprio" downWardmappedList="//@consumed.24" maxValue="3F" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <localValue xsi:type="ResourceModel:StringValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <toolTipHelpDescription>This allows a user to configure the interrupt priority.&#xD;
it is recommended to have the highest priority for the trap interrupt.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Trap Sub Priority" evalFunction="&#xD;&#xA;" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_trap_sub_prio" maxValue="3F" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>This allows a user to configure interrupt sub priority.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:StringParameter" name="Slice 3 Compare Match Interrupt" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_srslice3cminterrupthandler">
    <defaultValue xsi:type="ResourceModel:StringValue" value="pmsmfocsl01_CurrentMeasureISR&lt;A/B>"/>
    <localValue xsi:type="ResourceModel:StringValue" value="pmsmfocsl01_CurrentMeasureISR&lt;A/B>"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="pmsmfocsl01_CurrentMeasureISR&lt;A/B>"/>
    <toolTipHelpDescription>This displays the interrupt handler name&#xD;
used by current trigger interrupt.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Slice 3 Preemption Priority" evalFunction="&#xD;&#xA;         function ForwardMapping(){&#xD;&#xA;              var rise = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_slice_3_Int_prio&quot;);&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;              if(rise==101){&#xD;&#xA;                if(XMC1302==0){&#xD;&#xA;                  SCM.setIntValue(Res,3); &#xD;&#xA;                } else if(XMC4500==0) {&#xD;&#xA;                  SCM.setIntValue(Res,62); &#xD;&#xA;                }&#xD;&#xA;               }  &#xD;&#xA;              else{&#xD;&#xA;              SCM.setIntValue(Res,rise);&#xD;&#xA;              } &#xD;&#xA;          }&#xD;&#xA;          function BackwardMapping(){&#xD;&#xA;              var tempRes = SCM.getResource(&quot;temp_slice_3_Int_prio&quot;);&#xD;&#xA;              var value = SCM.getIntValue(tempRes);&#xD;&#xA;              var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;              if(XMC1302==0){&#xD;&#xA;               if(value > 3){&#xD;&#xA;                  SCM.setIntValue(currentResource,3); &#xD;&#xA;                }&#xD;&#xA;               else{&#xD;&#xA;               SCM.setIntValue(currentResource,value); &#xD;&#xA;               }&#xD;&#xA;              }&#xD;&#xA;              else{&#xD;&#xA;              SCM.setIntValue(currentResource,value);  &#xD;&#xA;             }      &#xD;&#xA;          }&#xD;&#xA;" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwslice3prio" downWardmappedList="//@consumed.25" maxValue="3F" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <localValue xsi:type="ResourceModel:StringValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="3"/>
    <toolTipHelpDescription>This allows a user to configure the interrupt priority.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Slice 3 Sub Priority" evalFunction="&#xD;&#xA;" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwslice3subprio" maxValue="3F" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>This allows a user to configure interrupt sub priority.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Enable Interrupt" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwenable_pm_int" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <localValue xsi:type="ResourceModel:StringValue" value="1"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="1"/>
    <toolTipHelpDescription>This allows a user to enable the PWM intrrupt</toolTipHelpDescription>
    <item name="Enable PWM Interrupt" evalFunction="&#xD;&#xA;                  function ForwardMapping()&#xD;&#xA;                  {&#xD;&#xA;                      var value = SCM.getIntValue(currentResource);&#xD;&#xA;                      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwenable_pm_int&quot;);&#xD;&#xA;                      SCM.setIntValue(Res,1);        &#xD;&#xA;                  }&#xD;&#xA;                   function BackwardMapping()&#xD;&#xA;                  {&#xD;&#xA;                      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwenable_pm_int&quot;); &#xD;&#xA;                      var value = SCM.getIntValue(Res); &#xD;&#xA;                      SCM.setIntValue(currentResource,value);&#xD;&#xA;                  }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwenable_pm_int/0" downWardmappedList="//@consumed.61" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>This allows a user to enable phase U period match interrupt. </toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="End Speed Reference" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_ref_motor_speed&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_ref_motor_speed&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwmotorspeed" downWardmappedList="//@consumed.29" maxValue="FFFF" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="5DC"/>
    <localValue xsi:type="ResourceModel:StringValue" value="5DC"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="5dc"/>
    <toolTipHelpDescription>This is the motor end speed reference.&#xD;
Please note that the speed value should be less than the maximum speed and greater than start speed reference.&#xD;
This condition is not checked in the GUI</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Start Speed Reference" evalFunction=" " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwmotorstartspeed" maxValue="FFFF" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="32"/>
    <localValue xsi:type="ResourceModel:StringValue" value="32"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="32"/>
    <toolTipHelpDescription>This is the start reference speed of the motor.&#xD;
Please note that the speed value should be less than the maximum speed and less than end speed reference. &#xD;
This condition is not checked in the GUI</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Start Speed Threshold" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_threshold&quot;);&#xD;&#xA;                var Respolepair = SCM.getResource(&quot;temp_pole_pair&quot;);&#xD;&#xA;                var Valpolepair = SCM.getIntValue(Respolepair);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_threshold&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;               var Respolepair = SCM.getResource(&quot;temp_pole_pair&quot;);&#xD;&#xA;                var Valpolepair = SCM.getIntValue(Respolepair);&#xD;&#xA;&#x9;&#x9;&#x9;    if (value==32768){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  value=800/Valpolepair;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  if(value&lt;100)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;   value=100;&#xD;&#xA;                } &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwmotorstartspeedthresh" downWardmappedList="//@consumed.36" maxValue="7FFF" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="c8"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="c8"/>
    <toolTipHelpDescription>This is the start speed threshold. &#xD;
The motor will switch to FOC mode at this value .</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Speed Slew Rate" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_slew_rate&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_slew_rate&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwslewrate" downWardmappedList="//@consumed.44" maxValue="2710" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="1F4"/>
    <localValue xsi:type="ResourceModel:StringValue" value="1f4"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f4"/>
    <toolTipHelpDescription>This is the value of speed slew rate which is given in RPM/S.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Configuration Options" evalFunction="&#xD;&#xA;      function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              SCM.setIntValue(Res,value);        &#xD;&#xA;           &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_config&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwconfigdefault" downWardmappedList="//@consumed.50">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <toolTipHelpDescription>This allow the user to choose the configuration options&#xD;
for V/F Constant and Voltage Offset and PI controller configurations.</toolTipHelpDescription>
    <item name="Default" evalFunction="&#xD;&#xA;      function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,0);        &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res,1);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_config&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value === 0 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value == -1 ){&#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }          &#xD;&#xA;          " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwconfigdefault/0" downWardmappedList="//@consumed.50" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>This option calculate the default values.</toolTipHelpDescription>
    </item>
    <item name="User Defined" evalFunction="          &#xD;&#xA;         function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,1);        &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_config&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value == -1 ){&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwconfigdefault/1" downWardmappedList="//@consumed.50" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>This option allows user to enter the user define values.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="V/F Startup" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwvfstartup" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Enable/Disable v/f control for open loop motor startup.</toolTipHelpDescription>
    <item name="Enable" evalFunction="          &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_startup&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,1);                   &#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_startup&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwvfstartup/0" downWardmappedList="//@consumed.14" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>Enable/Disable v/f control for open loop motor startup.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Motor Direction" evalFunction="&#xD;&#xA;    function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;          var Res = SCM.getResource(&quot;temp_motdir&quot;);&#xD;&#xA;          SCM.setIntValue(Res,value);             &#xD;&#xA;        }&#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var Res = SCM.getResource(&quot;temp_motdir&quot;); &#xD;&#xA;          var value = SCM.getIntValue(Res); &#xD;&#xA;          SCM.setIntValue(currentResource,value);&#xD;&#xA;        }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwmotordir" downWardmappedList="//@consumed.17">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>This allows a user to choose the motor direction.</toolTipHelpDescription>
    <item name="Forward Direction" evalFunction="&#xD;&#xA;  function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;          var Res = SCM.getResource(&quot;temp_motdir&quot;);&#xD;&#xA;          if (value == 1 ) {&#xD;&#xA;            SCM.setIntValue(Res,0);        &#xD;&#xA;          } else if (value == 0) {&#xD;&#xA;            SCM.setIntValue(Res,1);&#xD;&#xA;          }              &#xD;&#xA;        }&#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var Res = SCM.getResource(&quot;temp_motdir&quot;); &#xD;&#xA;          var value = SCM.getIntValue(Res); &#xD;&#xA;          if (value === 0 ) { &#xD;&#xA;            SCM.setIntValue(currentResource,1);&#xD;&#xA;          } else if (value == -1 ){&#xD;&#xA;            SCM.setIntValue(currentResource,1);&#xD;&#xA;          }&#xD;&#xA;          else {&#xD;&#xA;            SCM.setIntValue(currentResource,0);&#xD;&#xA;          }&#xD;&#xA;        }          &#xD;&#xA;      " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwmotordir/0" downWardmappedList="//@consumed.17" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>This allows the user to choose the motor direction as forward.</toolTipHelpDescription>
    </item>
    <item name="Reverse Direction" evalFunction="          &#xD;&#xA;     function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;          var Res = SCM.getResource(&quot;temp_motdir&quot;);&#xD;&#xA;          if (value == 1 ) {&#xD;&#xA;            SCM.setIntValue(Res,1);        &#xD;&#xA;          } else if (value === 0) {&#xD;&#xA;            SCM.setIntValue(Res,0);&#xD;&#xA;          }              &#xD;&#xA;        }&#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var Res = SCM.getResource(&quot;temp_motdir&quot;); &#xD;&#xA;          var value = SCM.getIntValue(Res); &#xD;&#xA;          if (value == 1 ) { &#xD;&#xA;            SCM.setIntValue(currentResource,1);&#xD;&#xA;          } else if (value == -1 ){&#xD;&#xA;            SCM.setIntValue(currentResource,0);&#xD;&#xA;          }&#xD;&#xA;          else {&#xD;&#xA;            SCM.setIntValue(currentResource,0);&#xD;&#xA;          }&#xD;&#xA;        }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwmotordir/1" downWardmappedList="//@consumed.17" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>This allows the user to choose the motor direction as reverse.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="V/F Constant" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_vf_constant&quot;);&#xD;&#xA;&#xD;&#xA;                var Res1 = SCM.getResource(&quot;temp_nominal_voltage&quot;);&#xD;&#xA;                var value1 = SCM.getDoubleValue(Res1);&#xD;&#xA;&#xD;&#xA;                var Res2 = SCM.getResource(&quot;temp_nominal_speed&quot;);&#xD;&#xA;                var value2 = SCM.getDoubleValue(Res2);&#xD;&#xA;&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;                var Res4 = SCM.getResource(&quot;temp_pole_pair&quot;);&#xD;&#xA;                var value4 = SCM.getDoubleValue(Res4);&#xD;&#xA;      &#xD;&#xA;                SCM.setDoubleValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res1 = SCM.getResource(&quot;temp_nominal_voltage&quot;);&#xD;&#xA;                var value1 = SCM.getDoubleValue(Res1);&#xD;&#xA;        &#xD;&#xA;                var Res2 = SCM.getResource(&quot;temp_nominal_speed&quot;);&#xD;&#xA;                var value2 = SCM.getDoubleValue(Res2);&#xD;&#xA;        &#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;        &#xD;&#xA;                var Res4 = SCM.getResource(&quot;temp_pole_pair&quot;);&#xD;&#xA;                var value4 = SCM.getDoubleValue(Res4);&#xD;&#xA;&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_vf_constant&quot;);&#xD;&#xA;                var Resvalue = SCM.getDoubleValue(Res); &#xD;&#xA;&#xD;&#xA;                var value = ((value1*60)/(value2*value4));&#xD;&#xA;&#xD;&#xA;                var UpdateValue =0;&#xD;&#xA;&#xD;&#xA;                if (value3 == 0) {&#xD;&#xA;                 UpdateValue=value;&#xD;&#xA;                } else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (Resvalue==41){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  UpdateValue=value;&#x9;&#x9;&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  UpdateValue=Resvalue;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;                } &#xD;&#xA;                SCM.setDoubleValue(currentResource,UpdateValue);      &#xD;&#xA;          }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwvfconstant" downWardmappedList="//@consumed.43" maxValue="28" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="29"/>
    <localValue xsi:type="ResourceModel:StringValue" value="29"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="3fc0b21642c8590b"/>
    <toolTipHelpDescription>This is the value of V/F constant.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Voltage Offset" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_voltage_offset&quot;);&#xD;&#xA;&#xD;&#xA;                var Res2 = SCM.getResource(&quot;temp_nominal_voltage&quot;);&#xD;&#xA;                var value2 = SCM.getDoubleValue(Res2);&#xD;&#xA;&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;      &#xD;&#xA;                SCM.setDoubleValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res1 = SCM.getResource(&quot;temp_nominal_voltage&quot;);&#xD;&#xA;                var value1 = SCM.getDoubleValue(Res1);&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_voltage_offset&quot;); &#xD;&#xA;                var Resvalue = SCM.getDoubleValue(Res);&#xD;&#xA;&#xD;&#xA;                var value = (value1*1000/48);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var UpdateValue=0;&#xD;&#xA;&#xD;&#xA;                if (value3==0) {&#xD;&#xA;                  UpdateValue=value;&#xD;&#xA;                } else {&#xD;&#xA;&#x9;&#x9;&#x9;      if (Resvalue==200001){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  UpdateValue=value;&#x9;&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;   } else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  UpdateValue=Resvalue;&#x9;&#x9;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;   }&#xD;&#xA;                } &#xD;&#xA;              SCM.setDoubleValue(currentResource,UpdateValue);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwvoltageoffset" downWardmappedList="//@consumed.45" maxValue="30D40" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="30D41"/>
    <localValue xsi:type="ResourceModel:StringValue" value="30D41"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f4"/>
    <toolTipHelpDescription>This is the value of voltage offset.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Scheme of SVM" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);&#xD;&#xA;              SCM.setIntValue(Res,value);        &#xD;&#xA;           &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwschemeofsvm" downWardmappedList="//@consumed.73">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>This allows a user to select scheme of SVM - 7 or 5 Segment</toolTipHelpDescription>
    <item name="7 Segment" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);&#xD;&#xA;&#xD;&#xA;              var ExtTriModeRes0 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var ExtTriModeRes1 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/2&quot;);&#xD;&#xA;              var Q2ExtTriModeRes0 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q2ExtTriModeRes1 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/2&quot;);&#xD;&#xA;              var Q3ExtTriModeRes0 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q3ExtTriModeRes1 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;                var ResSvmType = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;);&#xD;&#xA;                var ValSvmType = SCM.getIntValue(ResSvmType);&#xD;&#xA;&#xD;&#xA;                if (ValSvmType == 0 ) {&#xD;&#xA;&#x9;              var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;&#x9;              var Q2CmRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;&#x9;              var Q3CmRes = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;                  var ValG1Curnt = SCM.getIntValue(CurRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  var ValG2Curnt = SCM.getIntValue(Q2CmRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  var ValG3Curnt = SCM.getIntValue(Q3CmRes);&#xD;&#xA;&#xD;&#xA;&#x9;              var CurRes2 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;&#x9;              var CurRes3 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical3/ch40&quot;); &#xD;&#xA;&#x9;              var RefRes2 = SCM.getResource(&quot;queueapp/adc002_erwrefill2&quot;);              &#xD;&#xA;&#x9;              var RefRes3 = SCM.getResource(&quot;queueapp/adc002_erwrefill3&quot;);&#xD;&#xA;&#x9;              var ExtTriRes2 = SCM.getResource(&quot;queueapp/adc002_erwextrigger2&quot;);&#xD;&#xA;&#x9;              var ExtTriRes3 = SCM.getResource(&quot;queueapp/adc002_erwextrigger3&quot;);&#xD;&#xA;&#x9;              var Q2CmRes2 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;&#x9;              var Q2CmRes3 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#x9;              var Q2RefRes2 = SCM.getResource(&quot;queueapp2/adc002_erwrefill2&quot;);&#xD;&#xA;&#x9;&#x9;          var Q2RefRes3 = SCM.getResource(&quot;queueapp2/adc002_erwrefill3&quot;);&#xD;&#xA;&#x9;              var Q2ExtTriRes2 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger2&quot;);&#xD;&#xA;&#x9;              var Q2ExtTriRes3 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger3&quot;);&#xD;&#xA;&#x9;              var Q3CmRes2 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;&#x9;              var Q3CmRes3 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#x9;              var Q3RefRes2 = SCM.getResource(&quot;queueapp3/adc002_erwrefill2&quot;);&#xD;&#xA;&#x9;              var Q3RefRes3 = SCM.getResource(&quot;queueapp3/adc002_erwrefill3&quot;);&#xD;&#xA;&#x9;              var Q3ExtTriRes2 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger2&quot;);&#xD;&#xA;&#x9;              var Q3ExtTriRes3 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  if (ValG1Curnt == 1 ) {&#xD;&#xA;&#x9;&#x9;&#x9;        SCM.setIntValue(CurRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;        SCM.setIntValue(CurRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(RefRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;        SCM.setIntValue(RefRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(ExtTriRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(ExtTriRes3,1);&#xD;&#xA;                  } else if (ValG2Curnt == 1 ) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2CmRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2CmRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2RefRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2RefRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2ExtTriRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2ExtTriRes3,1);&#xD;&#xA;                  } else if (ValG3Curnt == 1 ) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3CmRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3CmRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3RefRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3RefRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3ExtTriRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3ExtTriRes3,1);&#xD;&#xA;                  }&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;} &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if (ValG1Curnt == 1 ) {&#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes1,1);    &#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;      SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (ValG2Curnt == 1 ) {&#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes1,1);&#xD;&#xA;&#x9;&#x9;&#x9;      SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;} else if (ValG3Curnt == 1 ) {&#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;      SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes1,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;              } else if (value == -1) {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(Res,1);&#xD;&#xA;              }               &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 0 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }          &#xD;&#xA;          " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwschemeofsvm/0" downWardmappedList="//@consumed.73" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>Select 7 segment- (T0/2-Ta-Tb-T0-Tb-Ta-T0/2)</toolTipHelpDescription>
    </item>
    <item name="5 Segment" evalFunction="          &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);&#xD;&#xA;&#xD;&#xA;              var ResSvmMode = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;);&#xD;&#xA;              var ValSvmMode = SCM.getIntValue(ResSvmMode); &#xD;&#xA;&#xD;&#xA;              var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;&#x9;          var Q2CmRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;&#x9;          var Q3CmRes = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var ValG1Curnt = SCM.getIntValue(CurRes);&#xD;&#xA;&#x9;&#x9;      var ValG2Curnt = SCM.getIntValue(Q2CmRes);&#xD;&#xA;&#x9;&#x9;&#x9;  var ValG3Curnt = SCM.getIntValue(Q3CmRes);&#xD;&#xA;&#xD;&#xA;              var ExtTriModeRes0 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var ExtTriModeRes1 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;              var Q2ExtTriModeRes0 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q2ExtTriModeRes1 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;              var Q3ExtTriModeRes0 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q3ExtTriModeRes1 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;              var CurRes2 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var CurRes3 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical3/ch40&quot;); &#xD;&#xA;              var RefRes2 = SCM.getResource(&quot;queueapp/adc002_erwrefill2&quot;);              &#xD;&#xA;              var RefRes3 = SCM.getResource(&quot;queueapp/adc002_erwrefill3&quot;);&#xD;&#xA;              var ExtTriRes2 = SCM.getResource(&quot;queueapp/adc002_erwextrigger2&quot;);&#xD;&#xA;              var ExtTriRes3 = SCM.getResource(&quot;queueapp/adc002_erwextrigger3&quot;);&#xD;&#xA;              var Q2CmRes2 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q2CmRes3 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;              var Q2RefRes2 = SCM.getResource(&quot;queueapp2/adc002_erwrefill2&quot;);&#xD;&#xA;&#x9;          var Q2RefRes3 = SCM.getResource(&quot;queueapp2/adc002_erwrefill3&quot;);&#xD;&#xA;              var Q2ExtTriRes2 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q2ExtTriRes3 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger3&quot;);&#xD;&#xA;              var Q3CmRes2 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q3CmRes3 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;              var Q3RefRes2 = SCM.getResource(&quot;queueapp3/adc002_erwrefill2&quot;);&#xD;&#xA;              var Q3RefRes3 = SCM.getResource(&quot;queueapp3/adc002_erwrefill3&quot;);&#xD;&#xA;              var Q3ExtTriRes2 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q3ExtTriRes3 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,1); &#xD;&#xA;&#x9;&#x9;        SCM.setIntValue(CurRes2,0);&#xD;&#xA;&#x9;&#x9;        SCM.setIntValue(CurRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(RefRes2,0);&#xD;&#xA;&#x9;&#x9;        SCM.setIntValue(RefRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(ExtTriRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2CmRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2CmRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2RefRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2RefRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2ExtTriRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3CmRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3CmRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3RefRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3RefRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3ExtTriRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if (ValG1Curnt == 1 ) {&#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes1,1);    &#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;                } else if (ValG2Curnt == 1 ) {&#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes1,1);&#xD;&#xA;&#x9;&#x9;&#x9;      SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;                } else if (ValG3Curnt == 1 ) {&#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;      SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes1,1);&#xD;&#xA;                } &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwschemeofsvm/1" downWardmappedList="//@consumed.73" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Select 5 segment - (T0-Ta-2Tb-Ta-T0)</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Type of SVM" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;);&#xD;&#xA;              SCM.setIntValue(Res,value);                  &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwtypeofsvm" downWardmappedList="//@consumed.75">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>This allows a user to select Type of SVM</toolTipHelpDescription>
    <item name="Symmetric" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;);&#xD;&#xA;&#xD;&#xA;              var ResSvmScheme = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);&#xD;&#xA;              var ValSvmScheme = SCM.getIntValue(ResSvmScheme);&#xD;&#xA;&#xD;&#xA;              var ExtTriModeRes0 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var ExtTriModeRes1 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;              var Q2ExtTriModeRes0 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q2ExtTriModeRes1 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;              var Q3ExtTriModeRes0 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q3ExtTriModeRes1 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,0);   &#xD;&#xA;                if (ValSvmScheme == 0 ) {&#xD;&#xA;&#x9;              var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;&#x9;              var Q2CmRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;&#x9;              var Q3CmRes = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;                  var ValG1Curnt = SCM.getIntValue(CurRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  var ValG2Curnt = SCM.getIntValue(Q2CmRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  var ValG3Curnt = SCM.getIntValue(Q3CmRes);&#xD;&#xA;&#xD;&#xA;&#x9;              var CurRes2 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;&#x9;              var CurRes3 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical3/ch40&quot;); &#xD;&#xA;&#x9;              var RefRes2 = SCM.getResource(&quot;queueapp/adc002_erwrefill2&quot;);              &#xD;&#xA;&#x9;              var RefRes3 = SCM.getResource(&quot;queueapp/adc002_erwrefill3&quot;);&#xD;&#xA;&#x9;              var ExtTriRes2 = SCM.getResource(&quot;queueapp/adc002_erwextrigger2&quot;);&#xD;&#xA;&#x9;              var ExtTriRes3 = SCM.getResource(&quot;queueapp/adc002_erwextrigger3&quot;);&#xD;&#xA;&#x9;              var Q2CmRes2 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;&#x9;              var Q2CmRes3 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#x9;              var Q2RefRes2 = SCM.getResource(&quot;queueapp2/adc002_erwrefill2&quot;);&#xD;&#xA;&#x9;&#x9;          var Q2RefRes3 = SCM.getResource(&quot;queueapp2/adc002_erwrefill3&quot;);&#xD;&#xA;&#x9;              var Q2ExtTriRes2 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger2&quot;);&#xD;&#xA;&#x9;              var Q2ExtTriRes3 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger3&quot;);&#xD;&#xA;&#x9;              var Q3CmRes2 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;&#x9;              var Q3CmRes3 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#x9;              var Q3RefRes2 = SCM.getResource(&quot;queueapp3/adc002_erwrefill2&quot;);&#xD;&#xA;&#x9;              var Q3RefRes3 = SCM.getResource(&quot;queueapp3/adc002_erwrefill3&quot;);&#xD;&#xA;&#x9;              var Q3ExtTriRes2 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger2&quot;);&#xD;&#xA;&#x9;              var Q3ExtTriRes3 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger3&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  if (ValG1Curnt == 1 ) {&#xD;&#xA;&#x9;&#x9;&#x9;        SCM.setIntValue(CurRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;        SCM.setIntValue(CurRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(RefRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;        SCM.setIntValue(RefRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(ExtTriRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(ExtTriRes3,1);&#xD;&#xA;                  } else if (ValG2Curnt == 1 ) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2CmRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2CmRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2RefRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2RefRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2ExtTriRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2ExtTriRes3,1);&#xD;&#xA;                  } else if (ValG3Curnt == 1 ) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3CmRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3CmRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3RefRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3RefRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3ExtTriRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3ExtTriRes3,1);&#xD;&#xA;                  }&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  if (ValG1Curnt == 1 ) {&#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes1,1);    &#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;                  } else if (ValG2Curnt == 1 ) {&#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes1,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;                  } else if (ValG3Curnt == 1 ) {&#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q3ExtTriModeRes1,1);&#xD;&#xA;                  }&#xD;&#xA;                &#xD;&#xA;              } else if (value == -1) {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(Res,1);&#xD;&#xA;              }               &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 0 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }          &#xD;&#xA;          " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwtypeofsvm/0" downWardmappedList="//@consumed.75" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>Select Symmetric as SVM type. In this type, same compare value&#xD;
is used for Up and Down timer counting.</toolTipHelpDescription>
    </item>
    <item name="Asymmetric" evalFunction="          &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;);&#xD;&#xA;&#xD;&#xA;              var ResSvmMode = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;);&#xD;&#xA;              var ValSvmMode = SCM.getIntValue(ResSvmMode); &#xD;&#xA;&#xD;&#xA;              var ExtTriModeRes0 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var ExtTriModeRes1 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;              var Q2ExtTriModeRes0 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q2ExtTriModeRes1 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;              var Q3ExtTriModeRes0 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q3ExtTriModeRes1 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;              var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var Q2CmRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var Q3CmRes = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var ValG1Curnt = SCM.getIntValue(CurRes);&#xD;&#xA;&#x9;&#x9;&#x9;  var ValG2Curnt = SCM.getIntValue(Q2CmRes);&#xD;&#xA;&#x9;&#x9;&#x9;  var ValG3Curnt = SCM.getIntValue(Q3CmRes);&#xD;&#xA;&#xD;&#xA;              var CurRes2 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var CurRes3 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical3/ch40&quot;); &#xD;&#xA;              var RefRes2 = SCM.getResource(&quot;queueapp/adc002_erwrefill2&quot;);              &#xD;&#xA;              var RefRes3 = SCM.getResource(&quot;queueapp/adc002_erwrefill3&quot;);&#xD;&#xA;              var ExtTriRes2 = SCM.getResource(&quot;queueapp/adc002_erwextrigger2&quot;);&#xD;&#xA;              var ExtTriRes3 = SCM.getResource(&quot;queueapp/adc002_erwextrigger3&quot;);&#xD;&#xA;              var Q2CmRes2 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q2CmRes3 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;              var Q2RefRes2 = SCM.getResource(&quot;queueapp2/adc002_erwrefill2&quot;);&#xD;&#xA;&#x9;          var Q2RefRes3 = SCM.getResource(&quot;queueapp2/adc002_erwrefill3&quot;);&#xD;&#xA;              var Q2ExtTriRes2 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q2ExtTriRes3 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger3&quot;);&#xD;&#xA;              var Q3CmRes2 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q3CmRes3 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;              var Q3RefRes2 = SCM.getResource(&quot;queueapp3/adc002_erwrefill2&quot;);&#xD;&#xA;              var Q3RefRes3 = SCM.getResource(&quot;queueapp3/adc002_erwrefill3&quot;);&#xD;&#xA;              var Q3ExtTriRes2 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q3ExtTriRes3 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res,1);    &#xD;&#xA;&#xD;&#xA;&#x9;&#x9;        SCM.setIntValue(CurRes2,0);&#xD;&#xA;&#x9;&#x9;        SCM.setIntValue(CurRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(RefRes2,0);&#xD;&#xA;&#x9;&#x9;        SCM.setIntValue(RefRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(ExtTriRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2CmRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2CmRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2RefRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2RefRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2ExtTriRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3CmRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3CmRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3RefRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3RefRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3ExtTriRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3ExtTriRes3,0);   &#xD;&#xA;&#x9;&#x9;      if (ValG1Curnt == 1 ) {&#xD;&#xA;                SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                SCM.setIntValue(ExtTriModeRes1,1);    &#xD;&#xA; &#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;&#xD;&#xA;              } else if (ValG2Curnt == 1 ) {&#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes1,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;&#xD;&#xA;              } else if (ValG3Curnt == 1 ) {&#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes1,1);&#xD;&#xA;&#xD;&#xA;              } &#xD;&#xA;&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(Res,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwtypeofsvm/1" downWardmappedList="//@consumed.75" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Select Asymmetric as SVM type. In this type,&#xD;
different compare values are used for Up and Down timer counting.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="SVM Modes" evalFunction="             &#xD;&#xA;    function ForwardMapping()&#xD;&#xA;    {&#xD;&#xA;      var value = SCM.getIntValue(currentResource);&#xD;&#xA;      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;);&#xD;&#xA;      SCM.setIntValue(Res,value);        &#xD;&#xA;    }&#xD;&#xA;    function BackwardMapping()&#xD;&#xA;    {&#xD;&#xA;      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;); &#xD;&#xA;      var value = SCM.getIntValue(Res); &#xD;&#xA;      SCM.setIntValue(currentResource,value);&#xD;&#xA;    }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl_erwsvmmodes" downWardmappedList="//@consumed.76">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>This allows a user to select desired SVM mode.</toolTipHelpDescription>
    <item name="Standard SVM" evalFunction="            &#xD;&#xA;&#x9;    function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;          var Res = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;);&#xD;&#xA;&#xD;&#xA;          var ExtTriModeRes0 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/0&quot;);&#xD;&#xA;          var ExtTriModeRes1 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;          var Q2ExtTriModeRes0 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/0&quot;);&#xD;&#xA;          var Q2ExtTriModeRes1 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;          var Q3ExtTriModeRes0 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/0&quot;);&#xD;&#xA;          var Q3ExtTriModeRes1 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;          var ResSvmType = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;);&#xD;&#xA;          var ValSvmType = SCM.getIntValue(ResSvmType);&#xD;&#xA;&#xD;&#xA;          var ResSvmScheme = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);&#xD;&#xA;          var ValSvmScheme = SCM.getIntValue(ResSvmScheme);&#xD;&#xA;&#xD;&#xA;          if (value == 1 ) {&#xD;&#xA;            SCM.setIntValue(Res,0);&#xD;&#xA;&#xD;&#xA;                if ((ValSvmType == 0 )&amp;&amp;(ValSvmScheme==0)) {&#xD;&#xA;&#xD;&#xA;&#x9;              var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;&#x9;              var Q2CmRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;&#x9;              var Q3CmRes = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;                  var ValG1Curnt = SCM.getIntValue(CurRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  var ValG2Curnt = SCM.getIntValue(Q2CmRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  var ValG3Curnt = SCM.getIntValue(Q3CmRes);&#xD;&#xA;&#xD;&#xA;&#x9;              var CurRes2 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;&#x9;              var CurRes3 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical3/ch40&quot;); &#xD;&#xA;&#x9;              var RefRes2 = SCM.getResource(&quot;queueapp/adc002_erwrefill2&quot;);              &#xD;&#xA;&#x9;              var RefRes3 = SCM.getResource(&quot;queueapp/adc002_erwrefill3&quot;);&#xD;&#xA;&#x9;              var ExtTriRes2 = SCM.getResource(&quot;queueapp/adc002_erwextrigger2&quot;);&#xD;&#xA;&#x9;              var ExtTriRes3 = SCM.getResource(&quot;queueapp/adc002_erwextrigger3&quot;);&#xD;&#xA;&#x9;              var Q2CmRes2 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;&#x9;              var Q2CmRes3 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#x9;              var Q2RefRes2 = SCM.getResource(&quot;queueapp2/adc002_erwrefill2&quot;);&#xD;&#xA;&#x9;&#x9;          var Q2RefRes3 = SCM.getResource(&quot;queueapp2/adc002_erwrefill3&quot;);&#xD;&#xA;&#x9;              var Q2ExtTriRes2 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger2&quot;);&#xD;&#xA;&#x9;              var Q2ExtTriRes3 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger3&quot;);&#xD;&#xA;&#x9;              var Q3CmRes2 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;&#x9;              var Q3CmRes3 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#x9;              var Q3RefRes2 = SCM.getResource(&quot;queueapp3/adc002_erwrefill2&quot;);&#xD;&#xA;&#x9;              var Q3RefRes3 = SCM.getResource(&quot;queueapp3/adc002_erwrefill3&quot;);&#xD;&#xA;&#x9;              var Q3ExtTriRes2 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger2&quot;);&#xD;&#xA;&#x9;              var Q3ExtTriRes3 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  if (ValG1Curnt == 1 ) {&#xD;&#xA;&#x9;&#x9;&#x9;        SCM.setIntValue(CurRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;        SCM.setIntValue(CurRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(RefRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;        SCM.setIntValue(RefRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(ExtTriRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(ExtTriRes3,1);&#xD;&#xA;&#xD;&#xA;                  } else if (ValG2Curnt == 1 ) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2CmRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2CmRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2RefRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2RefRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2ExtTriRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q2ExtTriRes3,1);&#xD;&#xA;&#xD;&#xA;                  } else if (ValG3Curnt == 1 ) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3CmRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3CmRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3RefRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3RefRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3ExtTriRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    SCM.setIntValue(Q3ExtTriRes3,1);&#xD;&#xA;                  }&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  if (ValG1Curnt == 1 ) {&#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes1,1);    &#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;                    SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;                  } else if (ValG2Curnt == 1 ) {&#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes1,1);&#xD;&#xA;                    SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;                  } else if (ValG3Curnt == 1 ) {&#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                    SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;                    SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                    SCM.setIntValue(Q3ExtTriModeRes1,1);&#xD;&#xA;&#xD;&#xA;                  }&#xD;&#xA;  &#xD;&#xA;          } else if (value == -1) {&#xD;&#xA;            SCM.setIntValue(Res,0);&#xD;&#xA;          } else {&#xD;&#xA;            SCM.setIntValue(Res,1);&#xD;&#xA;          }              &#xD;&#xA;        }&#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var Res = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;); &#xD;&#xA;          var value = SCM.getIntValue(Res); &#xD;&#xA;          if (value == 0 ) { &#xD;&#xA;            SCM.setIntValue(currentResource,1);&#xD;&#xA;          } else {&#xD;&#xA;            SCM.setIntValue(currentResource,0);&#xD;&#xA;          }&#xD;&#xA;        }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl_erwsvmmodes/0" downWardmappedList="//@consumed.76" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>This allows a user to select standard SVM mode</toolTipHelpDescription>
    </item>
    <item name="Pseudo Zero Vector SVM" evalFunction="         &#xD;&#xA;&#x9;      function ForwardMapping()&#xD;&#xA;          {&#xD;&#xA;            var value = SCM.getIntValue(currentResource);&#xD;&#xA;            var Res = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;);&#xD;&#xA;            var ResSvmType = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;);&#xD;&#xA;            var ResSvmScheme = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);&#xD;&#xA;            var ResActiveVector = SCM.getResource(&quot;svm/pwmsvm01_erwactivevector&quot;);&#xD;&#xA;            var ValActiveVector = SCM.getIntValue(ResActiveVector);&#xD;&#xA;&#xD;&#xA;            var ExtTriModeRes0 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/0&quot;);&#xD;&#xA;            var ExtTriModeRes1 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/2&quot;);&#xD;&#xA;   &#xD;&#xA;            var Q2ExtTriModeRes0 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/0&quot;);&#xD;&#xA;            var Q2ExtTriModeRes1 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/2&quot;);&#xD;&#xA; &#xD;&#xA;            var Q3ExtTriModeRes0 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/0&quot;);&#xD;&#xA;            var Q3ExtTriModeRes1 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;            var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;            var Q2CmRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;            var Q3CmRes = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;            var ValG1Curnt = SCM.getIntValue(CurRes);&#xD;&#xA;&#x9;&#x9;    var ValG2Curnt = SCM.getIntValue(Q2CmRes);&#xD;&#xA;&#x9;&#x9;    var ValG3Curnt = SCM.getIntValue(Q3CmRes);&#xD;&#xA;&#xD;&#xA;            var CurRes2 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;            var CurRes3 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical3/ch40&quot;); &#xD;&#xA;            var RefRes2 = SCM.getResource(&quot;queueapp/adc002_erwrefill2&quot;);              &#xD;&#xA;            var RefRes3 = SCM.getResource(&quot;queueapp/adc002_erwrefill3&quot;);&#xD;&#xA;            var ExtTriRes2 = SCM.getResource(&quot;queueapp/adc002_erwextrigger2&quot;);&#xD;&#xA;            var ExtTriRes3 = SCM.getResource(&quot;queueapp/adc002_erwextrigger3&quot;);&#xD;&#xA;            var Q2CmRes2 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;            var Q2CmRes3 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;            var Q2RefRes2 = SCM.getResource(&quot;queueapp2/adc002_erwrefill2&quot;);&#xD;&#xA;&#x9;        var Q2RefRes3 = SCM.getResource(&quot;queueapp2/adc002_erwrefill3&quot;);&#xD;&#xA;            var Q2ExtTriRes2 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger2&quot;);&#xD;&#xA;            var Q2ExtTriRes3 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger3&quot;);&#xD;&#xA;            var Q3CmRes2 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;            var Q3CmRes3 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;            var Q3RefRes2 = SCM.getResource(&quot;queueapp3/adc002_erwrefill2&quot;);&#xD;&#xA;            var Q3RefRes3 = SCM.getResource(&quot;queueapp3/adc002_erwrefill3&quot;);&#xD;&#xA;            var Q3ExtTriRes2 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger2&quot;);&#xD;&#xA;            var Q3ExtTriRes3 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;if (ValActiveVector == 1 ) {&#xD;&#xA;              SCM.setIntValue(ResSvmScheme,0);&#xD;&#xA;            } else {&#xD;&#xA;              SCM.setIntValue(ResSvmScheme,1);&#xD;&#xA;            } &#xD;&#xA;            if (value == 1 ) {&#xD;&#xA;              SCM.setIntValue(Res,1);&#xD;&#xA;              SCM.setIntValue(ResSvmType,1);  &#xD;&#xA;&#xD;&#xA;              SCM.setIntValue(CurRes2,0);&#xD;&#xA;              SCM.setIntValue(CurRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(RefRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(RefRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(ExtTriRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q2CmRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q2CmRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q2RefRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q2RefRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q2ExtTriRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q2ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q3CmRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q3CmRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q3RefRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q3RefRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q3ExtTriRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;  SCM.setIntValue(Q3ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;  if (ValG1Curnt == 1 ) {&#xD;&#xA;                SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                SCM.setIntValue(ExtTriModeRes1,1);    &#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;              } else if (ValG2Curnt == 1 ) {&#xD;&#xA;                SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes1,1);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;              } else if (ValG3Curnt == 1 ) {&#xD;&#xA;                SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                SCM.setIntValue(ExtTriModeRes1,0);    &#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes1,1);&#xD;&#xA;              }&#xD;&#xA;            } else {&#xD;&#xA;              SCM.setIntValue(Res,0);&#xD;&#xA;            } &#xD;&#xA;          }&#xD;&#xA;          function BackwardMapping()&#xD;&#xA;          {&#xD;&#xA;             var Res = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;); &#xD;&#xA;             var value = SCM.getIntValue(Res); &#xD;&#xA;             if (value == 1 ) { &#xD;&#xA;               SCM.setIntValue(currentResource,1);&#xD;&#xA;             } else {&#xD;&#xA;               SCM.setIntValue(currentResource,0);&#xD;&#xA;             }&#xD;&#xA;          }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl_erwsvmmodes/1" downWardmappedList="//@consumed.73 //@consumed.76" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>This allows a user to select pseudo zero vector SVM</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Active Vector Selection" evalFunction="             &#xD;&#xA;    function ForwardMapping()&#xD;&#xA;    {&#xD;&#xA;      var value = SCM.getIntValue(currentResource);&#xD;&#xA;      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwactivevector&quot;);&#xD;&#xA;      SCM.setIntValue(Res,value);        &#xD;&#xA;    }&#xD;&#xA;    function BackwardMapping()&#xD;&#xA;    {&#xD;&#xA;      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwactivevector&quot;); &#xD;&#xA;      var value = SCM.getIntValue(Res); &#xD;&#xA;      SCM.setIntValue(currentResource,value);&#xD;&#xA;    }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwactivevector" downWardmappedList="//@consumed.74">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <toolTipHelpDescription>This allows a user to select number of active vectors &#xD;
for pseudo zero vector SVM mode</toolTipHelpDescription>
    <item name="3 Active Vector" evalFunction="            &#xD;&#xA;&#x9;    function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;          var Res = SCM.getResource(&quot;svm/pwmsvm01_erwactivevector&quot;);&#xD;&#xA;          var ResSvmScheme = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);&#xD;&#xA;&#xD;&#xA;          if (value == 1 ) {&#xD;&#xA;            SCM.setIntValue(Res,0);&#xD;&#xA;            SCM.setIntValue(ResSvmScheme,1);      &#xD;&#xA;          } else if (value == -1) {&#xD;&#xA;            SCM.setIntValue(Res,0);&#xD;&#xA;          } else {&#xD;&#xA;            SCM.setIntValue(Res,1);&#xD;&#xA;          }              &#xD;&#xA;        }&#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;          var Res = SCM.getResource(&quot;svm/pwmsvm01_erwactivevector&quot;); &#xD;&#xA;          var value = SCM.getIntValue(Res); &#xD;&#xA;          if (value == 0 ) { &#xD;&#xA;            SCM.setIntValue(currentResource,1);&#xD;&#xA;          } else {&#xD;&#xA;            SCM.setIntValue(currentResource,0);&#xD;&#xA;          }&#xD;&#xA;        }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwactivevector/0" downWardmappedList="//@consumed.74" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>This allows a user to select 3 active vector</toolTipHelpDescription>
    </item>
    <item name="4 Active Vector" evalFunction="         &#xD;&#xA;&#x9;      function ForwardMapping()&#xD;&#xA;          {&#xD;&#xA;            var value = SCM.getIntValue(currentResource);&#xD;&#xA;            var Res = SCM.getResource(&quot;svm/pwmsvm01_erwactivevector&quot;);&#x9;&#x9;&#xD;&#xA;            var ResSvmScheme = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);    &#xD;&#xA;            if (value == 1 ) {&#xD;&#xA;              SCM.setIntValue(Res,1); &#xD;&#xA;              SCM.setIntValue(ResSvmScheme,0);       &#xD;&#xA;            } else if (value == 0) {&#xD;&#xA;              SCM.setIntValue(Res,0);&#xD;&#xA;            }        &#xD;&#xA;      &#xD;&#xA;          }&#xD;&#xA;          function BackwardMapping()&#xD;&#xA;          {&#xD;&#xA;            var Res = SCM.getResource(&quot;svm/pwmsvm01_erwactivevector&quot;); &#xD;&#xA;            var value = SCM.getIntValue(Res); &#xD;&#xA;            if (value === 1 ) { &#xD;&#xA;              SCM.setIntValue(currentResource,1);&#xD;&#xA;            } else {&#xD;&#xA;              SCM.setIntValue(currentResource,0);&#xD;&#xA;            }&#xD;&#xA;          }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwactivevector/1" downWardmappedList="//@consumed.74 //@consumed.73" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>This allows a user to select 4 active vector.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="VADC Reference" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;&#xD;&#xA;                var BiasVoltRes = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;                var BiasVoltVal = SCM.getDoubleValue(BiasVoltRes);&#xD;&#xA;&#xD;&#xA;                var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;                var XMC4x00 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;&#xD;&#xA;                if(value==0){&#xD;&#xA;                 if(XMC1302==0){&#xD;&#xA;                   SCM.setIntValue(Res,5000);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    if(BiasVoltVal > 5000){&#xD;&#xA;&#x9;&#x9;&#x9;          SCM.setIntValue(BiasVoltRes,5000);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    }&#x9;&#x9;&#x9;&#x9;   &#xD;&#xA;&#x9;&#x9;&#x9;&#x9; } else if(XMC4x00==0) {&#xD;&#xA;                   SCM.setIntValue(Res,3300);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    if(BiasVoltVal > 3300){&#xD;&#xA;&#x9;&#x9;&#x9;          SCM.setIntValue(BiasVoltRes,3300);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    }&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;     }&#x9;&#xD;&#xA;                } else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(Res,value);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  if(BiasVoltVal > value){&#xD;&#xA;&#x9;&#x9;&#x9;        SCM.setIntValue(BiasVoltRes,value);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  }         &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}       &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_vadcref&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwvadcref" downWardmappedList="//@consumed.21" maxValue="1388" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1388"/>
    <toolTipHelpDescription>This is the VADC reference value.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Voltage Divide Ratio" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_voltage_dratio&quot;);&#xD;&#xA;                SCM.setDoubleValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_voltage_dratio&quot;); &#xD;&#xA;              var value = SCM.getDoubleValue(Res); &#xD;&#xA;        if(value == 0)&#xD;&#xA;        {&#xD;&#xA;          SCM.setDoubleValue(currentResource,9.79);&#xD;&#xA;        }&#xD;&#xA;        else&#xD;&#xA;        {&#xD;&#xA;                SCM.setDoubleValue(currentResource,value);&#xD;&#xA;        }&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwvoltdivideratio" downWardmappedList="//@consumed.20" maxValue="100" minValue="1">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="4023947ae147ae14"/>
    <toolTipHelpDescription>This is the DC link voltage divider ratio.
Entered value should be (R1/R2)*100.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Inverter Pin Enable" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;svm/pwmsvm01_erwinverterpin/0&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;svm/pwmsvm01_erwinverterpin/0&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }&#xD;&#xA;" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwinverterpin" downWardmappedList="//@consumed.80" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <toolTipHelpDescription>This allows a user to configure the enable pin of the inverter.</toolTipHelpDescription>
    <item name="Enable" evalFunction="&#xD;&#xA;                  function ForwardMapping()&#xD;&#xA;                  {&#xD;&#xA;                      var value = SCM.getIntValue(currentResource);&#xD;&#xA;                      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwinverterpin/0&quot;);&#xD;&#xA;                      if(value == 1)                      &#xD;&#xA;                      {&#xD;&#xA;                        SCM.setIntValue(Res,1);&#xD;&#xA;                      }&#xD;&#xA;                      else&#xD;&#xA;                      {&#xD;&#xA;                        SCM.setIntValue(Res,0);&#xD;&#xA;                      }&#xD;&#xA;    &#xD;&#xA;      &#xD;&#xA;                  }&#xD;&#xA;                  function BackwardMapping()&#xD;&#xA;                  {&#xD;&#xA;                    var Res = SCM.getResource(&quot;svm/pwmsvm01_erwinverterpin/0&quot;); &#xD;&#xA;                      var value = SCM.getIntValue(Res); &#xD;&#xA;                      if(value == 1 || value == -1)                      &#xD;&#xA;                      {&#xD;&#xA;                        SCM.setIntValue(currentResource,1);&#xD;&#xA;                      }&#xD;&#xA;                      else&#xD;&#xA;                      {&#xD;&#xA;                        SCM.setIntValue(currentResource,0);&#xD;&#xA;                      } &#xD;&#xA;                  }&#xD;&#xA;" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwinverterpin/0" downWardmappedList="//@consumed.80" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>This allows a user to configure the enable pin of the inverter.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Inverter Pin Level" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;svm/pwmsvm01_erwinverterpinlevel&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res = SCM.getResource(&quot;svm/pwmsvm01_erwinverterpinlevel&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res); &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }&#xD;&#xA;" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwinverterpinlevel" downWardmappedList="//@consumed.81">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <toolTipHelpDescription>This allow the user to configure the level of the enable pin of the inverter.</toolTipHelpDescription>
    <item name="Active Low" evalFunction="&#xD;&#xA;                 function ForwardMapping()&#xD;&#xA;                    {&#xD;&#xA;                      var value = SCM.getIntValue(currentResource);&#xD;&#xA;                      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwinverterpinlevel&quot;);&#xD;&#xA;                      if (value == 1 ) {&#xD;&#xA;                        SCM.setIntValue(Res,0);        &#xD;&#xA;                      } else if (value === 0) {&#xD;&#xA;                        SCM.setIntValue(Res,1);&#xD;&#xA;                      }              &#xD;&#xA;                    }&#xD;&#xA;                    function BackwardMapping()&#xD;&#xA;                    {&#xD;&#xA;                      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwinverterpinlevel&quot;); &#xD;&#xA;                      var value = SCM.getIntValue(Res); &#xD;&#xA;                      if (value == 0 ) { &#xD;&#xA;                        SCM.setIntValue(currentResource,1);&#xD;&#xA;                      } else if (value == -1 ){&#xD;&#xA;                        SCM.setIntValue(currentResource,1);&#xD;&#xA;                      }&#xD;&#xA;                      else {&#xD;&#xA;                        SCM.setIntValue(currentResource,0);&#xD;&#xA;                      }&#xD;&#xA;                    }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwinverterpinlevel/0" downWardmappedList="//@consumed.81" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Low signal on the enable pin drives the Inverter.  </toolTipHelpDescription>
    </item>
    <item name="Active High" evalFunction="&#xD;&#xA;                 function ForwardMapping()&#xD;&#xA;                    {&#xD;&#xA;                      var value = SCM.getIntValue(currentResource);&#xD;&#xA;                      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwinverterpinlevel&quot;);&#xD;&#xA;                      if (value == 1 ) {&#xD;&#xA;                        SCM.setIntValue(Res,1);        &#xD;&#xA;                      } else if (value === 0) {&#xD;&#xA;                        SCM.setIntValue(Res,0);&#xD;&#xA;                      }              &#xD;&#xA;                    }&#xD;&#xA;                    function BackwardMapping()&#xD;&#xA;                    {&#xD;&#xA;                      var Res = SCM.getResource(&quot;svm/pwmsvm01_erwinverterpinlevel&quot;); &#xD;&#xA;                      var value = SCM.getIntValue(Res); &#xD;&#xA;                      if (value == 1 ) { &#xD;&#xA;                        SCM.setIntValue(currentResource,1);&#xD;&#xA;                      } else if (value == -1 ){&#xD;&#xA;                        SCM.setIntValue(currentResource,0);&#xD;&#xA;                      }&#xD;&#xA;                      else {&#xD;&#xA;                        SCM.setIntValue(currentResource,0);&#xD;&#xA;                      }&#xD;&#xA;                    }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwinverterpinlevel/1" downWardmappedList="//@consumed.81" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>High signal on the enable pin drives the inverter.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Queue 1 Current Measurement" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq1adccmcontrol" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Selects group A for current measurement.</toolTipHelpDescription>
    <item name="Enable" evalFunction="            &#xD;&#xA;      function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Fifoforce = SCM.getResource(&quot;queueapp/adc002_irwfocapp&quot;);&#xD;&#xA;              var Fifoforce2 = SCM.getResource(&quot;queueapp2/adc002_irwfocapp&quot;);&#xD;&#xA;              var Fifoforce3 = SCM.getResource(&quot;queueapp3/adc002_irwfocapp&quot;);&#xD;&#xA;              var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var CurRes1 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical1/ch20&quot;); &#xD;&#xA;              var CurRes2 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var CurRes3 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical3/ch40&quot;); &#xD;&#xA; &#xD;&#xA;              var RefRes = SCM.getResource(&quot;queueapp/adc002_erwrefill0&quot;);             &#xD;&#xA;              var RefRes1 = SCM.getResource(&quot;queueapp/adc002_erwrefill1&quot;);                &#xD;&#xA;              var RefRes2 = SCM.getResource(&quot;queueapp/adc002_erwrefill2&quot;);              &#xD;&#xA;              var RefRes3 = SCM.getResource(&quot;queueapp/adc002_erwrefill3&quot;);&#xD;&#xA;              &#xD;&#xA;              var ExtTriRes = SCM.getResource(&quot;queueapp/adc002_erwextrigger0&quot;);&#xD;&#xA;              var ExtTriRes1 = SCM.getResource(&quot;queueapp/adc002_erwextrigger1&quot;);&#xD;&#xA;              var ExtTriRes2 = SCM.getResource(&quot;queueapp/adc002_erwextrigger2&quot;);&#xD;&#xA;              var ExtTriRes3 = SCM.getResource(&quot;queueapp/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              var ExtTriModeRes0 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var ExtTriModeRes1 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;             &#xD;&#xA;              var ChNo =0;&#xD;&#xA;              var PotRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical5/ch62&quot;);&#xD;&#xA;              var PotVal = SCM.getIntValue(PotRes);  &#xD;&#xA;              var VoltRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical4/ch51&quot;);&#xD;&#xA;              var VoltVal = SCM.getIntValue(VoltRes);&#xD;&#xA;              var ChNoRes = SCM.getResource(&quot;queueapp/adc002_irwchannelnum&quot;); &#xD;&#xA;              &#xD;&#xA;              if (PotVal == 1 ){ &#xD;&#xA;                ChNo =3;&#xD;&#xA;              }&#xD;&#xA;              else if( (VoltVal == 1) &amp;&amp; (PotVal != 1) )&#xD;&#xA;              {&#xD;&#xA;                ChNo =2;&#xD;&#xA;              }   &#xD;&#xA;              else &#xD;&#xA;              {&#xD;&#xA;                ChNo =1;&#xD;&#xA;              } &#xD;&#xA;&#xD;&#xA;              var Q2CmRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var Q2CmRes1 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical1/ch20&quot;);&#xD;&#xA;              var Q2CmRes2 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q2CmRes3 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#xD;&#xA;              var Q2RefRes = SCM.getResource(&quot;queueapp2/adc002_erwrefill0&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;  var Q2RefRes1 = SCM.getResource(&quot;queueapp2/adc002_erwrefill1&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;  var Q2RefRes2 = SCM.getResource(&quot;queueapp2/adc002_erwrefill2&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;  var Q2RefRes3 = SCM.getResource(&quot;queueapp2/adc002_erwrefill3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q2ExtTriRes = SCM.getResource(&quot;queueapp2/adc002_erwextrigger0&quot;);&#xD;&#xA;              var Q2ExtTriRes1 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger1&quot;);&#xD;&#xA;              var Q2ExtTriRes2 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q2ExtTriRes3 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q2ExtTriModeRes0 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q2ExtTriModeRes1 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;         &#xD;&#xA;              var Q3CmRes = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var Q3CmRes1 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical1/ch20&quot;);&#xD;&#xA;              var Q3CmRes2 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q3CmRes3 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#xD;&#xA;              var Q3RefRes = SCM.getResource(&quot;queueapp3/adc002_erwrefill0&quot;);&#xD;&#xA;              var Q3RefRes1 = SCM.getResource(&quot;queueapp3/adc002_erwrefill1&quot;);&#xD;&#xA;              var Q3RefRes2 = SCM.getResource(&quot;queueapp3/adc002_erwrefill2&quot;);&#xD;&#xA;              var Q3RefRes3 = SCM.getResource(&quot;queueapp3/adc002_erwrefill3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q3ExtTriRes = SCM.getResource(&quot;queueapp3/adc002_erwextrigger0&quot;);&#xD;&#xA;              var Q3ExtTriRes1 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger1&quot;);&#xD;&#xA;              var Q3ExtTriRes2 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q3ExtTriRes3 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q3ExtTriModeRes0 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q3ExtTriModeRes1 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;  var ResSvmScheme = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);&#xD;&#xA;              var ValSvmScheme = SCM.getIntValue(ResSvmScheme); &#xD;&#xA;              var ResSvmType = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;);&#xD;&#xA;              var ValSvmType = SCM.getIntValue(ResSvmType); &#xD;&#xA;              var ResSvmMode = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;);&#xD;&#xA;              var ValSvmMode = SCM.getIntValue(ResSvmMode); &#xD;&#xA;&#xD;&#xA;             if (value == 1 ){ &#xD;&#xA;                SCM.setIntValue(ChNoRes,ChNo); &#xD;&#xA;                SCM.setIntValue(Fifoforce,1);&#xD;&#xA;                SCM.setIntValue(CurRes,1);&#xD;&#xA;                SCM.setIntValue(CurRes1,1);&#xD;&#xA;                SCM.setIntValue(RefRes,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(RefRes1,1);&#xD;&#xA;                SCM.setIntValue(ExtTriRes,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(ExtTriRes1,1);&#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(Fifoforce2,0);&#xD;&#xA;                SCM.setIntValue(Q2CmRes,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Q2CmRes1,0);&#xD;&#xA;                SCM.setIntValue(Q2RefRes,0);&#xD;&#xA;                SCM.setIntValue(Q2RefRes1,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriRes,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriRes1,0);&#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(Fifoforce3,0);                &#xD;&#xA;                SCM.setIntValue(Q3CmRes,0);&#xD;&#xA;                SCM.setIntValue(Q3CmRes1,0);&#xD;&#xA;                SCM.setIntValue(Q3RefRes,0);&#xD;&#xA;                SCM.setIntValue(Q3RefRes1,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriRes,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriRes1,0);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if((ValSvmScheme==0)&amp;&amp; (ValSvmType==0)){&#xD;&#xA;                  SCM.setIntValue(CurRes2,1);&#xD;&#xA;                  SCM.setIntValue(CurRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(RefRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(RefRes3,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(ExtTriRes2,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(ExtTriRes3,1);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(Q2CmRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(Q2CmRes3,0);&#xD;&#xA;                  SCM.setIntValue(Q2RefRes2,0);&#xD;&#xA;                  SCM.setIntValue(Q2RefRes3,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriRes2,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriRes3,0);&#xD;&#xA;&#xD;&#xA;                  SCM.setIntValue(Q3CmRes2,0);&#xD;&#xA;                  SCM.setIntValue(Q3CmRes3,0);&#xD;&#xA;                  SCM.setIntValue(Q3RefRes2,0);&#xD;&#xA;                  SCM.setIntValue(Q3RefRes3,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriRes2,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;/****************************Configure ADC triggering mode ******************************/&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(ExtTriModeRes0,0); &#xD;&#xA;                  SCM.setIntValue(ExtTriModeRes1,1);    &#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes0,1);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes0,1);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;/*********************************************************************************************/&#xD;&#xA;             } else {&#xD;&#xA;                SCM.setIntValue(ChNoRes,ChNo); &#xD;&#xA;                SCM.setIntValue(CurRes,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(CurRes1,0);&#xD;&#xA;                SCM.setIntValue(RefRes,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(RefRes1,0);&#xD;&#xA;                SCM.setIntValue(ExtTriRes,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(ExtTriRes1,0);&#xD;&#xA;                if((ValSvmScheme==0)&amp;&amp; (ValSvmType==0)){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(CurRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(CurRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(RefRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(RefRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(ExtTriRes2,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(ExtTriRes3,0);&#xD;&#xA;                }&#xD;&#xA;                SCM.setIntValue(ExtTriModeRes0,1);&#xD;&#xA;                SCM.setIntValue(ExtTriModeRes1,0);     &#xD;&#xA;             }  &#xD;&#xA;                var dep = &quot;DependentApp&quot;; &#xD;&#xA;                var queueapp3 = SCM.getResource(&quot;queueapp3&quot;); &#xD;&#xA;                SCM.setStringValue(queueapp3,dep); &#xD;&#xA;                var queueapp2 = SCM.getResource(&quot;queueapp2&quot;); &#xD;&#xA;                SCM.setStringValue(queueapp2,dep);         &#xD;&#xA;        }&#xD;&#xA;         function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;queueapp/adc002_erwchannellogical0/ch10&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;            }&#xD;&#xA;        }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq1adccmcontrol/0" downWardmappedList="//@consumed.86 //@consumed.85 //@consumed.88 //@consumed.90 //@consumed.99 //@consumed.100 //@consumed.105 //@consumed.106 //@consumed.113 //@consumed.116 //@consumed.118 //@consumed.127 //@consumed.128 //@consumed.133 //@consumed.134 //@consumed.141 //@consumed.144 //@consumed.146 //@consumed.155 //@consumed.156 //@consumed.161 //@consumed.162 //@consumed.92 //@consumed.94 //@consumed.101 //@consumed.102 //@consumed.107 //@consumed.108 //@consumed.120 //@consumed.122 //@consumed.129 //@consumed.130 //@consumed.135 //@consumed.136 //@consumed.148 //@consumed.150 //@consumed.157 //@consumed.158 //@consumed.163 //@consumed.164 //@consumed.110 //@consumed.112 //@consumed.138 //@consumed.140 //@consumed.166 //@consumed.168 //@consumed.57 //@consumed.56" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>Selects group A for current measurement.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Queue 1 Voltage Compensation" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq1adcvccontrol" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Selects group A for voltage compensation.</toolTipHelpDescription>
    <item name="Enable" evalFunction="            &#xD;&#xA;       function ForwardMapping()&#xD;&#xA;       {&#xD;&#xA;         var value = SCM.getIntValue(currentResource);     &#xD;&#xA;&#xD;&#xA;         var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical4/ch51&quot;);  &#xD;&#xA;         var RefRes = SCM.getResource(&quot;queueapp/adc002_erwrefill4&quot;);&#xD;&#xA;         var Q2RefRes = SCM.getResource(&quot;queueapp2/adc002_erwrefill4&quot;);&#xD;&#xA;&#xD;&#xA;         var Q2CmRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;         var Q2Cmval = SCM.getIntValue(Q2CmRes);&#xD;&#xA;&#xD;&#xA;         var Q2VcRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical4/ch51&quot;);&#xD;&#xA;&#xD;&#xA;         var ChNoRes = SCM.getResource(&quot;queueapp/adc002_irwchannelnum&quot;);&#xD;&#xA;         var Q2ChNoRes = SCM.getResource(&quot;queueapp2/adc002_irwchannelnum&quot;);&#xD;&#xA;&#xD;&#xA;         var ChNo =0;&#xD;&#xA;         var PotRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical5/ch62&quot;);&#xD;&#xA;         var PotVal = SCM.getIntValue(PotRes);&#xD;&#xA;&#xD;&#xA;         if (PotVal == 1){ &#xD;&#xA;            ChNo =3;&#xD;&#xA;          }&#xD;&#xA;         else if( (value == 1) &amp;&amp; (PotVal != 1) )&#xD;&#xA;         {&#xD;&#xA;            ChNo =2;&#xD;&#xA;          }   &#xD;&#xA;         else &#xD;&#xA;         {&#xD;&#xA;            ChNo =1;&#xD;&#xA;         }&#xD;&#xA;            &#xD;&#xA;        if (value == 1 ){ &#xD;&#xA;           SCM.setIntValue(CurRes,1);&#xD;&#xA;           SCM.setIntValue(RefRes,1);&#xD;&#xA;           SCM.setIntValue(ChNoRes,ChNo);&#xD;&#xA;           SCM.setIntValue(Q2VcRes,0);&#xD;&#xA;          SCM.setIntValue(Q2RefRes,0);&#xD;&#xA;          if(Q2Cmval == 1){&#xD;&#xA;          SCM.setIntValue(Q2ChNoRes,1);&#xD;&#xA;          }&#xD;&#xA;        } else {&#xD;&#xA;           SCM.setIntValue(CurRes,0);&#xD;&#xA;           SCM.setIntValue(RefRes,0);&#xD;&#xA;           SCM.setIntValue(ChNoRes,ChNo);&#xD;&#xA;        } &#xD;&#xA;        var dep = &quot;DependentApp&quot;; &#xD;&#xA;        var queueapp3 = SCM.getResource(&quot;queueapp3&quot;); &#xD;&#xA;        SCM.setStringValue(queueapp3,dep); &#xD;&#xA;        var queueapp2 = SCM.getResource(&quot;queueapp2&quot;); &#xD;&#xA;        SCM.setStringValue(queueapp2,dep);      &#xD;&#xA;      }&#xD;&#xA;       function BackwardMapping()&#xD;&#xA;       {&#xD;&#xA;           var Res = SCM.getResource(&quot;queueapp/adc002_erwchannellogical4/ch51&quot;); &#xD;&#xA;           var value = SCM.getIntValue(Res); &#xD;&#xA;           if (value == 1 ) { &#xD;&#xA;              SCM.setIntValue(currentResource,1);&#xD;&#xA;           } else {&#xD;&#xA;              SCM.setIntValue(currentResource,0);&#xD;&#xA;           }&#xD;&#xA;       }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq1adcvccontrol/0" downWardmappedList="//@consumed.96 //@consumed.103 //@consumed.86 //@consumed.57 //@consumed.56" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Selects group A for voltage compensation.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Queue 1 Pot Measurement" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq1adcpmcontrol" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Selects group A for pot measurement.</toolTipHelpDescription>
    <item name="Enable" evalFunction="            &#xD;&#xA;  function ForwardMapping()&#xD;&#xA;  {&#xD;&#xA;      var value = SCM.getIntValue(currentResource);&#xD;&#xA;&#xD;&#xA;      var CurRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical5/ch62&quot;);  &#xD;&#xA;      var RefRes = SCM.getResource(&quot;queueapp/adc002_erwrefill5&quot;);&#xD;&#xA;&#xD;&#xA;      var ChNoRes = SCM.getResource(&quot;queueapp/adc002_irwchannelnum&quot;);&#xD;&#xA;&#xD;&#xA;      var ChNo =0;&#xD;&#xA;      var VoltRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical4/ch51&quot;);&#xD;&#xA;      var VoltVal = SCM.getIntValue(VoltRes);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;      if (value == 1 ){ &#xD;&#xA;        ChNo =3;&#xD;&#xA;      }&#xD;&#xA;      else if( (VoltVal == 1) &amp;&amp; (value != 1) )&#xD;&#xA;      {&#xD;&#xA;        ChNo =2;&#xD;&#xA;      }   &#xD;&#xA;      else &#xD;&#xA;      {&#xD;&#xA;        ChNo =1;&#xD;&#xA;      } &#xD;&#xA;  &#xD;&#xA;       if (value == 1 ){ &#xD;&#xA;         SCM.setIntValue(CurRes,1);&#xD;&#xA;         SCM.setIntValue(RefRes,1);&#xD;&#xA;         SCM.setIntValue(ChNoRes,ChNo);&#xD;&#xA;       } else {&#xD;&#xA;         SCM.setIntValue(CurRes,0);&#xD;&#xA;         SCM.setIntValue(RefRes,0);&#xD;&#xA;         SCM.setIntValue(ChNoRes,ChNo);&#xD;&#xA;       }    &#xD;&#xA;         var dep = &quot;DependentApp&quot;; &#xD;&#xA;         var queueapp3 = SCM.getResource(&quot;queueapp3&quot;); &#xD;&#xA;         SCM.setStringValue(queueapp3,dep); &#xD;&#xA;         var queueapp2 = SCM.getResource(&quot;queueapp2&quot;); &#xD;&#xA;         SCM.setStringValue(queueapp2,dep);  &#xD;&#xA;    }&#xD;&#xA;&#xD;&#xA;     function BackwardMapping()&#xD;&#xA;     {&#xD;&#xA;        var Res = SCM.getResource(&quot;queueapp/adc002_erwchannellogical5/ch62&quot;); &#xD;&#xA;        var value = SCM.getIntValue(Res); &#xD;&#xA;        if (value == 1 ) { &#xD;&#xA;          SCM.setIntValue(currentResource,1);&#xD;&#xA;        } else {&#xD;&#xA;          SCM.setIntValue(currentResource,0);&#xD;&#xA;        }&#xD;&#xA;     }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq1adcpmcontrol/0" downWardmappedList="//@consumed.98 //@consumed.104 //@consumed.86 //@consumed.57 //@consumed.56" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Selects group A for pot measurement.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Queue 2 Current Measurement" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq2adccmcontrol" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Selects group B for current measurement</toolTipHelpDescription>
    <item name="Enable" evalFunction="            &#xD;&#xA;      function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Fifoforce = SCM.getResource(&quot;queueapp/adc002_irwfocapp&quot;);&#xD;&#xA;              var Fifoforce2 = SCM.getResource(&quot;queueapp2/adc002_irwfocapp&quot;);&#xD;&#xA;              var Fifoforce3 = SCM.getResource(&quot;queueapp3/adc002_irwfocapp&quot;);&#xD;&#xA;              var Q2CurRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var Q2CurRes1 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical1/ch20&quot;);&#xD;&#xA;              var Q2CurRes2 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q2CurRes3 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA; &#xD;&#xA;              var Q2RefRes = SCM.getResource(&quot;queueapp2/adc002_erwrefill0&quot;);&#xD;&#xA;              var Q2RefRes1 = SCM.getResource(&quot;queueapp2/adc002_erwrefill1&quot;);&#xD;&#xA;              var Q2RefRes2 = SCM.getResource(&quot;queueapp2/adc002_erwrefill2&quot;);&#xD;&#xA;              var Q2RefRes3 = SCM.getResource(&quot;queueapp2/adc002_erwrefill3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q2ExtTriRes = SCM.getResource(&quot;queueapp2/adc002_erwextrigger0&quot;);&#xD;&#xA;              var Q2ExtTriRes1 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger1&quot;);&#xD;&#xA;              var Q2ExtTriRes2 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q2ExtTriRes3 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q1CmRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var Q1CmRes1 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical1/ch20&quot;);&#xD;&#xA;              var Q1CmRes2 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q1CmRes3 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;              var Q1RefRes = SCM.getResource(&quot;queueapp/adc002_erwrefill0&quot;);&#xD;&#xA;              var Q1RefRes1 = SCM.getResource(&quot;queueapp/adc002_erwrefill1&quot;);&#xD;&#xA;              var Q1RefRes2 = SCM.getResource(&quot;queueapp/adc002_erwrefill2&quot;);&#xD;&#xA;              var Q1RefRes3 = SCM.getResource(&quot;queueapp/adc002_erwrefill3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q1ExtTriRes = SCM.getResource(&quot;queueapp/adc002_erwextrigger0&quot;);&#xD;&#xA;              var Q1ExtTriRes1 = SCM.getResource(&quot;queueapp/adc002_erwextrigger1&quot;);&#xD;&#xA;              var Q1ExtTriRes2 = SCM.getResource(&quot;queueapp/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q1ExtTriRes3 = SCM.getResource(&quot;queueapp/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q3CmRes = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var Q3CmRes1 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical1/ch20&quot;);&#xD;&#xA;              var Q3CmRes2 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q3CmRes3 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;              var Q3RefRes = SCM.getResource(&quot;queueapp3/adc002_erwrefill0&quot;);&#xD;&#xA;              var Q3RefRes1 = SCM.getResource(&quot;queueapp3/adc002_erwrefill1&quot;);&#xD;&#xA;              var Q3RefRes2 = SCM.getResource(&quot;queueapp3/adc002_erwrefill2&quot;);&#xD;&#xA;              var Q3RefRes3 = SCM.getResource(&quot;queueapp3/adc002_erwrefill3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q3ExtTriRes = SCM.getResource(&quot;queueapp3/adc002_erwextrigger0&quot;);&#xD;&#xA;              var Q3ExtTriRes1 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger1&quot;);&#xD;&#xA;              var Q3ExtTriRes2 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q3ExtTriRes3 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q2ExtTriModeRes0 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q2ExtTriModeRes1 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/2&quot;);&#xD;&#xA;              var Q1ExtTriModeRes0 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q1ExtTriModeRes1 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/2&quot;);&#xD;&#xA;              var Q3ExtTriModeRes0 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q3ExtTriModeRes1 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;              var ChNo =0;&#xD;&#xA;              var PotRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical5/ch62&quot;);&#xD;&#xA;              var PotVal = SCM.getIntValue(PotRes);  &#xD;&#xA;&#xD;&#xA;              var VoltRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical4/ch51&quot;);&#xD;&#xA;              var VoltVal = SCM.getIntValue(VoltRes);&#xD;&#xA;              &#xD;&#xA;&#xD;&#xA;              var ChNoRes = SCM.getResource(&quot;queueapp2/adc002_irwchannelnum&quot;); &#xD;&#xA;              &#xD;&#xA;              if (PotVal == 1 ){ &#xD;&#xA;                ChNo =3;&#xD;&#xA;              }&#xD;&#xA;              else if( (VoltVal == 1) &amp;&amp; (PotVal != 1) )&#xD;&#xA;              {&#xD;&#xA;                ChNo =2;&#xD;&#xA;              }   &#xD;&#xA;              else &#xD;&#xA;              {&#xD;&#xA;                ChNo =1;&#xD;&#xA;              } &#xD;&#xA; &#xD;&#xA;              var ResSvmScheme = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);&#xD;&#xA;              var ValSvmScheme = SCM.getIntValue(ResSvmScheme); &#xD;&#xA;              var ResSvmType = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;);&#xD;&#xA;              var ValSvmType = SCM.getIntValue(ResSvmType); &#xD;&#xA;              var ResSvmMode = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;);&#xD;&#xA;              var ValSvmMode = SCM.getIntValue(ResSvmMode); &#xD;&#xA;&#xD;&#xA;             if (value == 1 ){ &#xD;&#xA;                SCM.setIntValue(ChNoRes,ChNo);&#xD;&#xA;                SCM.setIntValue(Fifoforce2,1);&#xD;&#xA;                SCM.setIntValue(Q2CurRes,1);&#xD;&#xA;                SCM.setIntValue(Q2CurRes1,1);&#xD;&#xA;                SCM.setIntValue(Q2RefRes,1);&#xD;&#xA;                SCM.setIntValue(Q2RefRes1,1);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriRes,1);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriRes1,1);&#xD;&#xA;            &#xD;&#xA;                SCM.setIntValue(Fifoforce,0);                &#xD;&#xA;                SCM.setIntValue(Q1CmRes,0);&#xD;&#xA;                SCM.setIntValue(Q1CmRes1,0);&#xD;&#xA;                SCM.setIntValue(Q1RefRes,0);&#xD;&#xA;                SCM.setIntValue(Q1RefRes1,0);&#xD;&#xA;                SCM.setIntValue(Q1ExtTriRes,0);&#xD;&#xA;                SCM.setIntValue(Q1ExtTriRes1,0);&#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(Fifoforce3,0);                &#xD;&#xA;                SCM.setIntValue(Q3CmRes,0);&#xD;&#xA;                SCM.setIntValue(Q3CmRes1,0);&#xD;&#xA;                SCM.setIntValue(Q3RefRes,0);&#xD;&#xA;                SCM.setIntValue(Q3RefRes1,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriRes,0);  &#xD;&#xA;                SCM.setIntValue(Q3ExtTriRes1,0);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if((ValSvmScheme==0)&amp;&amp; (ValSvmType==0)){&#xD;&#xA;&#x9;              SCM.setIntValue(Q2CurRes2,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q2CurRes3,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q2RefRes2,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q2RefRes3,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q2ExtTriRes2,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q2ExtTriRes3,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1CmRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1CmRes3,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1RefRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1RefRes3,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1ExtTriRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1ExtTriRes3,0);&#xD;&#xA;                  SCM.setIntValue(Q3CmRes2,0);&#xD;&#xA;                  SCM.setIntValue(Q3CmRes3,0);&#xD;&#xA;                  SCM.setIntValue(Q3RefRes2,0);&#xD;&#xA;                  SCM.setIntValue(Q3RefRes3,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriRes2,0); &#xD;&#xA;                  SCM.setIntValue(Q3ExtTriRes3,0);  &#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes1,1);&#xD;&#xA;                  SCM.setIntValue(Q1ExtTriModeRes0,1);&#xD;&#xA;                  SCM.setIntValue(Q1ExtTriModeRes1,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes0,1);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;             } else {&#xD;&#xA;                SCM.setIntValue(ChNoRes,ChNo); &#xD;&#xA;                SCM.setIntValue(Q2CurRes,0);&#xD;&#xA;                SCM.setIntValue(Q2CurRes1,0);&#xD;&#xA;                SCM.setIntValue(Q2RefRes,0);&#xD;&#xA;                SCM.setIntValue(Q2RefRes1,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriRes,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if((ValSvmScheme==0)&amp;&amp; (ValSvmType==0)){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(Q2CurRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q2CurRes3,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q2RefRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q2RefRes3,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q2ExtTriRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q2ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes0,1);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;             }  &#xD;&#xA;                var dep = &quot;DependentApp&quot;; &#xD;&#xA;                var queueapp3 = SCM.getResource(&quot;queueapp3&quot;); &#xD;&#xA;                SCM.setStringValue(queueapp3,dep); &#xD;&#xA;                var queueapp2 = SCM.getResource(&quot;queueapp2&quot;); &#xD;&#xA;                SCM.setStringValue(queueapp2,dep);      &#xD;&#xA;            &#xD;&#xA;           }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;            }&#xD;&#xA;        }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq2adccmcontrol/0" downWardmappedList="//@consumed.114 //@consumed.116 //@consumed.118 //@consumed.127 //@consumed.128 //@consumed.133 //@consumed.134 //@consumed.120 //@consumed.122 //@consumed.129 //@consumed.130 //@consumed.135 //@consumed.136 //@consumed.138 //@consumed.140 //@consumed.57 //@consumed.56" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Selects group B for current measurement.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Queue 2 Voltage Compensation" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq2adcvccontrol" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Selects group B for voltage compensation.</toolTipHelpDescription>
    <item name="Enable" evalFunction="            &#xD;&#xA;      function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;&#xD;&#xA;              var CurRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical4/ch51&quot;); &#xD;&#xA;              var RefRes = SCM.getResource(&quot;queueapp2/adc002_erwrefill4&quot;);&#xD;&#xA; &#xD;&#xA;              var Q1VcRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical4/ch51&quot;);&#xD;&#xA;              var Q1VcVal = SCM.getIntValue(Q1VcRes);&#xD;&#xA;              var Q1RefRes = SCM.getResource(&quot;queueapp/adc002_erwrefill4&quot;);&#xD;&#xA;&#xD;&#xA;              var ChNo =0;&#xD;&#xA;              var PotRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical5/ch62&quot;);&#xD;&#xA;              var PotVal = SCM.getIntValue(PotRes);  &#xD;&#xA;              &#xD;&#xA;              var Q1ChNoRes = SCM.getResource(&quot;queueapp/adc002_irwchannelnum&quot;);&#xD;&#xA;              var ChNoRes = SCM.getResource(&quot;queueapp2/adc002_irwchannelnum&quot;);     &#xD;&#xA;              if(value == 1)&#xD;&#xA;              {&#xD;&#xA;                ChNo =2;&#xD;&#xA;                if(PotVal != 1)&#xD;&#xA;                {&#xD;&#xA;                   SCM.setIntValue(Q1ChNoRes,1);&#xD;&#xA;                } &#xD;&#xA;              }   &#xD;&#xA;              else &#xD;&#xA;              {&#xD;&#xA;                ChNo =1;&#xD;&#xA;              } &#xD;&#xA;           &#xD;&#xA;             if (value == 1 ){ &#xD;&#xA;                SCM.setIntValue(CurRes,1);&#xD;&#xA;                SCM.setIntValue(RefRes,1);&#xD;&#xA;                SCM.setIntValue(ChNoRes,ChNo);&#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(Q1VcRes,0);&#xD;&#xA;                SCM.setIntValue(Q1RefRes,0);  &#xD;&#xA;             } else {&#xD;&#xA;                SCM.setIntValue(CurRes,0);&#xD;&#xA;                SCM.setIntValue(RefRes,0);&#xD;&#xA;                SCM.setIntValue(ChNoRes,ChNo);      &#xD;&#xA;             }  &#xD;&#xA;                var dep = &quot;DependentApp&quot;; &#xD;&#xA;                var queueapp3 = SCM.getResource(&quot;queueapp3&quot;); &#xD;&#xA;                SCM.setStringValue(queueapp3,dep); &#xD;&#xA;                var queueapp2 = SCM.getResource(&quot;queueapp2&quot;); &#xD;&#xA;                SCM.setStringValue(queueapp2,dep);      &#xD;&#xA;            &#xD;&#xA;           }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical4/ch51&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;            }&#xD;&#xA;        }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq2adcvccontrol/0" downWardmappedList="//@consumed.124 //@consumed.131 //@consumed.114 //@consumed.57 //@consumed.56" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Selects group B for voltage compensation.</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Queue 3 Current Measurement" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq3adccmcontrol" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Selects group C for current measurement</toolTipHelpDescription>
    <item name="Enable" evalFunction="            &#xD;&#xA;      function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;&#xD;&#xA;              var Fifoforce = SCM.getResource(&quot;queueapp/adc002_irwfocapp&quot;);&#xD;&#xA;              var Fifoforce2 = SCM.getResource(&quot;queueapp2/adc002_irwfocapp&quot;);&#xD;&#xA;              var Fifoforce3 = SCM.getResource(&quot;queueapp3/adc002_irwfocapp&quot;);&#xD;&#xA;              var Q2CmRes = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var Q2CmRes1 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical1/ch20&quot;);&#xD;&#xA;              var Q2CmRes2 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q2CmRes3 = SCM.getResource(&quot;queueapp2/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA; &#xD;&#xA;              var Q2RefRes = SCM.getResource(&quot;queueapp2/adc002_erwrefill0&quot;);&#xD;&#xA;              var Q2RefRes1 = SCM.getResource(&quot;queueapp2/adc002_erwrefill1&quot;);&#xD;&#xA;              var Q2RefRes2 = SCM.getResource(&quot;queueapp2/adc002_erwrefill2&quot;);&#xD;&#xA;              var Q2RefRes3 = SCM.getResource(&quot;queueapp2/adc002_erwrefill3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q2ExtTriRes = SCM.getResource(&quot;queueapp2/adc002_erwextrigger0&quot;);&#xD;&#xA;              var Q2ExtTriRes1 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger1&quot;);&#xD;&#xA;              var Q2ExtTriRes2 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q2ExtTriRes3 = SCM.getResource(&quot;queueapp2/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q1CmRes = SCM.getResource(&quot;queueapp/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var Q1CmRes1 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical1/ch20&quot;);&#xD;&#xA;              var Q1CmRes2 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q1CmRes3 = SCM.getResource(&quot;queueapp/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;              var Q1RefRes = SCM.getResource(&quot;queueapp/adc002_erwrefill0&quot;);&#xD;&#xA;              var Q1RefRes1 = SCM.getResource(&quot;queueapp/adc002_erwrefill1&quot;);&#xD;&#xA;              var Q1RefRes2 = SCM.getResource(&quot;queueapp/adc002_erwrefill2&quot;);&#xD;&#xA;              var Q1RefRes3 = SCM.getResource(&quot;queueapp/adc002_erwrefill3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q1ExtTriRes = SCM.getResource(&quot;queueapp/adc002_erwextrigger0&quot;);&#xD;&#xA;              var Q1ExtTriRes1 = SCM.getResource(&quot;queueapp/adc002_erwextrigger1&quot;);&#xD;&#xA;              var Q1ExtTriRes2 = SCM.getResource(&quot;queueapp/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q1ExtTriRes3 = SCM.getResource(&quot;queueapp/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q3CmRes = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical0/ch10&quot;);&#xD;&#xA;              var Q3CmRes1 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical1/ch20&quot;);&#xD;&#xA;              var Q3CmRes2 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical2/ch30&quot;);&#xD;&#xA;              var Q3CmRes3 = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical3/ch40&quot;);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;              var Q3RefRes = SCM.getResource(&quot;queueapp3/adc002_erwrefill0&quot;);&#xD;&#xA;              var Q3RefRes1 = SCM.getResource(&quot;queueapp3/adc002_erwrefill1&quot;);&#xD;&#xA;              var Q3RefRes2 = SCM.getResource(&quot;queueapp3/adc002_erwrefill2&quot;);&#xD;&#xA;              var Q3RefRes3 = SCM.getResource(&quot;queueapp3/adc002_erwrefill3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q3ExtTriRes = SCM.getResource(&quot;queueapp3/adc002_erwextrigger0&quot;);&#xD;&#xA;              var Q3ExtTriRes1 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger1&quot;);&#xD;&#xA;              var Q3ExtTriRes2 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger2&quot;);&#xD;&#xA;              var Q3ExtTriRes3 = SCM.getResource(&quot;queueapp3/adc002_erwextrigger3&quot;);&#xD;&#xA;&#xD;&#xA;              var Q2ExtTriModeRes0 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q2ExtTriModeRes1 = SCM.getResource(&quot;queueapp2/adc002_erwtrgmode/2&quot;);&#xD;&#xA;              var Q1ExtTriModeRes0 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q1ExtTriModeRes1 = SCM.getResource(&quot;queueapp/adc002_erwtrgmode/2&quot;);&#xD;&#xA;              var Q3ExtTriModeRes0 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/0&quot;);&#xD;&#xA;              var Q3ExtTriModeRes1 = SCM.getResource(&quot;queueapp3/adc002_erwtrgmode/2&quot;);&#xD;&#xA;&#xD;&#xA;              var ChNoRes = SCM.getResource(&quot;queueapp3/adc002_irwchannelnum&quot;); &#xD;&#xA;                     &#xD;&#xA;              var ResSvmScheme = SCM.getResource(&quot;svm/pwmsvm01_erwschemeofsvm&quot;);&#xD;&#xA;              var ValSvmScheme = SCM.getIntValue(ResSvmScheme); &#xD;&#xA;              var ResSvmType = SCM.getResource(&quot;svm/pwmsvm01_erwtypeofsvm&quot;);&#xD;&#xA;              var ValSvmType = SCM.getIntValue(ResSvmType); &#xD;&#xA;              var ResSvmMode = SCM.getResource(&quot;svm/pwmsvm01_erwsvmmodes&quot;);&#xD;&#xA;              var ValSvmMode = SCM.getIntValue(ResSvmMode); &#xD;&#xA;&#xD;&#xA;             if (value == 1 ){ &#xD;&#xA;                SCM.setIntValue(ChNoRes,1);&#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(Fifoforce3,1);               &#xD;&#xA;                SCM.setIntValue(Q3CmRes,1);&#xD;&#xA;                SCM.setIntValue(Q3CmRes1,1);&#xD;&#xA;                SCM.setIntValue(Q3RefRes,1);&#xD;&#xA;                SCM.setIntValue(Q3RefRes1,1);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriRes,1);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriRes1,1);&#xD;&#xA;            &#xD;&#xA;                SCM.setIntValue(Fifoforce,0);                &#xD;&#xA;                SCM.setIntValue(Q1CmRes,0);&#xD;&#xA;                SCM.setIntValue(Q1CmRes1,0);&#xD;&#xA;                SCM.setIntValue(Q1RefRes,0);&#xD;&#xA;                SCM.setIntValue(Q1RefRes1,0);&#xD;&#xA;                SCM.setIntValue(Q1ExtTriRes,0);&#xD;&#xA;                SCM.setIntValue(Q1ExtTriRes1,0);&#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(Fifoforce2,0);                &#xD;&#xA;                SCM.setIntValue(Q2CmRes,0);&#xD;&#xA;                SCM.setIntValue(Q2CmRes1,0);&#xD;&#xA;                SCM.setIntValue(Q2RefRes,0);&#xD;&#xA;                SCM.setIntValue(Q2RefRes1,0);&#xD;&#xA;                SCM.setIntValue(Q2ExtTriRes,0);  &#xD;&#xA;                SCM.setIntValue(Q2ExtTriRes1,0);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if((ValSvmScheme==0)&amp;&amp; (ValSvmType==0)){&#xD;&#xA;&#x9;              SCM.setIntValue(Q3CmRes2,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q3CmRes3,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q3RefRes2,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q3RefRes3,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q3ExtTriRes2,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q3ExtTriRes3,1);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1CmRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1CmRes3,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1RefRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1RefRes3,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1ExtTriRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q1ExtTriRes3,0);&#xD;&#xA;                  SCM.setIntValue(Q2CmRes2,0);&#xD;&#xA;                  SCM.setIntValue(Q2CmRes3,0);&#xD;&#xA;                  SCM.setIntValue(Q2RefRes2,0);&#xD;&#xA;                  SCM.setIntValue(Q2RefRes3,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriRes2,0); &#xD;&#xA;                  SCM.setIntValue(Q2ExtTriRes3,0);  &#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes0,0);&#xD;&#xA;                  SCM.setIntValue(Q3ExtTriModeRes1,1);&#xD;&#xA;                  SCM.setIntValue(Q1ExtTriModeRes0,1);&#xD;&#xA;                  SCM.setIntValue(Q1ExtTriModeRes1,0);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes0,1);&#xD;&#xA;                  SCM.setIntValue(Q2ExtTriModeRes1,0);&#xD;&#xA;             } else {&#xD;&#xA;                SCM.setIntValue(ChNoRes,0); &#xD;&#xA;                SCM.setIntValue(Q3CmRes,0);&#xD;&#xA;                SCM.setIntValue(Q3CmRes1,0);&#xD;&#xA;                SCM.setIntValue(Q3RefRes,0);&#xD;&#xA;                SCM.setIntValue(Q3RefRes1,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriRes,0);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriRes1,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if((ValSvmScheme==0)&amp;&amp; (ValSvmType==0)){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  SCM.setIntValue(Q3CmRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q3CmRes3,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q3RefRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q3RefRes3,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q3ExtTriRes2,0);&#xD;&#xA;&#x9;              SCM.setIntValue(Q3ExtTriRes3,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes0,1);&#xD;&#xA;                SCM.setIntValue(Q3ExtTriModeRes1,0);&#xD;&#xA;             }  &#xD;&#xA;                var dep = &quot;DependentApp&quot;; &#xD;&#xA;                var queueapp3 = SCM.getResource(&quot;queueapp3&quot;); &#xD;&#xA;                SCM.setStringValue(queueapp3,dep); &#xD;&#xA;                var queueapp2 = SCM.getResource(&quot;queueapp2&quot;); &#xD;&#xA;                SCM.setStringValue(queueapp2,dep);      &#xD;&#xA;            &#xD;&#xA;           }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;queueapp3/adc002_erwchannellogical0/ch10&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              if (value == 1 ) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;            }&#xD;&#xA;        }        " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_erwq3adccmcontrol/0" downWardmappedList="//@consumed.142 //@consumed.144 //@consumed.146 //@consumed.155 //@consumed.156 //@consumed.161 //@consumed.162 //@consumed.148 //@consumed.150 //@consumed.157 //@consumed.158 //@consumed.163 //@consumed.164 //@consumed.166 //@consumed.168 //@consumed.57 //@consumed.56" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Selects group C for current measurement</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Id Proportional Gain(Kp)" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_idkp&quot;);&#xD;&#xA;                SCM.setIntValue(Res,value);&#xD;&#xA; &#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA; &#x9;&#x9;&#x9;&#x9;var ShuntRes = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ShuntVal = SCM.getDoubleValue(ShuntRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainRes = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainVal = SCM.getDoubleValue(GainRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefRes = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefVal = SCM.getDoubleValue(AdcRefRes);&#xD;&#xA;                var PwmCountRes = SCM.getResource(&quot;svm/pwmsvm01_irperiodreg&quot;);&#xD;&#xA;                var PwmCountVal = SCM.getDoubleValue(PwmCountRes);&#xD;&#xA;                var PwmFreqRes = SCM.getResource(&quot;svm/pwmsvm01_irwpwmfreq&quot;);&#xD;&#xA;                var PwmFreqVal = SCM.getDoubleValue(PwmFreqRes);&#xD;&#xA;                var DeadTimeRes = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;                var DeadTimeVal = SCM.getDoubleValue(DeadTimeRes);&#xD;&#xA;                var SwitchDRes = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;);&#xD;&#xA;                var SwitchDVal = SCM.getDoubleValue(SwitchDRes);&#xD;&#xA;                var DcLinkVoltRes = SCM.getResource(&quot;temp_dc_voltage&quot;);&#xD;&#xA;                var DcLinkVoltVal = SCM.getIntValue(DcLinkVoltRes);&#xD;&#xA;                var Resccr = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;                var Valccr = SCM.getIntValue(Resccr);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndRes = SCM.getResource(&quot;temp_phase_ind&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndVal = SCM.getDoubleValue(IndRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Ampbias = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Ampval = SCM.getDoubleValue(Ampbias);&#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_idkp&quot;); &#xD;&#xA;                var Resvalue = SCM.getIntValue(Res);&#xD;&#xA;                var value1=0;&#xD;&#xA;&#xD;&#xA;                var value =0;&#xD;&#xA;                var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;                var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;                var k_Cordic=1;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;      k_Cordic  =1.64676;&#xD;&#xA;&#xD;&#xA;                var IPhaseScale =1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IClarkScale =-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IParkScale  =-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var VPhaseScale =0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var VClarkScale =0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var VParkScale  =-2;&#xD;&#xA;&#xD;&#xA; &#x9;&#x9;&#x9;&#x9;var ShuntRes = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ShuntVal = SCM.getDoubleValue(ShuntRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainRes = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainVal = SCM.getDoubleValue(GainRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefRes = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefVal = SCM.getDoubleValue(AdcRefRes);&#xD;&#xA;&#xD;&#xA;                var PwmCountRes = SCM.getResource(&quot;svm/pwmsvm01_irperiodreg&quot;);&#xD;&#xA;                var PwmCountVal = SCM.getDoubleValue(PwmCountRes);&#xD;&#xA;                var PwmFreqRes = SCM.getResource(&quot;svm/pwmsvm01_irwpwmfreq&quot;);&#xD;&#xA;                var PwmFreqVal = SCM.getDoubleValue(PwmFreqRes);&#xD;&#xA;&#xD;&#xA;                var DeadTimeRes = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;                var DeadTimeVal = SCM.getDoubleValue(DeadTimeRes);&#xD;&#xA;                var SwitchDRes = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;);&#xD;&#xA;                var SwitchDVal = SCM.getDoubleValue(SwitchDRes);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;ShuntVal =ShuntVal;&#xD;&#xA;                DeadTimeVal=DeadTimeVal/1000;&#xD;&#xA;                SwitchDVal =SwitchDVal/1000;&#xD;&#xA;&#xD;&#xA;                var DcLinkVoltRes = SCM.getResource(&quot;temp_dc_voltage&quot;);&#xD;&#xA;                var DcLinkVoltVal = SCM.getIntValue(DcLinkVoltRes);&#xD;&#xA;&#xD;&#xA;                var Resccr = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;                var Valccr = SCM.getIntValue(Resccr);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndRes = SCM.getResource(&quot;temp_phase_ind&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndVal = SCM.getDoubleValue(IndRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Ampbias = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Ampval = SCM.getDoubleValue(Ampbias);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;                var MaxCurrent =((AdcRefVal-Ampval)/(ShuntVal*GainVal));&#xD;&#xA;                var N_IPhase =((MaxCurrent*32767*(AdcRefVal/(AdcRefVal-Ampval)))/(4096*Math.pow(2,IPhaseScale)));&#xD;&#xA;                var N_IClark    =(N_IPhase/Math.pow(2,IClarkScale));&#xD;&#xA;                var N_IPark     =(N_IClark/(Math.pow(2,IParkScale)*k_Cordic));&#xD;&#xA;                var PWM_Period = 1000000/PwmFreqVal;&#xD;&#xA;                var temp = (PwmCountVal*(1-((DeadTimeVal+SwitchDVal+.1)/PWM_Period)));&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ks = (2*temp)/(Math.pow(2,11)*k_Cordic*k_Cordic*4*1.2);&#xD;&#xA;                var N_VPhase    =((DcLinkVoltVal*ks*32767)/temp);&#xD;&#xA;                var N_VClark    =(N_VPhase*k_Cordic/Math.pow(2,VClarkScale));&#xD;&#xA;                var N_VPark     =(N_VClark*k_Cordic/Math.pow(2,VParkScale));&#xD;&#xA;                &#xD;&#xA;                value = ((IndVal*N_IPark*64*4)/(2*N_VPark*PWM_Period));&#xD;&#xA;&#xD;&#xA;                if(IndVal &lt; 1000)&#xD;&#xA;                {&#xD;&#xA;                value = value*4;&#xD;&#xA;                }&#xD;&#xA;                else&#xD;&#xA;                {&#xD;&#xA;                value = value*2;&#xD;&#xA;                }&#xD;&#xA;&#xD;&#xA;                if(value &lt; 1)&#xD;&#xA;                {&#xD;&#xA;                 value = 1;&#xD;&#xA;                }&#xD;&#xA;                if(value >32767)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;value = 32767;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;                if (value3==0) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;value1=value;&#xD;&#xA;                 } else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (Resvalue==32768){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;      value1=value;&#xD;&#xA;                    } else {&#xD;&#xA;                      value1=Resvalue;&#xD;&#xA;                    }&#xD;&#xA;                } &#xD;&#xA;              SCM.setIntValue(currentResource,value1);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwidkp" downWardmappedList="//@consumed.8" maxValue="7FFF" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="eab"/>
    <toolTipHelpDescription>This is proportional gain value for Id.&#xD;
Multiplication factor is 2^9.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Id Integral Gain(Ki)" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_idki&quot;);&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;                SCM.setIntValue(Res,value);      &#xD;&#xA;&#xD;&#xA; &#x9;&#x9;&#x9;&#x9;var ShuntRes = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ShuntVal = SCM.getDoubleValue(ShuntRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainRes = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainVal = SCM.getDoubleValue(GainRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefRes = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefVal = SCM.getDoubleValue(AdcRefRes);&#xD;&#xA;                var PwmCountRes = SCM.getResource(&quot;svm/pwmsvm01_irperiodreg&quot;);&#xD;&#xA;                var PwmCountVal = SCM.getDoubleValue(PwmCountRes);&#xD;&#xA;                var PwmFreqRes = SCM.getResource(&quot;svm/pwmsvm01_irwpwmfreq&quot;);&#xD;&#xA;                var PwmFreqVal = SCM.getDoubleValue(PwmFreqRes);&#xD;&#xA;                var DeadTimeRes = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;                var DeadTimeVal = SCM.getDoubleValue(DeadTimeRes);&#xD;&#xA;                var SwitchDRes = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;);&#xD;&#xA;                var SwitchDVal = SCM.getDoubleValue(SwitchDRes);&#xD;&#xA;                var DcLinkVoltRes = SCM.getResource(&quot;temp_dc_voltage&quot;);&#xD;&#xA;                var DcLinkVoltVal = SCM.getIntValue(DcLinkVoltRes);&#xD;&#xA;                var Resccr = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;                var Valccr = SCM.getIntValue(Resccr);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndRes = SCM.getResource(&quot;temp_phase_ind&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndVal = SCM.getDoubleValue(IndRes); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ResRes = SCM.getResource(&quot;temp_phase_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ResVal = SCM.getDoubleValue(ResRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Ampbias = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Ampval = SCM.getDoubleValue(Ampbias);&#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_idki&quot;);&#xD;&#xA;                var Resvalue = SCM.getIntValue(Res);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value1=0;&#xD;&#xA;&#xD;&#xA;                   var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;                    var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;                    var k_Cordic=1;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;      k_Cordic  =1.64676;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;                var IPhaseScale =1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var IClarkScale =-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var IParkScale  =-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var VPhaseScale =0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var VClarkScale =0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var VParkScale  =-2;&#xD;&#xA;&#x9;&#xD;&#xA;&#x9; &#x9;&#x9;&#x9;&#x9;var ShuntRes = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var ShuntVal = SCM.getDoubleValue(ShuntRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var GainRes = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var GainVal = SCM.getDoubleValue(GainRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var AdcRefRes = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var AdcRefVal = SCM.getDoubleValue(AdcRefRes);&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;                var PwmCountRes = SCM.getResource(&quot;svm/pwmsvm01_irperiodreg&quot;);&#xD;&#xA;&#x9;                var PwmCountVal = SCM.getDoubleValue(PwmCountRes);&#xD;&#xA;&#x9;                var PwmFreqRes = SCM.getResource(&quot;svm/pwmsvm01_irwpwmfreq&quot;);&#xD;&#xA;&#x9;                var PwmFreqVal = SCM.getDoubleValue(PwmFreqRes);&#xD;&#xA;&#x9;                var DeadTimeRes = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;&#x9;                var DeadTimeVal = SCM.getDoubleValue(DeadTimeRes);&#xD;&#xA;&#x9;                var SwitchDRes = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;);&#xD;&#xA;&#x9;                var SwitchDVal = SCM.getDoubleValue(SwitchDRes);&#xD;&#xA;                    DeadTimeVal=DeadTimeVal/1000;&#xD;&#xA;                    SwitchDVal =SwitchDVal/1000;&#xD;&#xA;&#x9;                var DcLinkVoltRes = SCM.getResource(&quot;temp_dc_voltage&quot;);&#xD;&#xA;&#x9;                var DcLinkVoltVal = SCM.getIntValue(DcLinkVoltRes);&#xD;&#xA;&#x9;&#xD;&#xA;                    var Resccr = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;                    var Valccr = SCM.getIntValue(Resccr);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var IndRes = SCM.getResource(&quot;temp_phase_ind&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var IndVal = SCM.getDoubleValue(IndRes);&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var ResRes = SCM.getResource(&quot;temp_phase_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    var ResVal = SCM.getDoubleValue(ResRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    var Ampbias = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    var Ampval = SCM.getDoubleValue(Ampbias);&#xD;&#xA;                    ResVal =ResVal/1000;&#xD;&#xA;&#xD;&#xA;&#x9;                var MaxCurrent =((AdcRefVal-Ampval)/(ShuntVal*GainVal));&#xD;&#xA;                    var N_IPhase =((MaxCurrent*32767*(AdcRefVal/(AdcRefVal-Ampval)))/(4096*Math.pow(2,IPhaseScale)));&#xD;&#xA;&#x9;                var N_IClark    =(N_IPhase/Math.pow(2,IClarkScale));&#xD;&#xA;&#x9;                var N_IPark     =(N_IClark/(Math.pow(2,IParkScale)*k_Cordic));&#xD;&#xA;&#xD;&#xA;&#x9;                var PWM_Period = 1000000/PwmFreqVal;&#xD;&#xA;&#x9;                var temp = (PwmCountVal*(1-((DeadTimeVal+SwitchDVal+.1)/(PWM_Period))));&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var ks = (2*temp)/(Math.pow(2,11)*k_Cordic*k_Cordic*4*1.2);&#xD;&#xA;&#x9;                var N_VPhase    =((DcLinkVoltVal*ks*32767)/temp);&#xD;&#xA;&#xD;&#xA;&#x9;                var N_VClark    =(N_VPhase*k_Cordic/Math.pow(2,VClarkScale));&#xD;&#xA;&#x9;                var N_VPark     =(N_VClark*k_Cordic/Math.pow(2,VParkScale));&#xD;&#xA;&#xD;&#xA;                    var value = (ResVal*N_IPark*64*2)/(N_VPark*2*2);&#xD;&#xA;                    if(value &lt; 1)&#xD;&#xA;                    {&#xD;&#xA;                     value = 1;&#xD;&#xA;                    }&#xD;&#xA;                    if(value >32767)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;value = 32767;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;                if (value3==0) {&#xD;&#xA;                  value1=value;&#xD;&#xA;                } else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (Resvalue==32768){&#xD;&#xA;                     value1=value;&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;                     value1=Resvalue;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;                } &#xD;&#xA;              SCM.setIntValue(currentResource,value1);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwidki" downWardmappedList="//@consumed.9" maxValue="7FFF" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="29"/>
    <toolTipHelpDescription>This is integral gain value for Id.&#xD;
Multiplication factor is 2^15</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Id PI Ymax" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;              var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_idpiymax&quot;);&#xD;&#xA;              SCM.setDoubleValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;          function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_idpiymax&quot;); &#xD;&#xA;              var Resvalue = SCM.getDoubleValue(Res); &#xD;&#xA; &#xD;&#xA;              var value1=100;&#xD;&#xA;&#x9;&#x9;&#x9;  var value=0;&#xD;&#xA;              if(value3 == 0)&#xD;&#xA;              {&#xD;&#xA;                 value=value1;&#xD;&#xA;              }&#xD;&#xA;              else&#xD;&#xA;              {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if (Resvalue==101){&#xD;&#xA;                 value=value1&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9; value=Resvalue;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;              }&#xD;&#xA;             SCM.setDoubleValue(currentResource,value);&#xD;&#xA;        }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwidpiymaxlimit" downWardmappedList="//@consumed.2" maxValue="64" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <localValue xsi:type="ResourceModel:StringValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="64"/>
    <toolTipHelpDescription>This is PI Controller Output limit value&#xD;
100% = full dutycycle</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="ID PI Yimax" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;              var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_idpiyimax&quot;);&#xD;&#xA;              SCM.setDoubleValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_idpiyimax&quot;); &#xD;&#xA;              var Resvalue = SCM.getDoubleValue(Res); &#xD;&#xA; &#xD;&#xA;              var value1=100;&#xD;&#xA;&#x9;&#x9;&#x9;  var value=0;&#xD;&#xA;&#xD;&#xA;              if(value3 == 0)&#xD;&#xA;              {&#xD;&#xA;                 value=value1;&#xD;&#xA;              }&#xD;&#xA;              else&#xD;&#xA;              {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if (Resvalue==101){&#xD;&#xA;                 value=value1&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9; value=Resvalue;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;              }&#xD;&#xA;             SCM.setDoubleValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwidpiyimaxlimit" downWardmappedList="//@consumed.3" maxValue="64" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <localValue xsi:type="ResourceModel:StringValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="64"/>
    <toolTipHelpDescription>This is Integral Buffer Limit &#xD;
100% = full dutycycle</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Iq Proportional Gain(Kp)" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_iqkp&quot;);&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;                SCM.setIntValue(Res,value);   &#xD;&#xA;&#xD;&#xA; &#x9;&#x9;&#x9;&#x9;var ShuntRes = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ShuntVal = SCM.getDoubleValue(ShuntRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainRes = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainVal = SCM.getDoubleValue(GainRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefRes = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefVal = SCM.getDoubleValue(AdcRefRes);&#xD;&#xA;&#xD;&#xA;                var PwmCountRes = SCM.getResource(&quot;svm/pwmsvm01_irperiodreg&quot;);&#xD;&#xA;                var PwmCountVal = SCM.getDoubleValue(PwmCountRes);&#xD;&#xA;                var PwmFreqRes = SCM.getResource(&quot;svm/pwmsvm01_irwpwmfreq&quot;);&#xD;&#xA;                var PwmFreqVal = SCM.getDoubleValue(PwmFreqRes);&#xD;&#xA;                var DeadTimeRes = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;                var DeadTimeVal = SCM.getDoubleValue(DeadTimeRes);&#xD;&#xA;                var SwitchDRes = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;);&#xD;&#xA;                var SwitchDVal = SCM.getDoubleValue(SwitchDRes);&#xD;&#xA;&#xD;&#xA;                var DcLinkVoltRes = SCM.getResource(&quot;temp_dc_voltage&quot;);&#xD;&#xA;                var DcLinkVoltVal = SCM.getIntValue(DcLinkVoltRes);&#xD;&#xA;&#xD;&#xA;                var Resccr = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;                var Valccr = SCM.getIntValue(Resccr);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndRes = SCM.getResource(&quot;temp_phase_ind&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndVal = SCM.getDoubleValue(IndRes);  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Ampbias = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Ampval = SCM.getDoubleValue(Ampbias);   &#xD;&#xA;             }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;             {&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_iqkp&quot;); &#xD;&#xA;                var Resvalue = SCM.getIntValue(Res);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value1=0;&#xD;&#xA;&#xD;&#xA;                    var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;                    var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;                    var k_Cordic=1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;      k_Cordic  =1.64676;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;                var IPhaseScale =1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var IClarkScale =-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var IParkScale  =-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var VPhaseScale =0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var VClarkScale =0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var VParkScale  =-2;&#xD;&#xA;&#x9; &#x9;&#x9;&#x9;&#x9;var ShuntRes = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var ShuntVal = SCM.getDoubleValue(ShuntRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var GainRes = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var GainVal = SCM.getDoubleValue(GainRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var AdcRefRes = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var AdcRefVal = SCM.getDoubleValue(AdcRefRes);&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;                var PwmCountRes = SCM.getResource(&quot;svm/pwmsvm01_irperiodreg&quot;);&#xD;&#xA;&#x9;                var PwmCountVal = SCM.getDoubleValue(PwmCountRes);&#xD;&#xA;&#x9;                var PwmFreqRes = SCM.getResource(&quot;svm/pwmsvm01_irwpwmfreq&quot;);&#xD;&#xA;&#x9;                var PwmFreqVal = SCM.getDoubleValue(PwmFreqRes);&#xD;&#xA;&#x9;                var DeadTimeRes = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;&#x9;                var DeadTimeVal = SCM.getDoubleValue(DeadTimeRes);&#xD;&#xA;&#x9;                var SwitchDRes = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;);&#xD;&#xA;&#x9;                var SwitchDVal = SCM.getDoubleValue(SwitchDRes);&#xD;&#xA;&#xD;&#xA;                    DeadTimeVal=DeadTimeVal/1000;&#xD;&#xA;                    SwitchDVal =SwitchDVal/1000;&#xD;&#xA;&#xD;&#xA;&#x9;                var DcLinkVoltRes = SCM.getResource(&quot;temp_dc_voltage&quot;);&#xD;&#xA;&#x9;                var DcLinkVoltVal = SCM.getIntValue(DcLinkVoltRes);&#xD;&#xA;&#x9;&#xD;&#xA;                    var Resccr = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;                    var Valccr = SCM.getIntValue(Resccr);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var IndRes = SCM.getResource(&quot;temp_phase_ind&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var IndVal = SCM.getDoubleValue(IndRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    var Ampbias = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    var Ampval = SCM.getDoubleValue(Ampbias);&#x9;&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;                var MaxCurrent =((AdcRefVal-Ampval)/(ShuntVal*GainVal));&#xD;&#xA;                    var N_IPhase =((MaxCurrent*32767*(AdcRefVal/(AdcRefVal-Ampval)))/(4096*Math.pow(2,IPhaseScale)));&#xD;&#xA;&#x9;                var N_IClark    =(N_IPhase/Math.pow(2,IClarkScale));&#xD;&#xA;&#x9;                var N_IPark     =(N_IClark/(Math.pow(2,IParkScale)*k_Cordic));&#xD;&#xA;&#x9;                var PWM_Period = 1000000/PwmFreqVal;&#xD;&#xA;&#x9;                var temp = (PwmCountVal*(1-((DeadTimeVal+SwitchDVal+.1)/(PWM_Period*1000))));&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var ks = (2*temp)/(Math.pow(2,11)*k_Cordic*k_Cordic*4*1.2);&#xD;&#xA;&#x9;                var N_VPhase    =((DcLinkVoltVal*ks*32767)/temp);&#xD;&#xA;                    var N_VClark    =(N_VPhase*k_Cordic/Math.pow(2,VClarkScale));&#xD;&#xA;&#x9;                var N_VPark     =(N_VClark*k_Cordic/Math.pow(2,VParkScale));&#xD;&#xA;&#xD;&#xA;                    var value = (IndVal*N_IPark*64*2*2)/(2*N_VPark*PWM_Period);&#xD;&#xA;&#xD;&#xA;&#x9;                if(IndVal &lt; 1000)&#xD;&#xA;&#x9;                {&#xD;&#xA;&#x9;                value = value*4;&#xD;&#xA;&#x9;                }&#xD;&#xA;&#x9;                else&#xD;&#xA;&#x9;                {&#xD;&#xA;&#x9;                value = value*2;&#xD;&#xA;&#x9;                }&#xD;&#xA;&#xD;&#xA;                    if(value &lt; 1)&#xD;&#xA;                    {&#xD;&#xA;                     value = 1;&#xD;&#xA;                    }&#xD;&#xA;                    if(value >32767)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;value = 32767;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;                if (value3==0) {&#xD;&#xA;                  value1=value;&#xD;&#xA;                } else if (value3==1) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (Resvalue==32768){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  value1=value;&#x9;&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  value1=Resvalue;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;                } &#xD;&#xA;              SCM.setIntValue(currentResource,value1);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwiqkp" downWardmappedList="//@consumed.10" maxValue="7FFF" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="eab"/>
    <toolTipHelpDescription>This is proportional gain value for Iq.&#xD;
Multiplication factor is 2^9.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Iq Integral Gain(Ki)" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_iqki&quot;);&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;                SCM.setIntValue(Res,value);  &#xD;&#xA;      &#xD;&#xA; &#x9;&#x9;&#x9;&#x9;var ShuntRes = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ShuntVal = SCM.getDoubleValue(ShuntRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainRes = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainVal = SCM.getDoubleValue(GainRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefRes = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefVal = SCM.getDoubleValue(AdcRefRes);&#xD;&#xA;                var PwmCountRes = SCM.getResource(&quot;svm/pwmsvm01_irperiodreg&quot;);&#xD;&#xA;                var PwmCountVal = SCM.getDoubleValue(PwmCountRes);&#xD;&#xA;                var PwmFreqRes = SCM.getResource(&quot;svm/pwmsvm01_irwpwmfreq&quot;);&#xD;&#xA;                var PwmFreqVal = SCM.getDoubleValue(PwmFreqRes);&#xD;&#xA;                var DeadTimeRes = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;                var DeadTimeVal = SCM.getDoubleValue(DeadTimeRes);&#xD;&#xA;                var SwitchDRes = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;);&#xD;&#xA;                var SwitchDVal = SCM.getDoubleValue(SwitchDRes);&#xD;&#xA;                var DcLinkVoltRes = SCM.getResource(&quot;temp_dc_voltage&quot;);&#xD;&#xA;                var DcLinkVoltVal = SCM.getIntValue(DcLinkVoltRes);&#xD;&#xA;               &#xD;&#xA;                var Resccr = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;                var Valccr = SCM.getIntValue(Resccr);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndRes = SCM.getResource(&quot;temp_phase_ind&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndVal = SCM.getDoubleValue(IndRes); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ResRes = SCM.getResource(&quot;temp_phase_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ResVal = SCM.getDoubleValue(ResRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Ampbias = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Ampval = SCM.getDoubleValue(Ampbias);&#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_iqki&quot;); &#xD;&#xA;                var Resvalue = SCM.getIntValue(Res);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value1=0;&#xD;&#xA;&#xD;&#xA;                var XMC1302 = SCM.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;                var XMC4500 = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;                var k_Cordic=1;&#xD;&#xA;&#x9;&#x9;&#x9;   &#xD;&#xA;&#x9;&#x9;&#x9;      k_Cordic  =1.64676;&#xD;&#xA;&#x9;&#x9;&#x9;&#xD;&#xA;                var IPhaseScale =1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IClarkScale =-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IParkScale  =-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var VPhaseScale =0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var VClarkScale =0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var VParkScale  =-2;&#xD;&#xA;&#xD;&#xA; &#x9;&#x9;&#x9;&#x9;var ShuntRes = SCM.getResource(&quot;temp_shunt_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ShuntVal = SCM.getDoubleValue(ShuntRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainRes = SCM.getResource(&quot;temp_curnt_gain&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var GainVal = SCM.getDoubleValue(GainRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefRes = SCM.getResource(&quot;temp_vadcref&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var AdcRefVal = SCM.getDoubleValue(AdcRefRes);&#xD;&#xA;&#xD;&#xA;                var PwmCountRes = SCM.getResource(&quot;svm/pwmsvm01_irperiodreg&quot;);&#xD;&#xA;                var PwmCountVal = SCM.getDoubleValue(PwmCountRes);&#xD;&#xA;                var PwmFreqRes = SCM.getResource(&quot;svm/pwmsvm01_irwpwmfreq&quot;);&#xD;&#xA;                var PwmFreqVal = SCM.getDoubleValue(PwmFreqRes);&#xD;&#xA;                var DeadTimeRes = SCM.getResource(&quot;svm/pwmsvm01_irwdeadtime&quot;);&#xD;&#xA;                var DeadTimeVal = SCM.getDoubleValue(DeadTimeRes);&#xD;&#xA;                var SwitchDRes = SCM.getResource(&quot;svm/pwmsvm01_irwdswitchdelay&quot;);&#xD;&#xA;                var SwitchDVal = SCM.getDoubleValue(SwitchDRes);&#xD;&#xA;&#xD;&#xA;                DeadTimeVal=DeadTimeVal/1000;&#xD;&#xA;                SwitchDVal =SwitchDVal/1000;&#xD;&#xA;&#xD;&#xA;                var DcLinkVoltRes = SCM.getResource(&quot;temp_dc_voltage&quot;);&#xD;&#xA;                var DcLinkVoltVal = SCM.getIntValue(DcLinkVoltRes);&#xD;&#xA;&#xD;&#xA;                var Resccr = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;                var Valccr = SCM.getIntValue(Resccr);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndRes = SCM.getResource(&quot;temp_phase_ind&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var IndVal = SCM.getDoubleValue(IndRes);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ResRes = SCM.getResource(&quot;temp_phase_res&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;    var ResVal = SCM.getDoubleValue(ResRes);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    var Ampbias = SCM.getResource(&quot;temp_biasvoltage&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;    var Ampval = SCM.getDoubleValue(Ampbias);&#xD;&#xA;                ResVal =ResVal/1000;&#xD;&#xA;&#xD;&#xA;                var MaxCurrent =((AdcRefVal-Ampval)/(ShuntVal*GainVal));&#xD;&#xA;                var N_IPhase =((MaxCurrent*32767*(AdcRefVal/(AdcRefVal-Ampval)))/(4096*Math.pow(2,IPhaseScale)));&#xD;&#xA;                var N_IClark    =(N_IPhase/Math.pow(2,IClarkScale));&#xD;&#xA;                var N_IPark     =(N_IClark/(Math.pow(2,IParkScale)*k_Cordic));&#xD;&#xA;                var PWM_Period = 1000000/PwmFreqVal;&#xD;&#xA;                var temp = (PwmCountVal*(1-((DeadTimeVal+SwitchDVal+.1)/(PWM_Period*1000))));&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var ks = (2*temp)/(Math.pow(2,11)*k_Cordic*k_Cordic*4*1.2);&#xD;&#xA;                var N_VPhase    =((DcLinkVoltVal*ks*32767)/temp);&#xD;&#xA;                var N_VClark    =(N_VPhase*k_Cordic/Math.pow(2,VClarkScale));&#xD;&#xA;                var N_VPark     =(N_VClark*k_Cordic/Math.pow(2,VParkScale));&#xD;&#xA;&#xD;&#xA;                var value = ((ResVal*N_IPark*64*2)/(2*N_VPark*2));&#xD;&#xA;                if(value &lt; 1)&#xD;&#xA;                {&#xD;&#xA;                 value = 1;&#xD;&#xA;                }&#xD;&#xA;                if(value >32767)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;value = 32767;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;                if (value3==0) {&#xD;&#xA;                  value1=value;&#xD;&#xA;                } else if (value3==1) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (Resvalue==32768){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  value1=value;&#x9;&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  value1=Resvalue;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;                } &#xD;&#xA;              SCM.setIntValue(currentResource,value1);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwiqki" downWardmappedList="//@consumed.11" maxValue="7FFF" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="29"/>
    <toolTipHelpDescription>This is integral gain value for Iq.&#xD;
Multiplication factor is 2^15</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Iq PI Ymax" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;              var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_iqpiymax&quot;);&#xD;&#xA;              SCM.setDoubleValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;          function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_iqpiymax&quot;); &#xD;&#xA;               var Resvalue = SCM.getDoubleValue(Res); &#xD;&#xA; &#xD;&#xA;              var value1=100;&#xD;&#xA;&#x9;&#x9;&#x9;  var value=0;&#xD;&#xA;&#xD;&#xA;              if(value3 == 0)&#xD;&#xA;              {&#xD;&#xA;                 value=value1;&#xD;&#xA;              }&#xD;&#xA;              else&#xD;&#xA;              {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if (Resvalue==101){&#xD;&#xA;                 value=value1&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9; value=Resvalue;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;              }&#xD;&#xA;             SCM.setDoubleValue(currentResource,value);&#xD;&#xA;        }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwiqpiymaxlimit" downWardmappedList="//@consumed.4" maxValue="64" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <localValue xsi:type="ResourceModel:StringValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="64"/>
    <toolTipHelpDescription>This is PI Controller Output limit value&#xD;
100% = full dutycycle</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Iq PI Yimax" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;              var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_iqpiyimax&quot;);&#xD;&#xA;              SCM.setDoubleValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_iqpiyimax&quot;); &#xD;&#xA;               var Resvalue = SCM.getDoubleValue(Res); &#xD;&#xA; &#xD;&#xA;              var value1=100;&#xD;&#xA;&#x9;&#x9;&#x9;  var value=0;&#xD;&#xA;&#xD;&#xA;              if(value3 == 0)&#xD;&#xA;              {&#xD;&#xA;                 value=value1;&#xD;&#xA;              }&#xD;&#xA;              else&#xD;&#xA;              {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if (Resvalue==101){&#xD;&#xA;                 value=value1&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9; value=Resvalue;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;              }&#xD;&#xA;             SCM.setDoubleValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwiqpiyimaxlimit" downWardmappedList="//@consumed.5" maxValue="64" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <localValue xsi:type="ResourceModel:StringValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="64"/>
    <toolTipHelpDescription>This is Integral Buffer Limit &#xD;
100% = full dutycycle</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Speed Proportional Gain(Kp)" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_speedkp&quot;);&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;                var Resscr = SCM.getResource(&quot;temp_scr&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Resccr = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;                var Valscr = SCM.getIntValue(Resscr);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Valccr = SCM.getIntValue(Resccr);&#xD;&#xA;                var Respolepair = SCM.getResource(&quot;temp_pole_pair&quot;);&#xD;&#xA;                var Valpolepair = SCM.getDoubleValue(Respolepair);&#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res = SCM.getResource(&quot;temp_speedkp&quot;); &#xD;&#xA;                var Resvalue = SCM.getIntValue(Res);&#xD;&#xA;&#xD;&#xA;&#x9;            var Resscr = SCM.getResource(&quot;temp_scr&quot;);&#xD;&#xA;&#x9;            var Valscr = SCM.getIntValue(Resscr);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Resccr = SCM.getResource(&quot;temp_ccr&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Valccr = SCM.getIntValue(Resccr);&#xD;&#xA;&#x9;            var Respolepair = SCM.getResource(&quot;temp_pole_pair&quot;);&#xD;&#xA;&#x9;            var Valpolepair = SCM.getIntValue(Respolepair);&#xD;&#xA;&#xD;&#xA;                var XMC4xxx = SCM.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;&#x9;            var value1 =0;&#xD;&#xA;                if(XMC4xxx==0)&#xD;&#xA;                {&#xD;&#xA;                  value1 = 6400; &#xD;&#xA;                } else {&#xD;&#xA;&#x9;              value1 = 6400/Valpolepair; &#xD;&#xA;                }&#xD;&#xA;                var value  =0;&#xD;&#xA;                if (value3==0) {&#xD;&#xA;                   value=value1;&#xD;&#xA;                } else if (value3==1) {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  if (Resvalue==32768){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;   value=value1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  }&#x9;else {&#xD;&#xA;                   value=Resvalue;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;  }&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#xD;&#xA;                } &#xD;&#xA;                SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwspeedkp" downWardmappedList="//@consumed.12" maxValue="7FFF" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="640"/>
    <toolTipHelpDescription>This is proportional gain value for Speed.&#xD;
Multiplication factor is 2^9.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Speed Integral Gain(Ki)" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var value = SCM.getIntValue(currentResource);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_speedki&quot;);&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getIntValue(Res3);     &#xD;&#xA;                SCM.setIntValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;                var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;                var value3 = SCM.getIntValue(Res3);&#xD;&#xA;                var Res = SCM.getResource(&quot;temp_speedki&quot;); &#xD;&#xA;                var value = SCM.getIntValue(Res);&#xD;&#xA;                var value1 = (0.15*64);&#xD;&#xA;                if(value1 &lt; 1)&#xD;&#xA;                {&#xD;&#xA;                 value1 = 1;&#xD;&#xA;                }&#xD;&#xA;                if (value3==0) {&#xD;&#xA;                  value=value1;&#xD;&#xA;                } else if (value3==1) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (value==32768){&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  value=value1;&#x9;&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  value=value;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;                } &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwspeedki" downWardmappedList="//@consumed.13" maxValue="7FFF" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="9"/>
    <toolTipHelpDescription>This is integral gain value for speed.&#xD;
Multiplication factor is 2^15</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Speed PI Ymax" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;              var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_speedpiymax&quot;);&#xD;&#xA;              SCM.setDoubleValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;          function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_speedpiymax&quot;); &#xD;&#xA;              var Resvalue = SCM.getDoubleValue(Res); &#xD;&#xA;&#xD;&#xA;              var value1=100;&#xD;&#xA;&#x9;&#x9;&#x9;  var value=0;&#xD;&#xA;&#xD;&#xA;              if(value3 == 0)&#xD;&#xA;              {&#xD;&#xA;                 value=value1;&#xD;&#xA;              }&#xD;&#xA;              else&#xD;&#xA;              {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if (Resvalue==101){&#xD;&#xA;                 value=value1&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9; value=Resvalue;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;              }&#xD;&#xA;              SCM.setDoubleValue(currentResource,value);&#xD;&#xA;        }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwspeedpiymaxlimit" downWardmappedList="//@consumed.6" maxValue="64" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <localValue xsi:type="ResourceModel:StringValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="64"/>
    <toolTipHelpDescription>This is PI Controller Output limit value&#xD;
100% = full dutycycle</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Speed PI Yimax" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;              var value = SCM.getDoubleValue(currentResource);&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_speedpiyimax&quot;);&#xD;&#xA;              SCM.setDoubleValue(Res,value);        &#xD;&#xA;            }&#xD;&#xA;             function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res3 = SCM.getResource(&quot;temp_config&quot;);&#xD;&#xA;              var value3 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;              var Res = SCM.getResource(&quot;temp_speedpiyimax&quot;); &#xD;&#xA;              var Resvalue = SCM.getDoubleValue(Res); &#xD;&#xA; &#xD;&#xA;              var value1=100;&#xD;&#xA;&#x9;&#x9;&#x9;  var value=0;&#xD;&#xA;&#xD;&#xA;              if(value3 == 0)&#xD;&#xA;              {&#xD;&#xA;                 value=value1;&#xD;&#xA;              }&#xD;&#xA;              else&#xD;&#xA;              {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;if (Resvalue==101){&#xD;&#xA;                 value=value1&#x9;&#x9;  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;} else {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9; value=Resvalue;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;              }&#xD;&#xA;             SCM.setDoubleValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/pmsmfocsl01_irwspeedpiyimaxlimit" downWardmappedList="//@consumed.7" maxValue="64" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <localValue xsi:type="ResourceModel:StringValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="64"/>
    <toolTipHelpDescription>This is Integral Buffer Limit &#xD;
100% = full dutycycle</toolTipHelpDescription>
  </provided>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_biasvoltcal" upWardMappingList="//@provided.23/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_biasvoltage" upWardMappingList="//@provided.24 //@provided.25 //@provided.57 //@provided.67 //@provided.68 //@provided.71 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="9c4"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="9c4"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_idpiymax" upWardMappingList="//@provided.69" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_idpiyimax" upWardMappingList="//@provided.70" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_iqpiymax" upWardMappingList="//@provided.73" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_iqpiyimax" upWardMappingList="//@provided.74" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_speedpiymax" upWardMappingList="//@provided.77" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_speedpiyimax" upWardMappingList="//@provided.78" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="65"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_idkp" upWardMappingList="//@provided.67" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_idki" upWardMappingList="//@provided.68" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_iqkp" upWardMappingList="//@provided.71" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_iqki" upWardMappingList="//@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_speedkp" upWardMappingList="//@provided.75" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_speedki" upWardMappingList="//@provided.76" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_startup" upWardMappingList="//@provided.49/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_vc" upWardMappingList="//@provided.15/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_pm" upWardMappingList="//@provided.12/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_motdir" upWardMappingList="//@provided.50 //@provided.50/@item.0 //@provided.50/@item.1" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_max_volt_lim" upWardMappingList="//@provided.11" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="64"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="64"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_max_crnt_lim" isSystemDefined="true">
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_voltage_dratio" upWardMappingList="//@provided.58" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_vadcref" upWardMappingList="//@provided.24 //@provided.25 //@provided.57 //@provided.67 //@provided.68 //@provided.71 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1388"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1388"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_enable_overcurrent" isSystemDefined="true">
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_slice_0_int_prio" upWardMappingList="//@provided.35" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="3"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="3"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_trap_0_int_prio" upWardMappingList="//@provided.38" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_slice_3_int_prio" upWardMappingList="//@provided.41" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="3"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="3"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_slice_0_int_sub_prio" upWardMappingList="//@provided.36" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_enable_autorun" upWardMappingList="//@provided.9 //@provided.9/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_pole_pair" upWardMappingList="//@provided.33 //@provided.46 //@provided.51 //@provided.75" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="4"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="4"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_ref_motor_speed" upWardMappingList="//@provided.44" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="5dc"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="5dc"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_dc_voltage" upWardMappingList="//@provided.16 //@provided.67 //@provided.68 //@provided.71 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="18"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="18"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_switch_delay" isSystemDefined="true">
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_nominal_voltage" upWardMappingList="//@provided.26 //@provided.51 //@provided.52" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="18"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="18"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_bs" upWardMappingList="//@provided.13 //@provided.13/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_bsvalue" upWardMappingList="//@provided.14" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="2"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="2"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_nominal_current" upWardMappingList="//@provided.27" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1f3"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f3"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_threshold" upWardMappingList="//@provided.46" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="c8"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="c8"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_thresholdtmp" isSystemDefined="true">
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_nominal_speed" upWardMappingList="//@provided.28 //@provided.51" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="ac8"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="ac8"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_nominal_frequency" upWardMappingList="//@provided.29" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="32"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="32"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_nominal_torque" upWardMappingList="//@provided.30" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="4039800000000000"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="4039800000000000"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_phase_res" upWardMappingList="//@provided.31 //@provided.68 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="3584"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="3584"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_phase_ind" upWardMappingList="//@provided.32 //@provided.67 //@provided.68 //@provided.71 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1e32"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1e32"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_vf_constant" upWardMappingList="//@provided.51" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="29"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="29"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_slew_rate" upWardMappingList="//@provided.47" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1f4"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f4"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_voltage_offset" upWardMappingList="//@provided.52" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="30d41"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="30d41"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_ccr" upWardMappingList="//@provided.7 //@provided.8 //@provided.67 //@provided.68 //@provided.71 //@provided.72 //@provided.75" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="3"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="3"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_scr" upWardMappingList="//@provided.7 //@provided.8 //@provided.75" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="9"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="9"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_shunt_res" upWardMappingList="//@provided.21 //@provided.25 //@provided.67 //@provided.68 //@provided.71 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="32"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="32"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_curnt_gain" upWardMappingList="//@provided.22 //@provided.25 //@provided.67 //@provided.68 //@provided.71 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="10"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="10"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/temp_config" upWardMappingList="//@provided.48 //@provided.48/@item.0 //@provided.48/@item.1 //@provided.51 //@provided.52 //@provided.67 //@provided.68 //@provided.69 //@provided.70 //@provided.71 //@provided.72 //@provided.73 //@provided.74 //@provided.75 //@provided.76 //@provided.77 //@provided.78" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm">
    <downWardmappedList xsi:type="ResourceModel:App" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#/"/>
    <requiredResource uriString="app/pwmsvm01/*" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/nvic_pwmperiod">
    <downWardmappedList xsi:type="ResourceModel:ResourceGroup" href="../../CPU/CPU_0.dd#//@provided.6"/>
    <requiredResource uriString="peripheral/cpu/0/nvic/interrupt/*" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/nvic_trap">
    <downWardmappedList xsi:type="ResourceModel:ResourceGroup" href="../../CPU/CPU_0.dd#//@provided.8"/>
    <requiredResource uriString="peripheral/cpu/0/nvic/interrupt/*" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="&#xD;&#xA;          function resourceCondition() {&#xD;&#xA;            var XMC4500 = Solver.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;            if (XMC4500 == 0) {&#xD;&#xA;              return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;          }" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/nvic_current">
    <requiredResource uriString="peripheral/cpu/0/nvic/interrupt/*" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp">
    <downWardmappedList xsi:type="ResourceModel:App" href="../../ADC002/1.0.28/adc002_0.app#/"/>
    <requiredResource uriString="app/adc002/*" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="&#xD;&#xA;          function resourceCondition() {&#xD;&#xA;            var Res0 = Solver.getResource(&quot;pmsmfocsl01_erwq2adccmcontrol/0&quot;);  &#xD;&#xA;            var cur0 = Solver.getIntValue(Res0);&#xD;&#xA;            var Res1 = Solver.getResource(&quot;pmsmfocsl01_erwq2adcvccontrol/0&quot;);  &#xD;&#xA;            var cur1 = Solver.getIntValue(Res1);&#xD;&#xA;            if ((cur0 == 1)||(cur1 == 1)) {&#xD;&#xA;              return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;          }&#xD;&#xA;" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2" upWardMappingList="//@provided.12/@item.0 //@provided.15/@item.0 //@provided.61/@item.0 //@provided.62/@item.0 //@provided.63/@item.0 //@provided.64/@item.0 //@provided.65/@item.0 //@provided.66/@item.0">
    <localValue xsi:type="ResourceModel:StringValue" value="DependentApp"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="DependentApp"/>
    <requiredResource uriString="app/adc002/*" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="&#xD;&#xA;          function resourceCondition() {&#xD;&#xA;            var Res0 = Solver.getResource(&quot;pmsmfocsl01_erwq3adccmcontrol/0&quot;);  &#xD;&#xA;            var cur = Solver.getIntValue(Res0);&#xD;&#xA;            if (cur == 1) {&#xD;&#xA;              return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;          } " URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3" upWardMappingList="//@provided.12/@item.0 //@provided.15/@item.0 //@provided.61/@item.0 //@provided.62/@item.0 //@provided.63/@item.0 //@provided.64/@item.0 //@provided.65/@item.0 //@provided.66/@item.0">
    <localValue xsi:type="ResourceModel:StringValue" value="DependentApp"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="DependentApp"/>
    <requiredResource uriString="app/adc002/*" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/nvic_pwmperiod/signal_in" isSystemDefined="true">
    <downWardmappedList xsi:type="ResourceModel:SignalDeclaration" href="../../CPU/CPU_0.dd#//@provided.7"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_irwpwmfreq" upWardMappingList="//@provided.6 //@provided.67 //@provided.68 //@provided.71 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="4e20"/>
    <downWardmappedList xsi:type="ResourceModel:IntegerParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.45"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="4e20"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_irselprescalar" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:IntegerParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.44"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwenable_pm_int" upWardMappingList="//@provided.43/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.58"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwout0passivelevel" upWardMappingList="//@provided.19 //@provided.19/@item.0 //@provided.19/@item.1" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.40"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwout1passivelevel" upWardMappingList="//@provided.20 //@provided.20/@item.0 //@provided.20/@item.1" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.41"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwout0trap/0" upWardMappingList="//@provided.10 //@provided.10/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.54/@item.0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwenablecrntmsr" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.70"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwenablecrntmsr/0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.70/@item.0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwenablecrntmsr/1" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.70/@item.1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwenablecrntmsr/2" upWardMappingList="//@provided.6" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.70/@item.2"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_irwdeadtime" upWardMappingList="//@provided.17 //@provided.18 //@provided.67 //@provided.68 //@provided.71 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1f4"/>
    <downWardmappedList xsi:type="ResourceModel:IntegerParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.49"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f4"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_irperiodreg" upWardMappingList="//@provided.67 //@provided.68 //@provided.71 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:IntegerParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.46"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="63f"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_irwselrisedeadtimereg" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_irwselfalldeadtimereg" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwschemeofsvm" upWardMappingList="//@provided.53 //@provided.53/@item.0 //@provided.53/@item.1 //@provided.54/@item.0 //@provided.55/@item.0 //@provided.55/@item.1 //@provided.56/@item.1 //@provided.61/@item.0 //@provided.64/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.66"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwactivevector" upWardMappingList="//@provided.55/@item.1 //@provided.56 //@provided.56/@item.0 //@provided.56/@item.1" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.64"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwtypeofsvm" upWardMappingList="//@provided.53/@item.0 //@provided.54 //@provided.54/@item.0 //@provided.54/@item.1 //@provided.55/@item.0 //@provided.61/@item.0 //@provided.64/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.65"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwsvmmodes" upWardMappingList="//@provided.53/@item.1 //@provided.54/@item.1 //@provided.55 //@provided.55/@item.0 //@provided.55/@item.1 //@provided.61/@item.0 //@provided.64/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.63"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_irwtoplevelapp" upWardMappingList="//@provided.6" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:IntegerParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.47"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_irwtmin" upWardMappingList="//@provided.17 //@provided.18" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="3fe32b020c49ba5e"/>
    <downWardmappedList xsi:type="ResourceModel:IntegerParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.52"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="3ff0cccccccccccd"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_irwdswitchdelay" upWardMappingList="//@provided.17 //@provided.18 //@provided.67 //@provided.68 //@provided.71 //@provided.72" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1f4"/>
    <downWardmappedList xsi:type="ResourceModel:IntegerParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.51"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f4"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwinverterpin/0" upWardMappingList="//@provided.59 //@provided.59/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.68/@item.0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwinverterpinlevel" upWardMappingList="//@provided.60 //@provided.60/@item.0 //@provided.60/@item.1" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.69"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwenabletrapint" upWardMappingList="//@provided.10/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.59"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwtriggercontrol" upWardMappingList="//@provided.6" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.71"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/svm/pwmsvm01_erwenable83upcompmatch" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../PWMSVM01/1.0.36/pwmsvm01_0.app#//@provided.60"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_irwfocapp" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:IntegerParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.8"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_irwchannelnum" upWardMappingList="//@provided.12/@item.0 //@provided.15/@item.0 //@provided.61/@item.0 //@provided.62/@item.0 //@provided.63/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:IntegerParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.11"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.26"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="2"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical0/ch10" upWardMappingList="//@provided.53/@item.1 //@provided.54/@item.0 //@provided.54/@item.1 //@provided.55/@item.0 //@provided.55/@item.1 //@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../ADC002/1.0.28/adc002_0.app#//@provided.26/@item.1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical1" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.27"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="2"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical1/ch20" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../ADC002/1.0.28/adc002_0.app#//@provided.27/@item.1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical2" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.28"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="2"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical2/ch30" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../ADC002/1.0.28/adc002_0.app#//@provided.28/@item.1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical3" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.29"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="2"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical3/ch40" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../ADC002/1.0.28/adc002_0.app#//@provided.29/@item.1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical4" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.30"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical4/ch51" upWardMappingList="//@provided.12/@item.0 //@provided.15/@item.0 //@provided.61/@item.0 //@provided.62/@item.0 //@provided.63/@item.0 //@provided.65/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../ADC002/1.0.28/adc002_0.app#//@provided.30/@item.2"/>
    <globalValue xsi:type="ResourceModel:Reserved" value="Reserved"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical5" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.31"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwchannellogical5/ch62" upWardMappingList="//@provided.12/@item.0 //@provided.15/@item.0 //@provided.61/@item.0 //@provided.62/@item.0 //@provided.63/@item.0 //@provided.65/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../ADC002/1.0.28/adc002_0.app#//@provided.31/@item.3"/>
    <globalValue xsi:type="ResourceModel:Reserved" value="Reserved"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwrefill0" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.50"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwrefill1" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.51"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwrefill2" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.52"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwrefill3" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.53"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwrefill4" upWardMappingList="//@provided.15/@item.0 //@provided.62/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.54"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwrefill5" upWardMappingList="//@provided.12/@item.0 //@provided.63/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.55"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwextrigger0" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.34"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwextrigger1" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.35"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwextrigger2" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.36"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwextrigger3" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.37"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwtrgmode" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumerationParameter" href="../../ADC002/1.0.28/adc002_0.app#//@provided.61"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="2"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwtrgmode/0" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../ADC002/1.0.28/adc002_0.app#//@provided.61/@item.0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwtrgmode/1" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../ADC002/1.0.28/adc002_0.app#//@provided.61/@item.1"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp/adc002_erwtrgmode/2" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:EnumItem" href="../../ADC002/1.0.28/adc002_0.app#//@provided.61/@item.2"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_irwfocapp" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_irwchannelnum" upWardMappingList="//@provided.64/@item.0 //@provided.65/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical0" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical0/ch10" upWardMappingList="//@provided.53/@item.1 //@provided.54/@item.0 //@provided.54/@item.1 //@provided.55/@item.0 //@provided.55/@item.1 //@provided.61/@item.0 //@provided.62/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical1" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical1/ch20" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical2" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical2/ch30" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical3" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical3/ch40" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical4" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical4/ch51" upWardMappingList="//@provided.15/@item.0 //@provided.64/@item.0 //@provided.65/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical5" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwchannellogical5/ch62" upWardMappingList="//@provided.64/@item.0" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwrefill0" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwrefill1" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwrefill2" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwrefill3" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwrefill4" upWardMappingList="//@provided.15/@item.0 //@provided.65/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwrefill5" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwextrigger0" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwextrigger1" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwextrigger2" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwextrigger3" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwtrgmode" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwtrgmode/0" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwtrgmode/1" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp2/adc002_erwtrgmode/2" upWardMappingList="//@provided.61/@item.0 //@provided.64/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_irwfocapp" upWardMappingList="//@provided.61/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_irwchannelnum" upWardMappingList="//@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical0" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical0/ch10" upWardMappingList="//@provided.53/@item.1 //@provided.54/@item.0 //@provided.54/@item.1 //@provided.55/@item.0 //@provided.55/@item.1 //@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical1" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical1/ch20" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical2" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical2/ch30" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical3" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical3/ch40" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical4" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical4/ch51" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical5" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwchannellogical5/ch62" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwrefill0" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwrefill1" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwrefill2" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwrefill3" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwrefill4" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwrefill5" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwextrigger0" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwextrigger1" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwextrigger2" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwextrigger3" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwtrgmode" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwtrgmode/0" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwtrgmode/1" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/queueapp3/adc002_erwtrgmode/2" upWardMappingList="//@provided.61/@item.0 //@provided.66/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/nvic_current/signal_in" isSystemDefined="true"/>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.12/app/pmsmfocsl01/0/nvic_trap/signal_in" isSystemDefined="true">
    <downWardmappedList xsi:type="ResourceModel:SignalDeclaration" href="../../CPU/CPU_0.dd#//@provided.9"/>
  </consumed>
  <propertyConstants name="uriprefix_Name" value="http://www.infineon.com/peripheral/vX.Y/XX_PeripheralName/0"/>
  <categoryDescription description="Middleware Apps" name="Middleware Apps">
    <subCategory description="Middleware apps for motor control" name="Motor Control"/>
  </categoryDescription>
  <manifestInfo version="1.0.12">
    <keywords>Sensorless Control</keywords>
    <keywords>Motor Control</keywords>
    <keywords>Motor</keywords>
    <keywords>Drive</keywords>
    <keywords>FOC</keywords>
    <keywords>DC Link current Measurement</keywords>
    <properties xsi:type="ResourceModel:AppProperties_1_0" initProvider="true"/>
  </manifestInfo>
  <datagenerate fileName="PMSMFOCSL01.h" fileType="HFILE" templateFileName="PMSMFOCSL01.hdt" templateEngine="NONE" fileAction="COPY"/>
  <datagenerate fileName="PMSMFOCSL01.c" templateFileName="PMSMFOCSL01.cdt" templateEngine="NONE" fileAction="COPY"/>
  <datagenerate fileName="PMSMFOCSL01_Conf.h" fileType="HFILE" templateFileName="PMSMFOCSL01_Confh.jet"/>
  <datagenerate fileName="PMSMFOCSL01_Conf.c" templateFileName="PMSMFOCSL01_Confc.jet"/>
  <datagenerate fileName="PMSMFOCSL01_Extern.h" fileType="HFILE" templateFileName="PMSMFOCSL01_Externh.jet"/>
  <connections sourceSignal="svm/pwmsvm01_ph1periodmatch_vs" targetSignal="app/pmsmfocsl01/0/pmsmfocsl01_nvic_pm_vs"/>
  <connections sourceSignal="svm/pwmsvm01_ph1trapevent_vs" targetSignal="app/pmsmfocsl01/0/pmsmfocsl01_nvic_trap_vs"/>
  <connections sourceSignal="svm/pwmsvm01_ph2periodmatch_vs" targetSignal="app/pmsmfocsl01/0/pmsmfocsl01_nvic_trap_vs"/>
  <connections sourceSignal="svm/pwmsvm01_ph4comparematch_vs" targetSignal="app/pmsmfocsl01/0/pmsmfocsl01_nvic_currentmeas_vs" constraintFunction="function resourceCondition() {&#xD;&#xA;          var XMC4500 = Solver.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;          if (XMC4500==0) {  &#xD;&#xA;            return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;            }"/>
  <connections sourceSignal="svm/pwmsvm01_ph4compare2match_vs" targetSignal="app/pmsmfocsl01/0/pmsmfocsl01_nvic_currentmeas_vs" constraintFunction="function resourceCondition() {&#xD;&#xA;          var XMC4500 = Solver.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;          if (XMC4500==0) {  &#xD;&#xA;            return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;            }"/>
  <connections sourceSignal="app/pmsmfocsl01/0/pmsmfocsl01_nvic_currentmeas_vs" targetSignal="queueapp/adc002_greqtr0sel_vs" constraintFunction="function resourceCondition() {&#xD;&#xA;          var Res0 = Solver.getResource(&quot;pmsmfocsl01_erwq1adccmcontrol/0&quot;);&#xD;&#xA;          var val  = Solver.getIntValue(Res0);&#xD;&#xA;          var XMC4500 = Solver.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;          if ((val==1) &amp;&amp; (XMC4500==0)) {  &#xD;&#xA;            return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;            }"/>
  <connections sourceSignal="app/pmsmfocsl01/0/pmsmfocsl01_nvic_currentmeas_vs" targetSignal="queueapp2/adc002_greqtr0sel_vs" constraintFunction="function resourceCondition() {&#xD;&#xA;          var Res0 = Solver.getResource(&quot;pmsmfocsl01_erwq2adccmcontrol/0&quot;);&#xD;&#xA;          var val  = Solver.getIntValue(Res0);&#xD;&#xA;          var XMC4500 = Solver.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;          if ((val==1) &amp;&amp; (XMC4500==0)) {  &#xD;&#xA;            return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;            }"/>
  <connections sourceSignal="app/pmsmfocsl01/0/pmsmfocsl01_nvic_currentmeas_vs" targetSignal="queueapp3/adc002_greqtr0sel_vs" constraintFunction="function resourceCondition() {&#xD;&#xA;          var Res0 = Solver.getResource(&quot;pmsmfocsl01_erwq3adccmcontrol/0&quot;);&#xD;&#xA;          var val  = Solver.getIntValue(Res0);&#xD;&#xA;          var XMC4500 = Solver.getSoftwareId().substring(0,1).compareTo(&quot;4&quot;);&#xD;&#xA;          if ((val==1) &amp;&amp; (XMC4500==0)) {  &#xD;&#xA;            return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;            }"/>
  <connections sourceSignal="svm/pwmsvm01_ph4comparematch_vs" targetSignal="queueapp/adc002_greqtr0sel_vs" constraintFunction="function resourceCondition() {&#xD;&#xA;          var Res0 = Solver.getResource(&quot;pmsmfocsl01_erwq1adccmcontrol/0&quot;);&#xD;&#xA;          var val  = Solver.getIntValue(Res0);&#xD;&#xA;          var XMC1302 = Solver.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;          if ((val==1) &amp;&amp; (XMC1302==0)) {  &#xD;&#xA;            return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;            }"/>
  <connections sourceSignal="svm/pwmsvm01_ph4compare2match_vs" targetSignal="queueapp/adc002_greqtr0sel_vs" constraintFunction="function resourceCondition() {&#xD;&#xA;          var Res0 = Solver.getResource(&quot;pmsmfocsl01_erwq1adccmcontrol/0&quot;);&#xD;&#xA;          var val  = Solver.getIntValue(Res0);&#xD;&#xA;          var XMC1302 = Solver.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;          if ((val==1) &amp;&amp; (XMC1302==0)) {  &#xD;&#xA;            return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;            }"/>
  <connections sourceSignal="svm/pwmsvm01_ph4comparematch_vs" targetSignal="queueapp2/adc002_greqtr0sel_vs" constraintFunction="function resourceCondition() {&#xD;&#xA;          var Res0 = Solver.getResource(&quot;pmsmfocsl01_erwq2adccmcontrol/0&quot;);&#xD;&#xA;          var val  = Solver.getIntValue(Res0);&#xD;&#xA;          var XMC1302 = Solver.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;          if ((val==1) &amp;&amp; (XMC1302==0)) {  &#xD;&#xA;            return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;            }"/>
  <connections sourceSignal="svm/pwmsvm01_ph4compare2match_vs" targetSignal="queueapp2/adc002_greqtr0sel_vs" constraintFunction="function resourceCondition() {&#xD;&#xA;          var Res0 = Solver.getResource(&quot;pmsmfocsl01_erwq2adccmcontrol/0&quot;);&#xD;&#xA;          var val  = Solver.getIntValue(Res0);&#xD;&#xA;          var XMC1302 = Solver.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#xD;&#xA;          if ((val==1) &amp;&amp; (XMC1302==0)) {  &#xD;&#xA;            return true; &#xD;&#xA;            } &#xD;&#xA;            return false;&#xD;&#xA;            }"/>
  <softwareIdList>45.0.2</softwareIdList>
  <softwareIdList>45.0.1</softwareIdList>
  <softwareIdList>45.0.3</softwareIdList>
  <softwareIdList>45.2.3</softwareIdList>
  <softwareIdList>45.4.3</softwareIdList>
  <softwareIdList>45.4.2</softwareIdList>
  <softwareIdList>45.0200.1</softwareIdList>
  <softwareIdList>45.0200.2</softwareIdList>
  <softwareIdList>45.0200.3</softwareIdList>
  <softwareIdList>45.0202.3</softwareIdList>
  <softwareIdList>45.0204.3</softwareIdList>
  <softwareIdList>45.0204.2</softwareIdList>
  <softwareIdList>45.0300.1</softwareIdList>
  <softwareIdList>45.0300.2</softwareIdList>
  <softwareIdList>45.0300.3</softwareIdList>
  <softwareIdList>45.0302.3</softwareIdList>
  <softwareIdList>45.0304.3</softwareIdList>
  <softwareIdList>45.0304.2</softwareIdList>
  <softwareIdList>44.0200.3</softwareIdList>
  <softwareIdList>44.0200.5</softwareIdList>
  <softwareIdList>44.0202.3</softwareIdList>
  <softwareIdList>44.0202.5</softwareIdList>
  <softwareIdList>44.0.3</softwareIdList>
  <softwareIdList>44.00.5</softwareIdList>
  <softwareIdList>44.02.3</softwareIdList>
  <softwareIdList>44.02.5</softwareIdList>
  <softwareIdList>42.00.5</softwareIdList>
  <softwareIdList>42.0.6</softwareIdList>
  <softwareIdList>42.04.5</softwareIdList>
  <softwareIdList>42.04.6</softwareIdList>
  <softwareIdList>42.0200.5</softwareIdList>
  <softwareIdList>42.0200.6</softwareIdList>
  <softwareIdList>42.0204.5</softwareIdList>
  <softwareIdList>42.0204.6</softwareIdList>
  <softwareIdList>42.0208.6</softwareIdList>
  <softwareIdList>13.0102.7</softwareIdList>
  <softwareIdList>13.0102.10</softwareIdList>
  <softwareIdList>13.0102.11</softwareIdList>
</ResourceModel:App>
